/**************************************************************************

	nPOP

	main.c

	Copyright (C) 1996-2002 by Tomoaki Nakashima. All rights reserved.
		http://www.nakka.com/
		nakka@nakka.com

	nPOP-Q
	(C) Copyright 1999-2002 By Qta Sakamoto. All right reserved.

**************************************************************************/

/**************************************************************************
	Include Files
**************************************************************************/

#include "General.h"

#ifdef _WIN32_WCE_PPC
//	#include <aygshell.h>
//	#pragma comment (lib, "aygshell.lib")
	#include <Sip.h>
#endif

#include "Options.h"
#ifdef _WIN32_WCE_EMULATION
	#ifndef _WIN32_WCE_PPC
		#pragma comment (lib, "winsockm.lib")
	#endif
#else
	#ifdef _WIN32_WCE
		#pragma comment (lib, "winsock.lib")
	#endif
#endif

TCHAR	MAIN_WND_CLASS[32] = TEXT("MailItMainWndClass");

/**************************************************************************
	Define
**************************************************************************/

#define WM_TRAY_NOTIFY			(WM_APP + 100)		//^XNgC
#define WM_FINDMAILBOX			(WM_APP + 101)
#define WM_RAS_START			(WM_APP + 400)

#define ID_MENU					(WM_APP + 102)		//Rg[ID
#define IDC_CB					2000
#define IDC_TB					2001
#define IDC_CB2					2010				//(nPOP-Q)

#define ID_MAILITEM_OPEN		(WM_APP + 300)		//[OpenpID

#define ID_RECV_TIMER			1					//^C}[ID
#define ID_SMTP_TIMER			2
#define ID_SMTP_ONE_TIMER		3
#define ID_CHECK_TIMER			4
#define ID_EXEC_TIMER			5
#define ID_AUTOCHECK_TIMER		6
#define ID_TIMEOUT_TIMER		7
#define ID_NEWMAIL_TIMER		8
#define ID_EXITSIZEMOVE			9
//^C}[ID  (nPOP-Q)
#define TIMER_SEP				44	//SplitBar
#define TIMER_VIEW				45	//EditView

#define RECVTIME				1					//^C}[C^[o
#define SMTPTIME				100
#define CHECKTIME				100
#define AUTOCHECKTIME			60000
#define TIMEOUTTIME				60000

#define TRAY_ID					100					//^XNgCID

#define ID_MENU_TREE			(WM_APP + 400)		//c[j[(nPOP-Q)
#define ID_MENU_ADDR			(WM_APP + 401)		//AhXj[(nPOP-Q)

#ifdef _WIN32_WCE
#define SEPWIDE					6	//Xsbgo[̕ (nPOP-Q)
#else
#define SEPWIDE					4	//Xsbgo[̕ (nPOP-Q)
#endif

/**************************************************************************
	Global Variables
**************************************************************************/

HINSTANCE hInst = NULL;						//Local copy of hInstance
TCHAR *AppDir = NULL;						//f[^ۑ̃pX
TCHAR *g_Pass = NULL;						//ꎞpX[h
int gPassSt;								//ꎞpX[hۑtO
static TCHAR *CmdLine = NULL;				//R}hC
HWND MainWnd;								//CEBhẼnh
HWND FocusWnd;								//tH[JXEBhẼnh
HFONT hListFont;							//ListView̃tHg
HFONT hEditFont;							//\AҏW̃tHg
static HICON TrayIcon_Main;					//^XNgCACR (ҋ@)
static HICON TrayIcon_Check;				//^XNgCACR (`FbN)
static HICON TrayIcon_Mail[10];				//^XNgCACR (V)
BOOL NewMail_Flag = FALSE;					//^XNgCACRpVtO
static HMENU hPOPUP;						//^XNgCACRp̃|bvAbvj[
static HANDLE hAccel, hViewAccel, hEditAccel, hFindAccel;	//ANZ[^̃nh
#ifdef _WIN32_WCE_PPC
HWND hMainToolBar;							//c[o[ (PocketPC)
#endif
#ifdef _WIN32_WCE_LAGENDA
static HWND hCSOBar;						//CSOo[ (l'agenda)
static RECT wnd_size;						//EBhETCY (l'agenda)
static int g_menu_height;					//j[̍ (l'agenda)
HMENU hMainMenu;							//EBhEj[̃nh (l'agenda)
#endif

BOOL first_start;							//NtO
BOOL PPCFlag = FALSE;						//PsPCtO
int MailMenuPos;							//j[ʒu
int LvSortFlag = 0;							//ListView̃\[gtO
BOOL EndThreadSortFlag = FALSE;				//ʐMI̎\[gtO(Xbhp)
#if defined(_WIN32_WCE_PPC) || defined(_WIN32_WCE_LAGENDA)
static BOOL SelMode = FALSE;				//I[h (PocketPC, l'agenda)
#endif
#ifndef _WIN32_WCE
static int confirm_flag;					//F؃tO
#endif

SOCKET g_soc = -1;							//\Pbg
BOOL gSockFlag = FALSE;						//ʐMtO
BOOL GetHostFlag = FALSE;					//zXgtO
int MailFlag = 0;							//MpR}htO (POP_, SMTP_)
int NewMailCnt = 0;							//V[
BOOL ShowMsgFlag = FALSE;					//VL̃bZ[W\
static BOOL ShowError = FALSE;				//G[bZ[W\
BOOL AutoCheckFlag = FALSE;					//`FbN
BOOL PopBeforeSmtpFlag = FALSE;				//POP before SMTP
BOOL KeyShowHeader;							//L[ɂꎞIȃwb_\tO
static BOOL AllCheck = FALSE;				//
static BOOL ExecFlag = FALSE;				//s
static BOOL ExecCheckFlag = FALSE;			//s`FbÑ`FbN
static int AutoCheckCnt = 0;				//`FbNJn܂ł̕JEg
static int SmtpWait = 0;					//POP before SMTP ŔF،̑҂ (~b)
static struct TPMAILITEM *wkSendMailItem;	//Mp[ACe

int SelBox;									//I𒆂̃[{bNX
static int RecvBox;							//M̃[{bNX
static int CheckBox;						//`FbÑ[{bNX

struct TPMAILBOX *MailBox = NULL;			//[{bNX
struct TPMAILBOX *AddressBox = NULL;		//AhX
int MailBoxCnt = 2;							//[{bNX

static WNDPROC ListViewWindowProcedure;		//TuNXpvV[W(ListView)

typedef BOOL (*PPROC)(HWND, SOCKET, char*, int, TCHAR*, struct TPMAILBOX*, BOOL);
static PPROC RecvProc;						//MvV[W

// (nPOP-Q)
HWND g_hListView = NULL;					//Xgr[
HWND g_hTreeView = NULL;					//c[
HWND g_hEditView = NULL;					//vr[
HWND g_hAdrList  = NULL;					//AhX
extern HWND hFindItem;						//EChE
int g_fEditView = 0;						//Tvr[
HFONT hSmallFont;							//tHg
extern void EditView_RestNo ();
extern void EditView_RestNo2 (HWND hWnd);

//OQ
extern char *RecvBuf;						//Mobt@
extern char *RemainderBuf;					//Mobt@

extern TCHAR *FindStr;						//

extern HWND hViewWnd;						//\EBhE
extern HWND MsgWnd;							//[bZ[W

//RAS
extern UINT WM_RASEVENT;
extern BOOL RasLoop;
extern struct TPRASINFO **RasInfo;
extern int RasInfoCnt;
extern HANDLE hEvent;

//ini
extern TCHAR *DataDir;

extern TCHAR *FontName;
extern int FontSize;
extern int FontCharset;

#ifndef _WIN32_WCE
extern RECT MainRect;
#endif
#ifdef _CENET
extern RECT MainRect;
#endif
extern int LvAutoSort;
extern int LvSortItem;
extern int LvThreadView;
extern TCHAR *LvFontName;
extern int LvFontSize;
extern int LvFontCharset;
extern int LvColSize[];
extern int SaveMsg;
extern int AutoSave;
extern int MoveAllMailBox;
#ifndef _WIN32_WCE
extern int ShowPass;
extern TCHAR *Password;
#endif

extern int ShowTrayIcon;
extern int StartHide;
extern int MinsizeHide;
extern int CloseHide;
extern int TrayIconToggle;
extern int SocLog;

extern int ListGetLine;
extern int ListDownload;
extern int ShowHeader;

extern int PopBeforeSmtpIsLoginOnly;
extern int PopBeforeSmtpWait;

extern int IPCache;

extern int ShowNewMailMessgae;
extern int ShowNoMailMessage;

extern int NewMailSound;
extern TCHAR *NewMailSoundFile;
extern int ExecEndSound;
extern TCHAR *ExecEndSoundFile;

extern int AutoCheck;
extern int AutoCheckTime;
extern int StartCheck;
extern int SocIgnoreError;
extern int SendIgnoreError;
extern int CheckAfterUpdate;
extern int CheckEndExec;
extern int CheckEndExecNoDelMsg;
extern int TimeoutInterval;

extern TCHAR *ViewFileSuffix;
extern TCHAR *EditFileSuffix;

extern int EnableLAN;

extern int RasCon;
extern int RasCheckEndDisCon;
extern int RasEndDisCon;


/**************************************************************************
	Local Function Prototypes
**************************************************************************/

static BOOL GetAppPath(HINSTANCE hinst);
#ifndef _WIN32_WCE
static BOOL ConfirmPass(HWND hWnd, TCHAR *ps);
#endif
static BOOL TrayMessage(HWND hWnd, DWORD dwMessage, UINT uID, HICON hIcon, TCHAR *pszTip);
static void SetTrayIcon(HWND hWnd, HICON hIcon, TCHAR *buf);
static void FreeAllMailBox(void);
static LRESULT CALLBACK SubClassListViewProc(HWND hWnd, UINT msg, WPARAM wParam,LPARAM lParam);
static void SetListViewSubClass(HWND hWnd);
static void DelListViewSubClass(HWND hWnd);
static LRESULT ListViewHeaderNotifyProc(HWND hWnd, LPARAM lParam);
#ifndef _WIN32_WCE
static LRESULT TbNotifyProc(HWND hWnd,LPARAM lParam);
#endif
static LRESULT NotifyProc(HWND hWnd, WPARAM wParam, LPARAM lParam);
static int CreateComboBox(HWND hWnd, int Top);
static BOOL InitWindow(HWND hWnd);
// (nPOP-Q)
static BOOL SetWindowSize(HWND hWnd, WPARAM wParam, LPARAM lParam, int fNotify);
//#if defined(_WIN32_WCE_PPC) || defined(_WIN32_WCE_LAGENDA)
//static BOOL SetWindowSize(HWND hWnd, WPARAM wParam, LPARAM lParam);
//#endif
//#ifndef _WIN32_WCE
//static BOOL SetWindowSize(HWND hWnd, WPARAM wParam, LPARAM lParam);
//#endif
static BOOL EndWindow(HWND hWnd);
static BOOL SendMail(HWND hWnd, struct TPMAILITEM *tpMailItem, int EndMailFlag);
static BOOL RecvMailList(HWND hWnd, int BoxIndex, BOOL SmtpFlag);
static BOOL MailMarkCheck(HWND hWnd, BOOL DelMsg, BOOL NoMsg);
static BOOL ExecItem(HWND hWnd, int BoxIndex);
static void OpenItem(HWND hWnd, BOOL MsgFlag, BOOL NoAppFlag);
static void ReMessageItem(HWND hWnd);
static void ItemToSaveBox(HWND hWnd);
static void ListDeleteItem(HWND hWnd);
static void SetDownloadMark(HWND hWnd, BOOL Flag);
static void SetDeleteMark(HWND hWnd);
static void UnMark(HWND hWnd);
static void SetMailStats(HWND hWnd, int St);
static void EndSocketFunc(HWND hWnd);
static BOOL CheckEndAutoExec(HWND hWnd, int SocBox, int cnt, BOOL AllFlag);
static void Init_NewMailFlag(void);
static void NewMail_Massage(HWND hWnd, int cnt);
static LRESULT CALLBACK WndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);
static BOOL InitApplication(HINSTANCE hInstance);
static HWND InitInstance(HINSTANCE hInstance, int CmdShow);


/******************************************************************************

	GetAppPath

	[UfBNg̍쐬

******************************************************************************/

#ifdef _WIN32_WCE_LAGENDA
int GetUserDiskName(HINSTANCE hInstance, LPTSTR lpDiskName, int nMaxCount);
#endif

static BOOL GetAppPath(HINSTANCE hinst)
{
#ifdef _WCE_OLD
#define SAVEPATH	TEXT("\\My Documents\\")
	AppDir = AllocCopy(SAVEPATH);
	if(AppDir == NULL){
		return FALSE;
	}
#elif defined(_WIN32_WCE_LAGENDA)
	TCHAR buf[BUF_SIZE];

	GetUserDiskName(hinst, buf, BUF_SIZE - 1);
	lstrcat(buf, TEXT("\\nPOP\\"));

	AppDir = AllocCopy(buf);
	if(AppDir == NULL){
		return FALSE;
	}
	CreateDirectory(AppDir, NULL);
#else
	TCHAR *p, *r;

	AppDir = (TCHAR *)LocalAlloc(LPTR, sizeof(TCHAR) * BUF_SIZE);
	if(AppDir == NULL){
		return FALSE;
	}

	//AvP[ṼpX擾
	GetModuleFileName(hinst, AppDir, BUF_SIZE - 1);
	for(p = r = AppDir; *p != TEXT('\0'); p++){
#ifndef UNICODE
		if(IsDBCSLeadByte((BYTE)*p) == TRUE){
			p++;
			continue;
		}
#endif	//UNICODE
		if(*p == TEXT('\\') || *p == TEXT('/')){
			r = p;
		}
	}
	*r = TEXT('\0');

	lstrcat(AppDir, TEXT("\\"));
#endif	//_WCE_OLD
	return TRUE;
}


/******************************************************************************

	CommandLine

	R}hC

******************************************************************************/

static BOOL CommandLine(HWND hWnd, TCHAR *buf)
{
	TCHAR name[BUF_SIZE];
	TCHAR *p, *r;
	int i;

	if(buf == NULL || *buf == TEXT('\0')){
		return FALSE;
	}
	for(p = buf; *p == TEXT(' '); p++);
	if(*p == TEXT('\0')) return FALSE;
	if(*p != TEXT('/')) return TRUE;
	p++;
	if(TStrCmpNI(p, TEXT("c:"), 2) == 0){
		p+=2;
		switch (*p) {
		case TEXT('N'):
		case TEXT('n'):
			PostMessage (hWnd, WM_COMMAND, ID_MENUITEM_RECV, 0);
			break;
		case TEXT('J'):
		case TEXT('j'):
			PostMessage (hWnd, WM_COMMAND, ID_MENUITEM_ALLCHECK, 0);
			break;
		}
		return FALSE;
	}
	if(TStrCmpNI(p, TEXT("a:"), 2) != 0){
		for(; *p != TEXT('\0') && *p != TEXT(' '); p++);
		for(; *p == TEXT(' '); p++);
		lstrcpy(buf, p);
		return ((*buf == TEXT('\0')) ? FALSE : TRUE);
	}
	p += 2;

	//[{bNX̎擾
	if(*p == TEXT('\"')){
		p++;
		for(r = p; *r != TEXT('\0') && *r != TEXT('\"'); r++);
	}else{
		for(r = p; *r != TEXT('\0') && *r != TEXT(' '); r++);
	}
	TStrCpyN(name, p, r - p + 1);
	i = GetNameToMailBox(name);
	SelectMailBox(hWnd, i);

	for(p = r; *p != TEXT('\0') && *p != TEXT(' '); p++);
	for(; *p == TEXT(' '); p++);
	lstrcpy(buf, p);
	return ((*buf == TEXT('\0')) ? FALSE : TRUE);
}


/******************************************************************************

	ConfirmPass

	pX[h̊mF

******************************************************************************/

#ifndef _WIN32_WCE
static BOOL ConfirmPass(HWND hWnd, TCHAR *ps)
{
	while(1){
		//NpX[h
		gPassSt = 0;
		if(DialogBoxParam(hInst, MAKEINTRESOURCE(IDD_DIALOG_INPUTPASS), NULL, InputPassProc,
			(LPARAM)STR_TITLE_SHOWPASSWORD) == FALSE){
			return FALSE;
		}
		if(g_Pass == NULL || lstrcmp(ps, g_Pass) != 0){
			ErrorMessage(NULL, STR_ERR_SOCK_BADPASSWORD);
			continue;
		}
		break;
	}
	confirm_flag = 2;
	return TRUE;
}
#endif


/******************************************************************************

	TrayMessage

	^XNgC̃ACR̐ݒ

******************************************************************************/

static BOOL TrayMessage(HWND hWnd, DWORD dwMessage, UINT uID, HICON hIcon, TCHAR *pszTip)
{
	NOTIFYICONDATA tnd;
	// (nPOP-Q)
	{
		OSVERSIONINFO ovi;
		memset (&ovi, 0, sizeof(ovi));
		ovi.dwOSVersionInfoSize = sizeof(ovi);
		GetVersionEx (&ovi);
		if (ovi.dwMajorVersion == 2 && ovi.dwMinorVersion == 12)
			return TRUE;
	}

	tnd.cbSize = sizeof(NOTIFYICONDATA);
	tnd.hWnd = hWnd;
	tnd.uID	= uID;
	tnd.uFlags = NIF_MESSAGE | NIF_ICON | NIF_TIP;
	tnd.uCallbackMessage = WM_TRAY_NOTIFY;
	tnd.hIcon = hIcon;
	lstrcpy(tnd.szTip, (pszTip == NULL) ? TEXT("") : pszTip);
	return Shell_NotifyIcon(dwMessage, &tnd);
}


/******************************************************************************

	SetTrayIcon

	^XNgCɃACRݒ肷

******************************************************************************/

static void SetTrayIcon(HWND hWnd, HICON hIcon, TCHAR *buf)
{
	if(ShowTrayIcon != 1 || hIcon == NULL){
		return;
	}
	if(TrayMessage(hWnd, NIM_MODIFY, TRAY_ID, hIcon, buf) == FALSE){
		//ύXłȂꍇ͒ǉs
		TrayMessage(hWnd, NIM_ADD, TRAY_ID, hIcon, buf);
	}
}


/******************************************************************************

	SwitchCursor

	J[\̏Ԃ̐؂ւ

******************************************************************************/

void SwitchCursor(const BOOL Flag)
{
	static HCURSOR hCursor = NULL;

	if(Flag == FALSE){
#ifdef _WIN32_WCE
		if(hCursor == NULL){
			SetCursor(hCursor);
		}
#endif
		hCursor = SetCursor(LoadCursor(NULL, IDC_WAIT));
	}else{
#ifdef _WIN32_WCE
		SetCursor(hCursor);
		hCursor = NULL;
#else
		SetCursor(LoadCursor(NULL, IDC_ARROW));
#endif
	}
}


/******************************************************************************

	_SetForegroundWindow

	EBhEANeBuɂ

******************************************************************************/

#ifndef _WIN32_WCE
BOOL _SetForegroundWindow(const HWND hWnd)
{
#ifndef SPI_GETFOREGROUNDLOCKTIMEOUT
#define SPI_GETFOREGROUNDLOCKTIMEOUT		  0x2000
#endif
#ifndef SPI_SETFOREGROUNDLOCKTIMEOUT
#define SPI_SETFOREGROUNDLOCKTIMEOUT		  0x2001
#endif
	int nTargetID, nForegroundID;
	UINT nTimeout;
	BOOL ret;

	nForegroundID = GetWindowThreadProcessId(GetForegroundWindow(), NULL);
	nTargetID = GetWindowThreadProcessId(hWnd, NULL);
	AttachThreadInput(nTargetID, nForegroundID, TRUE);

	SystemParametersInfo(SPI_GETFOREGROUNDLOCKTIMEOUT, 0, &nTimeout, 0);
	SystemParametersInfo(SPI_SETFOREGROUNDLOCKTIMEOUT, 0, (PVOID)0, 0);

	ret = SetForegroundWindow(hWnd);

	SystemParametersInfo(SPI_SETFOREGROUNDLOCKTIMEOUT, 0, (PVOID)nTimeout, 0);

	AttachThreadInput(nTargetID, nForegroundID, FALSE);
	return ret;
}
#endif


/******************************************************************************

	SetStatusTextT

	Xe[^X̕\ (TCHAR)

******************************************************************************/

void SetStatusTextT(HWND hWnd, TCHAR *buf, int Part)
{
#ifdef _WIN32_WCE_PPC
	SendDlgItemMessage(hWnd, IDC_STATUS, SB_SETTEXT, (WPARAM)Part | SBT_NOBORDERS, (LPARAM)buf);
#else
	SendDlgItemMessage(hWnd, IDC_STATUS, SB_SETTEXT, (WPARAM)Part, (LPARAM)buf);
#endif
}


/******************************************************************************

	SetSocStatusTextT

	Xe[^X̕\ (TCHAR)

******************************************************************************/

void SetSocStatusTextT(HWND hWnd, TCHAR *buf, int Part)
{
	TCHAR *SetBuf;

	if(PPCFlag == FALSE && RecvBox >= MAILBOX_USER && (MailBox + RecvBox)->Name != NULL){
		SetBuf = (TCHAR *)LocalAlloc(LMEM_FIXED, sizeof(TCHAR) * (lstrlen((MailBox + RecvBox)->Name) + lstrlen(buf) + 4));
		if(SetBuf == NULL){
			return;
		}
		TStrJoin(SetBuf, TEXT("["), (MailBox + RecvBox)->Name, TEXT("] "), buf, (TCHAR *)-1);
#ifdef _WIN32_WCE_PPC
		SendDlgItemMessage(hWnd, IDC_STATUS, SB_SETTEXT, (WPARAM)Part | SBT_NOBORDERS, (LPARAM)SetBuf);
#else
		SendDlgItemMessage(hWnd, IDC_STATUS, SB_SETTEXT, (WPARAM)Part, (LPARAM)SetBuf);
#endif
		if(SocLog == 1) SaveLog(AppDir, LOG_FILE, SetBuf);

		LocalFree(SetBuf);
	}else{
#ifdef _WIN32_WCE_PPC
		SendDlgItemMessage(hWnd, IDC_STATUS, SB_SETTEXT, (WPARAM)Part | SBT_NOBORDERS, (LPARAM)buf);
#else
		SendDlgItemMessage(hWnd, IDC_STATUS, SB_SETTEXT, (WPARAM)Part, (LPARAM)buf);
#endif
		if(SocLog == 1) SaveLog(AppDir, LOG_FILE, buf);
	}
}


/******************************************************************************

	SetStatusText

	Xe[^X̕\

******************************************************************************/

#ifdef UNICODE
void SetStatusText(HWND hWnd, char *buf)
{
	TCHAR *wbuf;

	wbuf = AllocCharToTchar(buf);
	if(wbuf == NULL){
		return;
	}
	SetSocStatusTextT(hWnd, wbuf, 1);
	LocalFree(wbuf);
}
#endif


/******************************************************************************

	SetItemCntStatusText

	ACe̕\

******************************************************************************/

void SetItemCntStatusText(HWND hWnd, struct TPMAILBOX *tpViewMailBox)
{
	struct TPMAILBOX *tpMailBox;
	struct TPMAILITEM *tpMailItem;
	TCHAR wbuf[BUF_SIZE];
	int ItemCnt;
	int NewCnt = 0;
	int NoReadCnt = 0;
	int i;

	tpMailBox = (MailBox + SelBox);
	if(tpMailBox == NULL || (tpViewMailBox != NULL && tpViewMailBox != tpMailBox)){
		return;
	}

	ItemCnt = ListView_GetItemCount(GetDlgItem(hWnd, IDC_LISTVIEW));

	if(SelBox == MAILBOX_SAVE || SelBox == MAILBOX_SEND){
		wsprintf(wbuf, STR_STATUS_VIEWINFO, ItemCnt);
		SetStatusTextT(hWnd, wbuf, 0);
		if(g_soc == -1){
			SetStatusTextT(hWnd, TEXT(""), 1);
		}
		return;
	}

	wsprintf(wbuf, STR_STATUS_MAILBOXINFO, ItemCnt, tpMailBox->MailCnt);
	SetStatusTextT(hWnd, wbuf, 0);

	if(g_soc != -1){
		return;
	}
	for(i = 0; i < tpMailBox->MailItemCnt; i++){
		tpMailItem = *(tpMailBox->tpMailItem + i);
		if(tpMailItem == NULL){
			continue;
		}
		if(tpMailItem->New == TRUE){
			NewCnt++;
		}
		if(tpMailItem->MailStatus == ICON_MAIL){
			NoReadCnt++;
		}
	}
	wsprintf(wbuf, STR_STATUS_MAILINFO, NewCnt, NoReadCnt);
	SetStatusTextT(hWnd, wbuf, 1);

	// ǐ (nPOP-Q)
	TreeView_NoReadCunt (SelBox, NoReadCnt);
	TreeView_SelMailBox (g_hTreeView, SelBox, TRUE);
}


/******************************************************************************

	SetStatusRecvLen

	MoCg̕\

******************************************************************************/

void SetStatusRecvLen(HWND hWnd, int len, TCHAR *msg)
{
	TCHAR wbuf[BUF_SIZE];

	wsprintf(wbuf, STR_STATUS_SOCKINFO, len, msg);
	SetStatusTextT(hWnd, wbuf, 1);
}


/******************************************************************************

	ErrorMessage

	G[bZ[W

******************************************************************************/

void ErrorMessage(HWND hWnd, TCHAR *buf)
{
	SwitchCursor(TRUE);
	ShowError = TRUE;
	MessageBox(hWnd, buf, STR_TITLE_ERROR, MB_OK | MB_ICONERROR);
	ShowError = FALSE;
}


/******************************************************************************

	SocketErrorMessage

	\Pbg̃G[bZ[W

******************************************************************************/

void SocketErrorMessage(HWND hWnd, TCHAR *buf, int BoxIndex)
{
	struct TPMAILBOX *tpMailBox;
	TCHAR *Title;
	TCHAR *p;

	tpMailBox = MailBox + BoxIndex;
	RecvBox = -1;
	SetMailMenu(hWnd);
	SwitchCursor(TRUE);

	if(hWnd != NULL){
		//Xe[^Xo[ɃG[̏\
		SetStatusTextT(hWnd, buf, 1);
		if(SocLog == 1) SaveLog(AppDir, LOG_FILE, buf);
	}
	if(SocIgnoreError == 1 && BoxIndex >= MAILBOX_USER){
		//MG[𖳎ݒ̏ꍇ
		return;
	}
	if(SendIgnoreError == 1 && BoxIndex == MAILBOX_SEND){
		//MG[𖳎ݒ̏ꍇ
		return;
	}
	if((BoxIndex == MAILBOX_SEND || BoxIndex >= MAILBOX_USER) &&
		tpMailBox->Name != NULL && *tpMailBox->Name != TEXT('\0')){
		//AJEgt̃^Cg̍쐬
		p = Title = (TCHAR *)LocalAlloc(LMEM_FIXED,
			sizeof(TCHAR) * (lstrlen(STR_TITLE_ERROR TEXT(" - ")) + lstrlen(tpMailBox->Name) + 1));
		if(Title == NULL){
			p = tpMailBox->Name;
			Title = NULL;
		}else{
			TStrJoin(Title, STR_TITLE_ERROR TEXT(" - "), tpMailBox->Name, (TCHAR *)-1);
		}
	}else{
		p = STR_TITLE_ERROR;
		Title = NULL;
	}
	ShowError = TRUE;
	//G[bZ[W̕\
	MessageBox(hWnd, buf, p, MB_OK | MB_ICONERROR);
	ShowError = FALSE;
	NULLCHECK_FREE(Title);
}


/******************************************************************************

	ErrorSocketEnd

	ʐMُ̈Ȉ

******************************************************************************/

void ErrorSocketEnd(HWND hWnd, int BoxIndex)
{
	//\Pbg
	if(g_soc != -1 && GetHostFlag == FALSE){
		SocketClose(hWnd, g_soc);
	}
	KillTimer(hWnd, ID_TIMEOUT_TIMER);
	g_soc = -1;
	if(BoxIndex == MAILBOX_SEND){
		SmtpError(hWnd);
	}

#ifndef WSAASYNC
	KillTimer(hWnd, ID_RECV_TIMER);
#endif
	if(AllCheck == FALSE){
		EndSocketFunc(hWnd);
		return;
	}

	if(SocIgnoreError == 1 && BoxIndex >= MAILBOX_USER){
		//MG[𖳎ݒ̏ꍇ
		return;
	}
	if(SendIgnoreError == 1 && BoxIndex == MAILBOX_SEND){
		//MG[𖳎ݒ̏ꍇ
		return;
	}
	//̒~
	KillTimer(hWnd, ID_SMTP_TIMER);
	KillTimer(hWnd, ID_SMTP_ONE_TIMER);
	KillTimer(hWnd, ID_CHECK_TIMER);
	KillTimer(hWnd, ID_EXEC_TIMER);
	KillTimer(hWnd, ID_RASWAIT_TIMER);
	gSockFlag = FALSE;
	AllCheck = FALSE;
	ExecFlag = FALSE;
	KeyShowHeader = FALSE;
	EndSocketFunc(hWnd);
}


/******************************************************************************

	ShowMenu

	}EẌʒuɃj[\

******************************************************************************/

int ShowMenu(HWND hWnd, HMENU hMenu, int mpos, int PosFlag, BOOL ReturnFlag)
{
#ifndef _WIN32_WCE_PPC
	HMENU hShowMenu;
#endif
	HWND hListView;
	RECT WndRect;
	RECT ItemRect;
	int i;
	int x = 0, y = 0;
	DWORD ret = 0;
#ifndef _WIN32_WCE
	POINT apos;
#endif

#ifndef _WIN32_WCE_PPC
	_SetForegroundWindow(hWnd);
#endif
	switch(PosFlag)
	{
	case 0:
		//}EXʒu̎擾
#ifdef _WIN32_WCE
		ret = GetMessagePos();
		x = LOWORD(ret);
		y = HIWORD(ret);
#else
		GetCursorPos((LPPOINT)&apos);
		x = apos.x;
		y = apos.y;
#endif
		break;

	case 1:
		//ACeʒu̎擾
		hListView = GetDlgItem(hWnd, IDC_LISTVIEW);
		i = ListView_GetNextItem(hListView, -1, LVNI_FOCUSED);
		GetWindowRect(hListView, &WndRect);
		if(i == -1){
			x = WndRect.left;
			y = WndRect.top;
		}else{
			ListView_EnsureVisible(hListView, i, TRUE);
			ListView_GetItemRect(hListView, i, &ItemRect, LVIR_ICON);
			if(ItemRect.left < 0){
				ItemRect.left = 0;
			}
			if(ItemRect.top < 0){
				ItemRect.top = 0;
			}
			if(ItemRect.top > (WndRect.bottom - WndRect.top)){
				ItemRect.top = WndRect.bottom - WndRect.top;
			}
			x = WndRect.left + ItemRect.left + (SICONSIZE / 2);
			y = WndRect.top + ItemRect.top + (SICONSIZE / 2);
		}
		break;

#ifdef _WIN32_WCE
#ifdef _WIN32_WCE_LAGENDA
	case 2:
		GetWindowRect(hWnd, &WndRect);
		TrackPopupMenu(GetSubMenu(hMenu, mpos), TPM_BOTTOMALIGN | TPM_RIGHTALIGN,
			0, wnd_size.bottom, 0, hWnd, NULL);
		PostMessage(hWnd, WM_NULL, 0, 0);
		return 0;
#else
	case 2:
		GetWindowRect(hWnd, &WndRect);
		TrackPopupMenu(GetSubMenu(hMenu, mpos), TPM_BOTTOMALIGN | TPM_RIGHTALIGN,
			WndRect.right, WndRect.bottom, 0, hWnd, NULL);
		PostMessage(hWnd, WM_NULL, 0, 0);
		return 0;
#endif
#endif

	case 3:	//c[ŃAJEgIĂƂ̃j[ (nPOP-Q)
		if (SelBox < MAILBOX_USER) {
			return 0;
		}
		//}EXʒu̎擾
#ifdef _WIN32_WCE
		ret = GetMessagePos();
		x = LOWORD(ret);
		y = HIWORD(ret);
#else
		GetCursorPos((LPPOINT)&apos);
		x = apos.x;
		y = apos.y;
#endif
	}

#ifdef _WIN32_WCE
#ifdef _WIN32_WCE_PPC
	_SetForegroundWindow(hWnd);
	ret = TrackPopupMenu(hMenu,
		TPM_TOPALIGN | TPM_LEFTALIGN | ((ReturnFlag == TRUE) ? TPM_RETURNCMD : 0),
		x, y, 0, hWnd, NULL);
#else
	hShowMenu = GetSubMenu(hMenu, mpos);
	ret = TrackPopupMenu(hShowMenu,
		TPM_TOPALIGN | TPM_LEFTALIGN | ((ReturnFlag == TRUE) ? TPM_RETURNCMD : 0),
		x, y, 0, hWnd, NULL);
#endif
#else
	hShowMenu = GetSubMenu(hMenu, mpos);
	ret = TrackPopupMenu(hShowMenu,
		TPM_TOPALIGN | TPM_RIGHTBUTTON | TPM_LEFTBUTTON | ((ReturnFlag == TRUE) ? TPM_RETURNCMD : 0),
		x, y, 0, hWnd, NULL);
#endif
	PostMessage(hWnd, WM_NULL, 0, 0);
	return ret;
}


/******************************************************************************

	SetMailMenu

	j[̊^񊈐̐؂ւ

******************************************************************************/

void SetMailMenu(HWND hWnd)
{
	HMENU hMenu;
	int SelFlag;
	int SocFlag;
	int RecvBoxFlag;
	int SaveBoxFlag;
	int SendBoxFlag;
	int MoveBoxFlag;

#ifdef _WIN32_WCE
#ifdef _WIN32_WCE_PPC
	hMenu = SHGetSubMenu(hMainToolBar, ID_MENUITEM_FILE);
#elif defined(_WIN32_WCE_LAGENDA)
	hMenu = GetSubMenu(hMainMenu, 0);
#else
	hMenu = CommandBar_GetMenu(GetDlgItem(hWnd, IDC_CB), 0);
#endif
#else
	hMenu = GetMenu(hWnd);
#endif
	if(hMenu == NULL){
		return;
	}

	SelFlag = (ListView_GetSelectedCount(GetDlgItem(hWnd, IDC_LISTVIEW)) <= 0) ? 0 : 1;
	SocFlag = (g_soc != -1 || gSockFlag == TRUE) ? 0 : 1;
	RecvBoxFlag = (SelBox == RecvBox) ? 0 : 1;
	SaveBoxFlag = (SelBox == MAILBOX_SAVE) ? 0 : 1;
	SendBoxFlag = (SelBox == MAILBOX_SEND) ? 0 : 1;
	MoveBoxFlag = (MailBoxCnt <= 3) ? 0 : 1;

	EnableMenuItem(hMenu, ID_MENUITEM_SETMAILBOX, !(RecvBoxFlag & SaveBoxFlag & SendBoxFlag));
	EnableMenuItem(hMenu, ID_MENUITEM_DELETEMAILBOX, !(RecvBoxFlag & SaveBoxFlag & SendBoxFlag));
	EnableMenuItem(hMenu, ID_MENUITEM_LISTINIT, !(SaveBoxFlag & SendBoxFlag));

	//(nPOP-Q)
	if (SelBox >= MAILBOX_USER) {
		CheckMenuItem (hMenu, ID_MENUITEM_CHCYCLIC, ((MailBox + SelBox)->CyclicFlag ? MF_UNCHECKED : MF_CHECKED));
		EnableMenuItem(hMenu, ID_MENUITEM_CHCYCLIC, 0);
	}
	else {
		CheckMenuItem (hMenu, ID_MENUITEM_CHCYCLIC, MF_UNCHECKED);
		EnableMenuItem(hMenu, ID_MENUITEM_CHCYCLIC, 1);
	}

	EnableMenuItem(hMenu, ID_MENUITEM_MOVEUPMAILBOX, !(SocFlag & SaveBoxFlag & SendBoxFlag & MoveBoxFlag));
	EnableMenuItem(hMenu, ID_MENUITEM_MOVEDOWNMAILBOX, !(SocFlag & SaveBoxFlag & SendBoxFlag & MoveBoxFlag));

	EnableMenuItem(hMenu, ID_MENUITEM_RAS_CONNECT,
		!(SocFlag & (MailBox + SelBox)->RasMode & !EnableLAN));
	EnableMenuItem(hMenu, ID_MENUITEM_RAS_DISCONNECT, EnableLAN);

#ifdef _WIN32_WCE_PPC
	hMenu = SHGetSubMenu(hMainToolBar, ID_MENUITEM_MAIL);
#elif defined(_WIN32_WCE_LAGENDA)
	hMenu = GetSubMenu(hMainMenu, 1);
#endif

	EnableMenuItem(hMenu, ID_MENUITEM_OPEN, !SelFlag);
	EnableMenuItem(hMenu, ID_MENUITEM_REMESSEGE, !SelFlag);

	EnableMenuItem(hMenu, ID_MENUITEM_RECV, !(SocFlag & SaveBoxFlag & SendBoxFlag));
	EnableMenuItem(hMenu, ID_MENUITEM_ALLCHECK, !SocFlag);
	EnableMenuItem(hMenu, ID_MENUITEM_EXEC, !(SocFlag & SaveBoxFlag));
	EnableMenuItem(hMenu, ID_MENUITEM_ALLEXEC, !SocFlag);
	EnableMenuItem(hMenu, ID_MENUITEM_STOP, SocFlag | !SaveBoxFlag);

#ifndef _WIN32_WCE
	SendDlgItemMessage(hWnd, IDC_TB, TB_ENABLEBUTTON, ID_MENUITEM_RECV,
		(LPARAM)MAKELONG(SocFlag & SaveBoxFlag & SendBoxFlag, 0));
	SendDlgItemMessage(hWnd, IDC_TB, TB_ENABLEBUTTON, ID_MENUITEM_ALLCHECK, (LPARAM)MAKELONG(SocFlag, 0));
	SendDlgItemMessage(hWnd, IDC_TB, TB_ENABLEBUTTON, ID_MENUITEM_EXEC,
		(LPARAM)MAKELONG(SocFlag & SaveBoxFlag, 0));
	SendDlgItemMessage(hWnd, IDC_TB, TB_ENABLEBUTTON, ID_MENUITEM_ALLEXEC, (LPARAM)MAKELONG(SocFlag, 0));
	SendDlgItemMessage(hWnd, IDC_TB, TB_ENABLEBUTTON, ID_MENUITEM_STOP, (LPARAM)MAKELONG(!SocFlag, 0));

#elif defined(_WIN32_WCE_LAGENDA)
	CSOBar_SetButtonState(hCSOBar, TRUE, ID_MENUITEM_RECV, 1,
		(SocFlag & SaveBoxFlag & SendBoxFlag) ? CSO_BUTTON_DISP : CSO_BUTTON_GRAYED);
	CSOBar_SetButtonState(hCSOBar, TRUE, ID_MENUITEM_ALLCHECK, 1,
		(SocFlag) ? CSO_BUTTON_DISP : CSO_BUTTON_GRAYED);
	CSOBar_SetButtonState(hCSOBar, TRUE, ID_MENUITEM_EXEC, 1,
		(SocFlag & SaveBoxFlag) ? CSO_BUTTON_DISP : CSO_BUTTON_GRAYED);
	CSOBar_SetButtonState(hCSOBar, TRUE, ID_MENUITEM_ALLEXEC, 1,
		(SocFlag) ? CSO_BUTTON_DISP : CSO_BUTTON_GRAYED);
	CSOBar_SetButtonState(hCSOBar, TRUE, ID_MENUITEM_STOP, 1,
		(!SocFlag) ? CSO_BUTTON_DISP : CSO_BUTTON_GRAYED);
#endif

	EnableMenuItem(hMenu, ID_MENUITEM_DOWNMARK, !(SelFlag & SaveBoxFlag));
	EnableMenuItem(hMenu, ID_MENUITEM_DELMARK, !(SelFlag & SaveBoxFlag & SendBoxFlag));
	EnableMenuItem(hMenu, ID_MENUITEM_UNMARK, !(SelFlag & SaveBoxFlag));

	EnableMenuItem(hMenu, ID_MENUITEM_READMAIL, !(SelFlag & SendBoxFlag));
	EnableMenuItem(hMenu, ID_MENUITEM_NOREADMAIL, !(SelFlag & SendBoxFlag));

	EnableMenuItem(hMenu, ID_MENUITE_SAVECOPY, !(SelFlag & SaveBoxFlag));
	EnableMenuItem(hMenu, ID_MENUITEM_DELETE, !SelFlag);

	// (nPOP-Q)
#ifndef _WIN32_WCE
	SendDlgItemMessage(hWnd,IDC_TB, TB_ENABLEBUTTON, ID_MENUITEM_REMESSEGE,	(LPARAM)MAKELONG(SelFlag & SendBoxFlag, 0));
	SendDlgItemMessage(hWnd,IDC_TB, TB_ENABLEBUTTON, ID_MENUITEM_DOWNMARK,	(LPARAM)MAKELONG((SelFlag & SaveBoxFlag), 0));
	SendDlgItemMessage(hWnd,IDC_TB, TB_ENABLEBUTTON, ID_MENUITEM_DELMARK,	(LPARAM)MAKELONG((SelFlag & SaveBoxFlag & SendBoxFlag), 0));
	SendDlgItemMessage(hWnd,IDC_TB, TB_ENABLEBUTTON, ID_MENUITEM_UNMARK,	(LPARAM)MAKELONG((SelFlag & SaveBoxFlag), 0));
	SendDlgItemMessage(hWnd,IDC_TB, TB_ENABLEBUTTON, ID_MENUITEM_READMAIL,	(LPARAM)MAKELONG((SelFlag & SendBoxFlag), 0));
	SendDlgItemMessage(hWnd,IDC_TB, TB_ENABLEBUTTON, ID_MENUITE_SAVECOPY,	(LPARAM)MAKELONG((SelFlag & SaveBoxFlag), 0));
#endif
}


/******************************************************************************

	FreeMailBoxs

	EBhȄI

******************************************************************************/

static void FreeAllMailBox(void)
{
	int i;

	//AhX̉
	FreeMailBox(AddressBox);
	NULLCHECK_FREE(AddressBox);

	//ׂẴ[{bNX̉
	for(i = 0; i < MailBoxCnt; i++){
		FreeMailBox((MailBox + i));
	}
	NULLCHECK_FREE(MailBox);
}


/******************************************************************************

	CloseViewWindow

	[\EBhEƃ[ҏWEBhE

******************************************************************************/

void CloseViewWindow(int Flag)
{
	HWND fWnd;
	//[\EBhE
	if(hViewWnd != NULL){
		SendMessage(hViewWnd, WM_ENDCLOSE, 0, 0);
	}
	//[ҏWEBhE
	while((fWnd = FindWindow(EDIT_WND_CLASS, NULL)) != NULL){
		SendMessage(fWnd, WM_ENDCLOSE, Flag, 0);
	}
}


/******************************************************************************

	SubClassListViewProc

	TuNXEBhEvV[W
	IMEԂłSpaceKeyLɂ邽

******************************************************************************/

static LRESULT CALLBACK SubClassListViewProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
#if defined(_WIN32_WCE_PPC) || defined(_WIN32_WCE_LAGENDA)
	LV_HITTESTINFO lvht;
	POINT apos;
#endif
	int i;

	switch(msg)
	{
#if defined(_WIN32_WCE_PPC) || defined(_WIN32_WCE_LAGENDA)
	case WM_LBUTTONDOWN:
		//}EX̉̃ACe擾
		apos.x = LOWORD(lParam);
		apos.y = HIWORD(lParam);

		lvht.pt = apos;
		lvht.flags = LVHT_ONITEMICON | LVHT_ONITEMLABEL | LVHT_ONITEMSTATEICON;
		lvht.iItem = 0;
		i = ListView_HitTest(hWnd, &lvht);

		if(SelMode == TRUE && GetKeyState(VK_CONTROL) >= 0 && GetKeyState(VK_SHIFT) >= 0){
			//I[h
			if(i != -1){
				ListView_SetItemState(hWnd, i,
					LVIS_FOCUSED | (ListView_GetItemState(hWnd, i, LVIS_SELECTED) ^ LVIS_SELECTED),
					LVIS_FOCUSED | LVIS_SELECTED);
			}
			return 0;
		}
		break;
#endif

	case WM_FINDMAILBOX:
		SwitchCursor(FALSE);
		i = NextNoReadMailBox(SelBox + 1, MailBoxCnt);
		if(i == -1){
			i = NextNoReadMailBox(MAILBOX_USER, SelBox);
		}
		if(i == -1){
			SwitchCursor(TRUE);
			return 0;
		}
		//[{bNX̑I
		SelectMailBox(GetParent(hWnd), i);
		SwitchCursor(TRUE);
		return 0;

	case WM_CHAR:
		if((TCHAR)wParam == TEXT(' ') && GetKeyState(VK_CONTROL) >= 0 && GetKeyState(VK_SHIFT) >= 0){
			if(ListView_GetItemCount(hWnd) == 0 && MoveAllMailBox == 1){
				SendMessage(hWnd, WM_FINDMAILBOX, 0, 0);
				return 0;
			}else if(ListView_GetItemState(hWnd, ListView_GetNextItem(hWnd, -1, LVNI_FOCUSED), LVIS_SELECTED) == LVIS_SELECTED){
				SendMessage(GetParent(hWnd), WM_COMMAND, ID_MAILITEM_OPEN, 0);
				return 0;
			}
		}
		break;

#ifndef _WCE_OLD
	case WM_IME_CHAR:
		//2oCg̃Xy[X
#ifdef UNICODE
		if(wParam == 0x3000 &&
#else
		if(wParam == 0x8140 &&
#endif
			GetKeyState(VK_CONTROL) >= 0 && GetKeyState(VK_SHIFT) >= 0){
			if(ListView_GetItemCount(hWnd) == 0 && MoveAllMailBox == 1){
				SendMessage(hWnd, WM_FINDMAILBOX, 0, 0);
				return 0;
			}else if(ListView_GetItemState(hWnd, ListView_GetNextItem(hWnd, -1, LVNI_FOCUSED), LVIS_SELECTED) == LVIS_SELECTED){
				SendMessage(GetParent(hWnd), WM_COMMAND, ID_MAILITEM_OPEN, 0);
				return 0;
			}
		}
		break;
#endif
	}
	return CallWindowProc(ListViewWindowProcedure, hWnd, msg, wParam, lParam);
}


/******************************************************************************

	SetListViewSubClass

	EBhẼTuNX

******************************************************************************/

static void SetListViewSubClass(HWND hWnd)
{
	ListViewWindowProcedure = (WNDPROC)SetWindowLong(hWnd, GWL_WNDPROC, (long)SubClassListViewProc);
}


/******************************************************************************

	DelListViewSubClass

	EBhENXŴ̂ɖ߂

******************************************************************************/

static void DelListViewSubClass(HWND hWnd)
{
	SetWindowLong(hWnd, GWL_WNDPROC, (long)ListViewWindowProcedure);
	ListViewWindowProcedure = NULL;
}


/******************************************************************************

	ListViewHeaderNotifyProc

	Xgr[wb_bZ[W

******************************************************************************/

static LRESULT ListViewHeaderNotifyProc(HWND hWnd, LPARAM lParam)
{
	HD_NOTIFY *phd = (HD_NOTIFY *)lParam;
	HWND hListView;

	switch(phd->hdr.code)
	{
	case HDN_ITEMCLICK:
		LvThreadView = 0;
#ifdef _WIN32_WCE
#ifdef _WIN32_WCE_PPC
		CheckMenuItem(SHGetSubMenu(hMainToolBar, ID_MENUITEM_MAIL), ID_MENUITEM_THREADVIEW, MF_UNCHECKED);
#elif defined(_WIN32_WCE_LAGENDA)
		CheckMenuItem(GetSubMenu(hMainMenu, 1), ID_MENUITEM_THREADVIEW, MF_UNCHECKED);
#else
		CheckMenuItem(CommandBar_GetMenu(GetDlgItem(hWnd, IDC_CB), 0), ID_MENUITEM_THREADVIEW, MF_UNCHECKED);
#endif
#else
		CheckMenuItem(GetMenu(hWnd), ID_MENUITEM_THREADVIEW, MF_UNCHECKED);
#endif
		//\[g̐ݒ
		LvSortFlag = (ABS(LvSortFlag) == (phd->iItem + 1)) ? (LvSortFlag * -1) : (phd->iItem + 1);
		//\[g
		hListView = GetDlgItem(hWnd, IDC_LISTVIEW);
		SwitchCursor(FALSE);
		ListView_SortItems(hListView, CompareFunc, LvSortFlag);
		SwitchCursor(TRUE);

		ListView_EnsureVisible(hListView,
			ListView_GetNextItem(hListView, -1, LVNI_FOCUSED), TRUE);

		if(SelBox == MAILBOX_SAVE || LvAutoSort == 2){
			LvSortItem = LvSortFlag;
		}
		break;
	}
	return FALSE;
}


/******************************************************************************

	TbNotifyProc

	c[o[̒ʒmbZ[W (Win32)

******************************************************************************/

#ifndef _WIN32_WCE
static LRESULT TbNotifyProc(HWND hWnd, LPARAM lParam)
{
	TOOLTIPTEXT *pTT;

	pTT = (TOOLTIPTEXT*)lParam;
	pTT->hinst = hInst;
	pTT->lpszText = MAKEINTRESOURCE(pTT->hdr.idFrom);
	return 0;
}
#endif


/******************************************************************************

	NotifyProc

	Rg[̒ʒmbZ[W

******************************************************************************/

static LRESULT NotifyProc(HWND hWnd, WPARAM wParam, LPARAM lParam)
{
	NMHDR *CForm = (NMHDR *)lParam;

	// c[r[WM_NOTIFYCxg (nPOP-Q)
	if(CForm->hwndFrom == GetDlgItem(hWnd, IDC_TREEVIEW)){
		return TreeView_NotifyProc(hWnd, lParam);
	}
	// AhXWM_NOTIFYCxg (nPOP-Q)
	if(CForm->hwndFrom == GetDlgItem(hWnd, IDC_ADRLIST)){
		return AdrList_NotifyProc(hWnd, lParam);
	}

	if(CForm->hwndFrom == GetDlgItem(hWnd, IDC_LISTVIEW)){
#ifdef _WIN32_WCE_PPC
		if(CForm->code == GN_CONTEXTMENU){
			//|bvAbvj[\
			SendMessage(hWnd, WM_COMMAND, ID_MENU, 0);
			return TRUE;
		}
#endif
		return ListView_NotifyProc(hWnd, lParam);
	}
	if(CForm->hwndFrom == GetWindow(GetDlgItem(hWnd, IDC_LISTVIEW), GW_CHILD)){
		return ListViewHeaderNotifyProc(hWnd, lParam);
	}
#ifndef _WIN32_WCE
	if(CForm->code == TTN_NEEDTEXT){
		return TbNotifyProc(hWnd, lParam);
	}
#endif
	return FALSE;
}


/******************************************************************************

	CreateComboBox

	R{{bNX̍쐬

******************************************************************************/

static int CreateComboBox(HWND hWnd, int Top)
{
	HWND hCombo;
	RECT rcClient, comboRect;
	int i;

	GetClientRect(hWnd, &rcClient);

	hCombo = CreateWindow(TEXT("COMBOBOX"), TEXT(""),
		WS_VISIBLE | WS_CHILD | WS_TABSTOP | WS_VSCROLL | CBS_DROPDOWNLIST,
		0, Top, rcClient.right, (rcClient.bottom < 200) ? 200 : rcClient.bottom,
		hWnd, (HMENU)IDC_COMBO, hInst, NULL);
	if(hCombo == NULL){
		return -1;
	}

#ifndef _WIN32_WCE
	SendDlgItemMessage(hWnd, IDC_COMBO, WM_SETFONT,
		(WPARAM)((hListFont != NULL) ? hListFont : GetStockObject(DEFAULT_GUI_FONT)),
		MAKELPARAM(TRUE,0));
#endif
	SendDlgItemMessage(hWnd, IDC_COMBO, CB_SETEXTENDEDUI, TRUE, 0);

	for(i = 0; i < MailBoxCnt; i++){
		SendDlgItemMessage(hWnd, IDC_COMBO, CB_ADDSTRING, 0,
			(LPARAM)(((MailBox + i)->Name == NULL || *(MailBox + i)->Name == TEXT('\0'))
			? STR_MAILBOX_NONAME : (MailBox + i)->Name));
	}
	GetWindowRect(GetDlgItem(hWnd, IDC_COMBO), &comboRect);
	return (comboRect.bottom - comboRect.top);
}


/******************************************************************************

	MenuBar_GetHeight (nPOP-Q)

	j[o[̍(CÊƂCYMENUƍႤ)

******************************************************************************/
int MenuBar_GetHeight (HWND hWnd)
{
#ifdef _WIN32_WCE
	return CommandBar_Height (GetDlgItem(hWnd, IDC_CB));
#else
	return GetSystemMetrics(SM_CYMENU);
#endif
}


/******************************************************************************

	CreateAddToolBar (nPOP-Q)

	c[o[ǉ

******************************************************************************/

#ifdef _WIN32_WCE_PPC
void CreateAddToolBar (HWND hWnd)
{
	TBBUTTON tbButton[] = {
		{5,	ID_MENUITEM_NEWMAIL,		TBSTATE_ENABLED,	TBSTYLE_BUTTON,	0, 0, 0, -1},
		{0,	0,							TBSTATE_ENABLED,	TBSTYLE_SEP,	0, 0, 0, -1},
		{6,	ID_MENUITEM_REMESSEGE,		TBSTATE_ENABLED,	TBSTYLE_BUTTON,	0, 0, 0, -1},
		{0,	0,							TBSTATE_ENABLED,	TBSTYLE_SEP,	0, 0, 0, -1},
		{7,	ID_MENUITEM_DOWNMARK,		TBSTATE_ENABLED,	TBSTYLE_BUTTON,	0, 0, 0, -1},
		{8,	ID_MENUITEM_DELMARK,		TBSTATE_ENABLED,	TBSTYLE_BUTTON,	0, 0, 0, -1},
		{9,	ID_MENUITEM_UNMARK,			TBSTATE_ENABLED,	TBSTYLE_BUTTON,	0, 0, 0, -1},
		{10,ID_MENUITEM_ALLSELECT,		TBSTATE_ENABLED,	TBSTYLE_BUTTON,	0, 0, 0, -1},
		{0,	0,							TBSTATE_ENABLED,	TBSTYLE_SEP,	0, 0, 0, -1},
		{11,ID_MENUITEM_READMAIL,		TBSTATE_ENABLED,	TBSTYLE_BUTTON,	0, 0, 0, -1},
		{12,ID_MENUITE_SAVECOPY,		TBSTATE_ENABLED,	TBSTYLE_BUTTON,	0, 0, 0, -1},
	};

	static TCHAR *szTips[] = {
		STR_CMDBAR_NEWMAIL,
		STR_CMDBAR_REMESSEGE,
		STR_CMDBAR_DOWNMARK,
		STR_CMDBAR_DELMARK,
		STR_CMDBAR_UNMARK,
		STR_CMDBAR_ALLSELECT,
		STR_CMDBAR_READMAIL,
		STR_CMDBAR_SAVECOPY,
	};

	DWORD dwStyle;
	int tBtnNum = sizeof(tbButton) / sizeof(TBBUTTON);
	HWND hToolBar = CommandBar_Create (hInst, hWnd, IDC_CB2);

	CommandBar_AddToolTips (hToolBar, 8, szTips);
	CommandBar_AddBitmap (hToolBar, hInst, IDB_TOOLBAR_QEX, 13, SICONSIZE, SICONSIZE);

	CommandBar_AddButtons (hToolBar, tBtnNum, tbButton);

	dwStyle = GetWindowLong (hToolBar, GWL_STYLE);
	dwStyle &=  ~CCS_TOP;
	dwStyle |= CCS_BOTTOM | WS_BORDER;// | CCS_NOPARENTALIGN;
	SetWindowLong (hToolBar, GWL_STYLE, dwStyle);

	ShowWindow (hToolBar,SW_SHOW);
}
#endif


/******************************************************************************

	InitWindow

	EBhȄ

******************************************************************************/

static BOOL InitWindow(HWND hWnd)
{
	HWND hStatusBar;
#ifndef _WIN32_WCE_PPC
#ifndef _WIN32_WCE_LAGENDA
	HWND hToolBar;
#endif	//_WIN32_WCE_LAGENDA
#endif	//_WIN32_WCE_PPC
	RECT rcClient, StatusRect;
	int Height = 0;
	int i, j;
	int Width[2];
#ifdef _WIN32_WCE
#ifdef _WIN32_WCE_LAGENDA
	CSOBAR_BASEINFO BaseInfo = {
		(-1),										// x
		(-1),										// y
		(-1),										// width
		(-1),										// height
		1,											// line
		CSOBAR_DEFAULT_BACKCOLOR,					// backColor
		CSOBAR_DEFAULT_CODECOLOR,					// titleColor
		NULL,										// titleText
		0,											// titleBmpResId
		NULL,										// titleBmpResIns
	};
	CSOBAR_BUTTONINFO ButtonInfo[] = {
		1,						CSOBAR_BUTTON_SUBMENU_DOWN,	CSO_BUTTON_DISP, (-1),					NULL, TEXT("̧"),	NULL, CSOBAR_CODEPOS_CENTER, 1, (-1), (-1), (-1), (-1), 0, CLR_INVALID, CLR_INVALID, CLR_INVALID,			FALSE, FALSE,
		2,						CSOBAR_BUTTON_SUBMENU_DOWN,	CSO_BUTTON_DISP, (-1),					NULL, TEXT("Ұ"),	NULL, CSOBAR_CODEPOS_CENTER, 1, (-1), (-1), (-1), (-1), 0, CLR_INVALID, CLR_INVALID, CLR_INVALID,			FALSE, FALSE,
		ID_MENUITEM_RECV,		CSOBAR_BUTTON_NORM,			CSO_BUTTON_DISP, IDB_BITMAP_RECV,		NULL, NULL,			NULL, CSOBAR_CODEPOS_CENTER, 1, (-1), (-1), (-1), (-1), 0, CLR_INVALID, CLR_INVALID, RGB(0xC0, 0xC0, 0xC0),	FALSE, FALSE,
		ID_MENUITEM_ALLCHECK,	CSOBAR_BUTTON_NORM,			CSO_BUTTON_DISP, IDB_BITMAP_ALLRECV,	NULL, NULL,			NULL, CSOBAR_CODEPOS_CENTER, 1, (-1), (-1), (-1), (-1), 0, CLR_INVALID, CLR_INVALID, RGB(0xC0, 0xC0, 0xC0),	FALSE, FALSE,
		ID_MENUITEM_EXEC,		CSOBAR_BUTTON_NORM,			CSO_BUTTON_DISP, IDB_BITMAP_EXEC,		NULL, NULL,			NULL, CSOBAR_CODEPOS_CENTER, 1, (-1), (-1), (-1), (-1), 0, CLR_INVALID, CLR_INVALID, RGB(0xC0, 0xC0, 0xC0),	FALSE, FALSE,
		ID_MENUITEM_ALLEXEC,	CSOBAR_BUTTON_NORM,			CSO_BUTTON_DISP, IDB_BITMAP_ALLEXEC,	NULL, NULL,			NULL, CSOBAR_CODEPOS_CENTER, 1, (-1), (-1), (-1), (-1), 0, CLR_INVALID, CLR_INVALID, RGB(0xC0, 0xC0, 0xC0),	FALSE, FALSE,
		ID_MENUITEM_STOP,		CSOBAR_BUTTON_NORM,			CSO_BUTTON_DISP, IDB_BITMAP_STOP,		NULL, NULL,			NULL, CSOBAR_CODEPOS_CENTER, 1, (-1), (-1), (-1), (-1), 0, CLR_INVALID, CLR_INVALID, RGB(0xC0, 0xC0, 0xC0),	FALSE, FALSE,
	};
	DWORD style;

#else	//_WIN32_WCE_LAGENDA
	TBBUTTON tbButton[] = {
//#ifndef _WIN32_WCE_PPC
		{0,	0,							TBSTATE_ENABLED,	TBSTYLE_SEP,	0, 0, 0, -1},
//#endif	//_WIN32_WCE_PPC
		{0,	ID_MENUITEM_RECV,			TBSTATE_ENABLED,	TBSTYLE_BUTTON,	0, 0, 0, -1},
		{1,	ID_MENUITEM_ALLCHECK,		TBSTATE_ENABLED,	TBSTYLE_BUTTON,	0, 0, 0, -1},
		{2,	ID_MENUITEM_EXEC,			TBSTATE_ENABLED,	TBSTYLE_BUTTON,	0, 0, 0, -1},
		{3,	ID_MENUITEM_ALLEXEC,		TBSTATE_ENABLED,	TBSTYLE_BUTTON,	0, 0, 0, -1},
		{4,	ID_MENUITEM_STOP,			TBSTATE_ENABLED,	TBSTYLE_BUTTON,	0, 0, 0, -1},
#ifndef _WIN32_WCE_PPC
		{0,	0,							TBSTATE_ENABLED,	TBSTYLE_SEP,	0, 0, 0, -1},
		{5,	ID_MENUITEM_NEWMAIL,		TBSTATE_ENABLED,	TBSTYLE_BUTTON,	0, 0, 0, -1},
//		{0,	0,							TBSTATE_ENABLED,	TBSTYLE_SEP,	0, 0, 0, -1},
//		{6,	ID_MENUITEM_RAS_CONNECT,	TBSTATE_ENABLED,	TBSTYLE_BUTTON,	0, 0, 0, -1},
//		{7,	ID_MENUITEM_RAS_DISCONNECT,	TBSTATE_ENABLED,	TBSTYLE_BUTTON,	0, 0, 0, -1}
		// (nPOP-Q)
		{6,	ID_MENUITEM_REMESSEGE,		TBSTATE_ENABLED,	TBSTYLE_BUTTON,	0, 0, 0, -1},
		{0,	0,							TBSTATE_ENABLED,	TBSTYLE_SEP,	0, 0, 0, -1},
		{7,	ID_MENUITEM_DOWNMARK,		TBSTATE_ENABLED,	TBSTYLE_BUTTON,	0, 0, 0, -1},
		{8,	ID_MENUITEM_DELMARK,		TBSTATE_ENABLED,	TBSTYLE_BUTTON,	0, 0, 0, -1},
		{9,	ID_MENUITEM_UNMARK,			TBSTATE_ENABLED,	TBSTYLE_BUTTON,	0, 0, 0, -1},
		{10,ID_MENUITEM_ALLSELECT,		TBSTATE_ENABLED,	TBSTYLE_BUTTON,	0, 0, 0, -1},
		{0,	0,							TBSTATE_ENABLED,	TBSTYLE_SEP,	0, 0, 0, -1},
		{11,ID_MENUITEM_READMAIL,		TBSTATE_ENABLED,	TBSTYLE_BUTTON,	0, 0, 0, -1},
		{12,ID_MENUITE_SAVECOPY,		TBSTATE_ENABLED,	TBSTYLE_BUTTON,	0, 0, 0, -1},
#endif
	};
	static TCHAR *szTips[] = {
#ifdef _WIN32_WCE_PPC
		NULL, //menu skipping
#endif	//_WIN32_WCE_PPC
		NULL, //menu skipping
		STR_CMDBAR_RECV,
		STR_CMDBAR_ALLCHECK,
		STR_CMDBAR_EXEC,
		STR_CMDBAR_ALLEXEC,
		STR_CMDBAR_STOP,
		STR_CMDBAR_NEWMAIL,
//		STR_CMDBAR_RAS_CONNECT,
//		STR_CMDBAR_RAS_DISCONNECT
		// (nPOP-Q)
		STR_CMDBAR_REMESSEGE,
		STR_CMDBAR_DOWNMARK,
		STR_CMDBAR_DELMARK,
		STR_CMDBAR_UNMARK,
		STR_CMDBAR_ALLSELECT,
		STR_CMDBAR_READMAIL,
		STR_CMDBAR_SAVECOPY,
	};
#ifdef _WIN32_WCE_PPC
	SHMENUBARINFO mbi;
#endif	//_WIN32_WCE_PPC
#endif	//_WIN32_WCE_LAGENDA
#else	//_WIN32_WCE
	TBBUTTON tbButton[] = {
		{0,	ID_MENUITEM_RECV,			TBSTATE_ENABLED,	TBSTYLE_BUTTON,	0, 0, 0, -1},
		{1,	ID_MENUITEM_ALLCHECK,		TBSTATE_ENABLED,	TBSTYLE_BUTTON,	0, 0, 0, -1},
		{2,	ID_MENUITEM_EXEC,			TBSTATE_ENABLED,	TBSTYLE_BUTTON,	0, 0, 0, -1},
		{3,	ID_MENUITEM_ALLEXEC,		TBSTATE_ENABLED,	TBSTYLE_BUTTON,	0, 0, 0, -1},
		{4,	ID_MENUITEM_STOP,			TBSTATE_ENABLED,	TBSTYLE_BUTTON,	0, 0, 0, -1},
		{0,	0,							TBSTATE_ENABLED,	TBSTYLE_SEP,	0, 0, 0, -1},
		{5,	ID_MENUITEM_NEWMAIL,		TBSTATE_ENABLED,	TBSTYLE_BUTTON,	0, 0, 0, -1},
		// (nPOP-Q)
		{6,	ID_MENUITEM_REMESSEGE,		TBSTATE_ENABLED,	TBSTYLE_BUTTON,	0, 0, 0, -1},
		{0,	0,							TBSTATE_ENABLED,	TBSTYLE_SEP,	0, 0, 0, -1},
		{7,	ID_MENUITEM_DOWNMARK,		TBSTATE_ENABLED,	TBSTYLE_BUTTON,	0, 0, 0, -1},
		{8,	ID_MENUITEM_DELMARK,		TBSTATE_ENABLED,	TBSTYLE_BUTTON,	0, 0, 0, -1},
		{9,	ID_MENUITEM_UNMARK,			TBSTATE_ENABLED,	TBSTYLE_BUTTON,	0, 0, 0, -1},
		{10,ID_MENUITEM_ALLSELECT,		TBSTATE_ENABLED,	TBSTYLE_BUTTON,	0, 0, 0, -1},
		{0,	0,							TBSTATE_ENABLED,	TBSTYLE_SEP,	0, 0, 0, -1},
		{11,ID_MENUITEM_READMAIL,		TBSTATE_ENABLED,	TBSTYLE_BUTTON,	0, 0, 0, -1},
		{12,ID_MENUITE_SAVECOPY,		TBSTATE_ENABLED,	TBSTYLE_BUTTON,	0, 0, 0, -1},
		{0,	0,							TBSTATE_ENABLED,	TBSTYLE_SEP,	0, 0, 0, -1}
	};
	RECT ToolbarRect;
#endif	//_WIN32_WCE

	int tBtnNum = 6;//sizeof(tbButton) / sizeof(TBBUTTON) - 5; (nPOP-Q)

#ifdef _WIN32_WCE
#ifdef _WIN32_WCE_PPC
	//PocketPC
	memset (&mbi, 0, sizeof (SHMENUBARINFO));
	mbi.cbSize     = sizeof (SHMENUBARINFO);
	mbi.hwndParent = hWnd;
	mbi.nToolBarId = IDM_MAIN_WINDOW;
	mbi.hInstRes   = hInst;
	mbi.nBmpId     = 0;
	mbi.cBmpImages = 0;
	SHCreateMenuBar(&mbi);

	// (nPOP-Q)
	hMainToolBar = mbi.hwndMB;
    CommandBar_AddToolTips(hMainToolBar, 13/*11*/, szTips);
	CommandBar_AddBitmap(hMainToolBar, hInst, IDB_TOOLBAR_QEX, 13, 16, 16);
	CommandBar_AddButtons(hMainToolBar, tBtnNum, tbButton);

	Height = 0;
	i = 0;
	CheckMenuItem(SHGetSubMenu(hMainToolBar, ID_MENUITEM_FILE), ID_MENUITEM_LAN, (EnableLAN == 1) ? MF_CHECKED : MF_UNCHECKED);
	CheckMenuItem(SHGetSubMenu(hMainToolBar, ID_MENUITEM_MAIL), ID_MENUITEM_THREADVIEW, (LvThreadView == 1) ? MF_CHECKED : MF_UNCHECKED);
	PPCFlag = TRUE;
	MailMenuPos = 1;

#elif defined(_WIN32_WCE_LAGENDA)
	//BE-500
	hCSOBar = CSOBar_Create(hInst, hWnd, 1, BaseInfo);
	CSOBar_AddAdornments(hCSOBar, hInst, 1, CSOBAR_ADORNMENT_CLOSE, 0);

	hMainMenu = LoadMenu(hInst, MAKEINTRESOURCE(IDR_MENU_WINDOW));
	ButtonInfo[0].SubMenu = GetSubMenu(hMainMenu, 0);
	ButtonInfo[1].SubMenu = GetSubMenu(hMainMenu, 1);
	ButtonInfo[2].reshInst = hInst;
	ButtonInfo[3].reshInst = hInst;
	ButtonInfo[4].reshInst = hInst;
	ButtonInfo[5].reshInst = hInst;
	ButtonInfo[6].reshInst = hInst;
	CSOBar_AddButtons(hCSOBar, hInst, sizeof(ButtonInfo) / sizeof(CSOBAR_BUTTONINFO), ButtonInfo);

	style = GetWindowLong(hCSOBar, GWL_STYLE);
	style &= ~WS_CLIPCHILDREN;
	SetWindowLong(hCSOBar, GWL_STYLE, style);

	Height = g_menu_height = CSOBar_Height(hCSOBar);
	i = 0;
	CheckMenuItem(GetSubMenu(hMainMenu, 0), ID_MENUITEM_LAN, (EnableLAN == 1) ? MF_CHECKED : MF_UNCHECKED);
	CheckMenuItem(GetSubMenu(hMainMenu, 1), ID_MENUITEM_THREADVIEW, (LvThreadView == 1) ? MF_CHECKED : MF_UNCHECKED);
	PPCFlag = TRUE;
	MailMenuPos = 1;

#else
	//H/PC & PsPC
	// (nPOP-Q)
	hToolBar = CommandBar_Create(hInst, hWnd, IDC_CB);

	if(GetSystemMetrics(SM_CXSCREEN) >= 320-1){
	    CommandBar_AddToolTips(hToolBar, 14, szTips);
		CommandBar_AddBitmap(hToolBar, hInst, IDB_TOOLBAR_QEX, 13, SICONSIZE, SICONSIZE);

		if(GetSystemMetrics(SM_CXSCREEN) >= 480)
			CommandBar_InsertMenubar(hToolBar, hInst, IDR_MENU_WINDOW_HPC, 0);
		else
			CommandBar_InsertMenubar(hToolBar, hInst, IDR_MENU_WINDOW_PPP, 0);
		MailMenuPos = 3;
		tBtnNum = sizeof(tbButton) / sizeof(TBBUTTON);
		CommandBar_AddButtons(hToolBar, tBtnNum, tbButton);
	}else{
	    CommandBar_AddToolTips(hToolBar, 9, szTips);
		CommandBar_AddBitmap(hToolBar, hInst, IDB_TOOLBAR, 8, SICONSIZE, SICONSIZE);

		PPCFlag = TRUE;
		CommandBar_InsertMenubar(hToolBar, hInst, IDR_MENU_WINDOW, 0);
		MailMenuPos = 1;
		CommandBar_AddButtons(hToolBar, tBtnNum, tbButton);
	}
//	hToolBar = CommandBar_Create(hInst, hWnd, IDC_CB);
//	CommandBar_AddToolTips(hToolBar, 9, szTips);
//	CommandBar_AddBitmap(hToolBar, hInst, IDB_TOOLBAR, 8, TB_ICONSIZE, TB_ICONSIZE);
//
//	if(GetSystemMetrics(SM_CXSCREEN) >= 450){
//		CommandBar_InsertMenubar(hToolBar, hInst, IDR_MENU_WINDOW_HPC, 0);
//		MailMenuPos = 3;
//		CommandBar_AddButtons(hToolBar, sizeof(tbButton) / sizeof(TBBUTTON) -
//			((GetSystemMetrics(SM_CXSCREEN) >= 640) ? 0 : 3), tbButton);
//	}else{
//		PPCFlag = TRUE;
//		CommandBar_InsertMenubar(hToolBar, hInst, IDR_MENU_WINDOW, 0);
//		MailMenuPos = 1;
//		CommandBar_AddButtons(hToolBar, sizeof(tbButton) / sizeof(TBBUTTON) - 5, tbButton);
//	}
#ifndef _CENET
	CommandBar_AddAdornments(hToolBar, 0, 0);
#endif
	Height = CommandBar_Height(hToolBar);
	i = 0;
	CheckMenuItem(CommandBar_GetMenu(hToolBar, 0), ID_MENUITEM_LAN, (EnableLAN == 1) ? MF_CHECKED : MF_UNCHECKED);
	CheckMenuItem(CommandBar_GetMenu(hToolBar, 0), ID_MENUITEM_THREADVIEW, (LvThreadView == 1) ? MF_CHECKED : MF_UNCHECKED);
#endif
#else
	// (nPOP-Q)
	if (g_Winpos.TbarType) {
		int i;
		int iCnt = 0;
		for (i = 0; i < sizeof(tbButton) / sizeof(TBBUTTON); i++) {
			if (tbButton[i].idCommand == 0) continue;
			tbButton[i].iString = iCnt;
			iCnt++;
		}
	}
	//Win32
	MailMenuPos = 3;
	// (nPOP-Q)
	hToolBar = CreateToolbarEx(hWnd, WS_CHILD | TBSTYLE_TOOLTIPS, IDC_TB, 13, hInst, IDB_TOOLBAR_QEX,
//	hToolBar = CreateToolbarEx(hWnd, WS_CHILD | TBSTYLE_TOOLTIPS, IDC_TB, 6, hInst, IDB_TOOLBAR,
		tbButton, sizeof(tbButton) / sizeof(TBBUTTON), 0, 0, TB_ICONSIZE, TB_ICONSIZE, sizeof(TBBUTTON));
	SetWindowLong(hToolBar, GWL_STYLE,
		GetWindowLong(hToolBar, GWL_STYLE) | TBSTYLE_FLAT);
	SendMessage(hToolBar, TB_SETINDENT, 5, 0);
	// (nPOP-Q)
	if (g_Winpos.TbarType) {
		TCHAR szBuf[80];
		int i;
		for (i = 0; i < sizeof(tbButton) / sizeof(TBBUTTON); i++) {
			if (tbButton[i].idCommand == 0) continue;
			LoadString (hInst, tbButton[i].idCommand,	szBuf, 80-1);
			szBuf[lstrlen(szBuf) + 1] = 0;
			SendMessage (hToolBar, TB_ADDSTRING, 0, (LPARAM) (LPSTR) szBuf); 
		}
   	}
	ShowWindow(hToolBar,SW_SHOW);

	GetWindowRect(hToolBar, &ToolbarRect);
	Height = ToolbarRect.bottom - ToolbarRect.top;

	i = SBS_SIZEGRIP | SBT_NOBORDERS;

	CheckMenuItem(GetMenu(hWnd), ID_MENUITEM_LAN, (EnableLAN == 1) ? MF_CHECKED : MF_UNCHECKED);
	CheckMenuItem(GetMenu(hWnd), ID_MENUITEM_THREADVIEW, (LvThreadView == 1) ? MF_CHECKED : MF_UNCHECKED);
#endif

	// c[o[ǉ(nPOP-Q)
#ifdef _WIN32_WCE_PPC
	CreateAddToolBar (hWnd);
#endif

	GetClientRect(hWnd, &rcClient);

	// ǉ̃c[o[(nPOP-Q)
#ifdef _WIN32_WCE_PPC
	rcClient.bottom -= 26;
#endif

	//R{{bNX
	if((j = CreateComboBox(hWnd, Height)) == -1){
		return FALSE;
	}
	Height += j;

	//Xe[^Xo[(nPOP-Q)
	hStatusBar = CreateWindowEx(0, STATUSCLASSNAME, TEXT(""),
#ifndef _WIN32_WCE_PPC
		WS_VISIBLE | WS_CHILD | i,
#else
		WS_VISIBLE | WS_CHILD | CCS_NOPARENTALIGN | WS_BORDER,
#endif
		0, 0, 0, 0, hWnd, (HMENU)IDC_STATUS, hInst, NULL);
	GetWindowRect(GetDlgItem(hWnd, IDC_STATUS), &StatusRect);
#ifdef _WIN32_WCE
	Width[0] = 120;
#else
	Width[0] = 220;
#endif
	Width[1] = -1;
	SendDlgItemMessage(hWnd, IDC_STATUS, SB_SETPARTS,
		(WPARAM)(sizeof(Width) / sizeof(int)), (LPARAM)((LPINT)Width));

	// ǉ̃c[o[,ʒuړ(nPOP-Q)
#ifdef _WIN32_WCE_PPC
	MoveWindow (hStatusBar, 0, 0, GetSystemMetrics(SM_CXSCREEN), 
		rcClient.bottom - rcClient.top, TRUE);
#endif

	//Xgr[
//	if(CreateListView(hWnd, Height, StatusRect.bottom - StatusRect.top) == NULL){
//		return FALSE;
//	}
//	SetFocus(GetDlgItem(hWnd, IDC_LISTVIEW));
	//Xgr[ (nPOP-Q)
	g_hListView = CreateListView(hWnd, Height, StatusRect.bottom - StatusRect.top);
	if (g_hListView == NULL){
		return FALSE;
	}
	SetFocus (g_hListView);
	//Xgr[̃tHgݒ
	if(LvFontName != NULL && *LvFontName != TEXT('\0')){
		hListFont = CreateEditFont(hWnd, LvFontName, LvFontSize, LvFontCharset);
		SendMessage(GetDlgItem(hWnd, IDC_LISTVIEW), WM_SETFONT, (WPARAM)hListFont, MAKELPARAM(TRUE, 0));
	}

	//c[r[ (nPOP-Q)
	g_hTreeView = CreateTreeView(hWnd, Height, StatusRect.bottom - StatusRect.top);
	if (g_hTreeView == NULL){
		return FALSE;
	}
	else {
		extern void TreeView_ChiSaveBox (HWND hTreeView, int Sel);
		extern void TreeView_ChiSendBox (HWND hTreeView, int Sel);
		//c[ɏl (nPOP-Q)
		for(i = 0;i < MailBoxCnt;i++){
			TreeView_SelMailBox (g_hTreeView, i, TRUE);
		}
		//ۑɃAJEgȋjǉ
		TreeView_ChiSaveBox (g_hTreeView, MailBoxCnt);
		//MɃAJEgȋjǉ
		TreeView_ChiSendBox (g_hTreeView, MailBoxCnt);
	}

	//Xgr[TuNX
	SetListViewSubClass(GetDlgItem(hWnd, IDC_LISTVIEW));

#ifdef _WIN32_WCE
	//EBhẼACRݒ
	SendMessage(hWnd, WM_SETICON, (WPARAM)FALSE,
		(LPARAM)LoadImage(hInst, MAKEINTRESOURCE(IDI_ICON_MAIN), IMAGE_ICON, SICONSIZE, SICONSIZE, 0));
#endif

	//ViewEdit̃tHg
	hEditFont = CreateEditFont(hWnd, FontName, FontSize, FontCharset);

	//Xdot̏AhXɎgp (nPOP-Q)
	hSmallFont = CreateEditFont(hWnd, STR_DEFAULT_FONT, 9, LvFontCharset);
	
	// (nPOP-Q) Tvr[ƃAhX
	// hEditFont̃tHgĝōŌɍ쐬

	//Tvr[ (nPOP-Q)
	g_hEditView = CreateEditView (hWnd);
	if (g_hEditView == NULL) {
		return FALSE;
	}

	//ȈՃAhX (nPOP-Q)
	g_hAdrList = CreateAdrList (hWnd);
	if (g_hAdrList == NULL) {
		return FALSE;
	}

	//tHg (nPOP-Q)
	if (g_Winpos.nListFont == 1) {
		SendMessage(g_hListView, WM_SETFONT, (WPARAM)hEditFont, 0);
	}

	//EChETCY (nPOP-Q)
	SetWindowSize(hWnd, 0, 0, FALSE);

	return TRUE;
}


/******************************************************************************

	SetWindowSize

	EBhẼTCYύX
	SetWindowSize (nPOP-Q)

******************************************************************************/

static BOOL SetWindowSize(HWND hWnd, WPARAM wParam, LPARAM lParam, int fNotify)
{
	RECT rcClient, StatusRect, ToolbarRect, comboRect;
	int Height = 0;
	int nSpacer = 12;

#ifdef _WIN32_WCE_PPC
//static BOOL SetWindowSize(HWND hWnd, WPARAM wParam, LPARAM lParam)
//{
//	RECT rcClient, StatusRect, comboRect;
//	int Height = 0;
	SIPINFO SipInfo;
	int sip_height = 0;

	if(hWnd == NULL){
		return FALSE;
	}

	memset(&SipInfo, 0, sizeof(SIPINFO));
	SipInfo.cbSize = sizeof(SIPINFO);
	SipGetInfo(&SipInfo);
	if(SipInfo.fdwFlags & SIPF_ON){
		sip_height = ((SipInfo.rcSipRect).bottom - (SipInfo.rcSipRect).top);
	}

	SendDlgItemMessage(hWnd, IDC_STATUS, WM_SIZE, 0, 0);

	GetClientRect(hWnd, &rcClient);
	GetWindowRect(GetDlgItem(hWnd, IDC_STATUS), &StatusRect);
	GetWindowRect(GetDlgItem(hWnd, IDC_COMBO), &comboRect);
//	Height = (comboRect.bottom - comboRect.top);

//	MoveWindow(GetDlgItem(hWnd, IDC_LISTVIEW), 0, Height,
//		rcClient.right, rcClient.bottom - Height - (StatusRect.bottom - StatusRect.top), TRUE);
//	return TRUE;
//}
#elif defined _WIN32_WCE_LAGENDA
//static BOOL SetWindowSize(HWND hWnd, WPARAM wParam, LPARAM lParam)
//{
	COSIPINFO CoSipInfo;
	SIPINFO SipInfo;
//	RECT rcClient, StatusRect, comboRect;
	int sip_height = 0;
//	int Height = 0;
	int ret;

	if(hWnd == NULL){
		return FALSE;
	}

	memset(&SipInfo, 0, sizeof(SIPINFO));
	SipInfo.cbSize = sizeof(SIPINFO);
	memset(&CoSipInfo, 0, sizeof(COSIPINFO));
	CoSipInfo.dwInfoType = COSIP_GET_KBTYPE;
	SipInfo.pvImData = &CoSipInfo;
	SipInfo.dwImDataSize = sizeof(COSIPINFO);
	SipGetInfo(&SipInfo);
	if(SipInfo.fdwFlags & SIPF_ON){
		sip_height = ((SipInfo.rcSipRect).bottom - (SipInfo.rcSipRect).top);
		ret = TRUE;
	}else{
		ret = FALSE;
	}

	if(wnd_size.right != 0 && wnd_size.bottom != 0){
		MoveWindow(hWnd, 0, 0,
			wnd_size.right, wnd_size.bottom - sip_height, TRUE);
	}
	SendDlgItemMessage(hWnd, IDC_STATUS, WM_SIZE, 0, 0);

	GetClientRect(hWnd, &rcClient);
	GetWindowRect(GetDlgItem(hWnd, IDC_STATUS), &StatusRect);
	GetWindowRect(GetDlgItem(hWnd, IDC_COMBO), &comboRect);
//	Height = (comboRect.bottom - comboRect.top) + g_menu_height;

//	MoveWindow(GetDlgItem(hWnd, IDC_LISTVIEW), 0, Height,
//		rcClient.right, rcClient.bottom - Height - (StatusRect.bottom - StatusRect.top), TRUE);
//	return ret;
//}
#endif

#ifndef _WIN32_WCE
//static BOOL SetWindowSize(HWND hWnd, WPARAM wParam, LPARAM lParam)
//{
//	RECT rcClient, StatusRect, ToolbarRect, comboRect;
//	int Height = 0;

	if(hWnd == NULL || IsIconic(hWnd) != 0){
		return FALSE;
	}

	// (nPOP-Q)
	if (fNotify) {
		SendDlgItemMessage(hWnd, IDC_TB, WM_SIZE, wParam, lParam);
		SendDlgItemMessage(hWnd, IDC_STATUS, WM_SIZE, wParam, lParam);
	}

//	SendDlgItemMessage(hWnd, IDC_TB, WM_SIZE, wParam, lParam);
//	SendDlgItemMessage(hWnd, IDC_STATUS, WM_SIZE, wParam, lParam);
#endif

#ifdef _CENET
	if (fNotify) {
		SendDlgItemMessage(hWnd, IDC_TB, WM_SIZE, wParam, lParam);
		SendDlgItemMessage(hWnd, IDC_STATUS, WM_SIZE, wParam, lParam);
	}
#endif

	GetClientRect(hWnd, &rcClient);
	GetWindowRect(GetDlgItem(hWnd, IDC_TB), &ToolbarRect);
	GetWindowRect(GetDlgItem(hWnd, IDC_STATUS), &StatusRect);
	GetWindowRect(GetDlgItem(hWnd, IDC_COMBO), &comboRect);

	Height = ToolbarRect.bottom - ToolbarRect.top;
//	MoveWindow(GetDlgItem(hWnd, IDC_COMBO), 0, Height,
//		rcClient.right, comboRect.bottom - comboRect.top, TRUE);
//
//	Height += comboRect.bottom - comboRect.top;
//	MoveWindow(GetDlgItem(hWnd, IDC_LISTVIEW), 0, Height,
//		rcClient.right, rcClient.bottom - Height - (StatusRect.bottom - StatusRect.top), TRUE);
//
//	UpdateWindow(GetDlgItem(hWnd, IDC_LISTVIEW));
//	return TRUE;
//}
//#endif

#ifdef _WIN32_WCE_PPC
	if (sip_height == 0) {
		rcClient.bottom -= (StatusRect.bottom - StatusRect.top);
	}
	else {
		rcClient.bottom += 26;
	}
#endif

#ifdef _WIN32_WCE
	Height = MenuBar_GetHeight(hWnd);
#endif

	// R{ (B悤ɂ)(nPOP-Q)
	if (g_Winpos.fCombView) {
		comboRect.bottom = comboRect.top +  
			GetSystemMetrics(SM_CYMENU) +  GetSystemMetrics(SM_CYBORDER);
		ShowWindow (GetDlgItem(hWnd, IDC_COMBO), SW_SHOW);
	}
	else {
		comboRect.bottom = comboRect.top;
		ShowWindow (GetDlgItem(hWnd, IDC_COMBO), SW_HIDE);
	}

#ifndef _WIN32_WCE
	MoveWindow(GetDlgItem(hWnd, IDC_COMBO), 0, Height,
		rcClient.right, comboRect.bottom - comboRect.top, TRUE);
	nSpacer = 16;//GetSystemMetrics(SM_CYMENU);
#endif

	Height += comboRect.bottom - comboRect.top;

	// c[ (nPOP-Q)
	if (g_hTreeView != NULL) {
		MoveWindow (g_hTreeView, 
			0, 
			Height,
			g_Winpos.xVertSplit,
			g_Winpos.yLeftSplit - Height - (StatusRect.bottom - StatusRect.top),
			TRUE);
		UpdateWindow (g_hTreeView);
	}

	// Xg (Xsbgo[Ή)(nPOP-Q)
	if (g_Winpos.typSmpView == 0) {
		MoveWindow(GetDlgItem(hWnd, IDC_LISTVIEW), 
			g_Winpos.xVertSplit + SEPWIDE,
			Height,
			rcClient.right - (g_Winpos.xVertSplit + SEPWIDE), 
			g_Winpos.yRightSplit - Height - (StatusRect.bottom - StatusRect.top),
			TRUE);
	}
	else {
		MoveWindow(GetDlgItem(hWnd, IDC_LISTVIEW), 
			g_Winpos.xVertSplit + SEPWIDE,
			Height,
			rcClient.right - (g_Winpos.xVertSplit + SEPWIDE * 2 + g_Winpos.xRightSplit), 
			rcClient.bottom - Height - (StatusRect.bottom - StatusRect.top),
			TRUE);
	}

	UpdateWindow(GetDlgItem(hWnd, IDC_LISTVIEW));

	// Tvr[ (nPOP-Q)
	if (g_hEditView != NULL) {
#ifdef _CENET
		if (g_Winpos.typSmpView == 0) {
			MoveWindow (g_hEditView, 
				g_Winpos.xVertSplit + SEPWIDE,
				g_Winpos.yRightSplit + SEPWIDE  - (StatusRect.bottom - StatusRect.top),
				rcClient.right - (g_Winpos.xVertSplit + SEPWIDE) - 4, 
				rcClient.bottom - g_Winpos.yRightSplit + nSpacer - (StatusRect.bottom - StatusRect.top), 
				TRUE);
		}
		else {
			MoveWindow (g_hEditView, 
				rcClient.right - g_Winpos.xRightSplit, 
				Height,
				g_Winpos.xRightSplit - 4,
				rcClient.bottom - Height - (StatusRect.bottom - StatusRect.top),
				TRUE);
		}
#else
		if (g_Winpos.typSmpView == 0) {
			MoveWindow (g_hEditView, 
				g_Winpos.xVertSplit + SEPWIDE,
				g_Winpos.yRightSplit + SEPWIDE  - (StatusRect.bottom - StatusRect.top),
				rcClient.right - (g_Winpos.xVertSplit + SEPWIDE), 
				rcClient.bottom - g_Winpos.yRightSplit + nSpacer - (StatusRect.bottom - StatusRect.top), 
				TRUE);
		}
		else {
			MoveWindow (g_hEditView, 
				rcClient.right - g_Winpos.xRightSplit, 
				Height,
				g_Winpos.xRightSplit,
				rcClient.bottom - Height - (StatusRect.bottom - StatusRect.top),
				TRUE);
		}
#endif
		UpdateWindow (g_hEditView);
	}

	// ȈՃAhX (nPOP-Q)
	if (g_hAdrList != NULL) {
		RECT rect;
		MoveWindow (g_hAdrList, 
			0,
			g_Winpos.yLeftSplit + SEPWIDE  - (StatusRect.bottom - StatusRect.top),
			g_Winpos.xVertSplit,
			rcClient.bottom - g_Winpos.yLeftSplit + nSpacer - (StatusRect.bottom - StatusRect.top), 
			TRUE);
		GetClientRect (g_hAdrList, &rect);
		ListView_SetColumnWidth (g_hAdrList, 0, rect.right-rect.left);
		//	g_Winpos.xVertSplit-GetSystemMetrics(SM_CXVSCROLL)-GetSystemMetrics(SM_CXBORDER)*2);
		UpdateWindow (g_hAdrList);
	}

	return TRUE;
}


/******************************************************************************

	SaveWindow

	EBhE̕ۑ

******************************************************************************/

static BOOL SaveWindow(HWND hWnd)
{
	int i;
	BOOL ret;

	SwitchCursor(FALSE);

	// EChEX^Cۑ (nPOP-Q)
	g_Winpos.dwStyle = GetWindowLong (hWnd, GWL_STYLE);
	// ۑtO𐧌
#ifndef _WIN32_WCE
	g_Winpos.dwStyle &= (WS_MAXIMIZE | WS_MINIMIZE);
#endif

	//ʐM̏ꍇ͐ؒfs
	if(g_soc != -1 && GetHostFlag == FALSE){
#ifndef WSAASYNC
		KillTimer(hWnd, ID_RECV_TIMER);
#endif
		KillTimer(hWnd, ID_SMTP_TIMER);
		KillTimer(hWnd, ID_SMTP_ONE_TIMER);
		KillTimer(hWnd, ID_CHECK_TIMER);
		KillTimer(hWnd, ID_EXEC_TIMER);
		KillTimer(hWnd, ID_TIMEOUT_TIMER);
		KillTimer(hWnd, ID_RASWAIT_TIMER);
		gSockFlag = FALSE;
		ExecFlag = FALSE;
		NewMailCnt = -1;
		MailFlag = POP_QUIT;
		SendBuf(g_soc, RSET);
		SendBuf(g_soc, QUIT);
		SocketClose(hWnd, g_soc);
		if(RasCheckEndDisCon == 1){
			RasDisconnect();
		}
	}
	NULLCHECK_FREE(RecvBuf);
	NULLCHECK_FREE(RemainderBuf);

	//_CAbv̐ؒf
	if(RasLoop == TRUE || RasEndDisCon == 1){
		RasDisconnect();
	}

	//\AҏWEBhE
	CloseViewWindow(1);

	//AhXAۑAMۑ
	ret = !SaveAddressBook(ADDRESS_FILE, AddressBox);
	ret |= !SaveMail(SAVEBOX_FILE, MailBox + MAILBOX_SAVE, 2);
	ret |= !SaveMail(SENDBOX_FILE, MailBox + MAILBOX_SEND, 2);
	if(ret == TRUE){
		SwitchCursor(TRUE);
		if(MessageBox(hWnd, STR_ERR_SAVEEND,
			STR_TITLE_ERROR, MB_ICONERROR | MB_YESNO) == IDNO){
			return FALSE;
		}
	}

	//AJEg̐ݒ̕ۑ
	for(i = 0; i < LV_COL_CNT; i++){
		LvColSize[i] = ListView_GetColumnWidth(GetDlgItem(hWnd, IDC_LISTVIEW), i);
	}
	if(PutINI(hWnd, TRUE) == FALSE){
		SwitchCursor(TRUE);
		if(MessageBox(hWnd, STR_ERR_SAVEEND,
			STR_TITLE_ERROR, MB_ICONERROR | MB_YESNO) == IDNO){
			return FALSE;
		}
	}
	SwitchCursor(TRUE);
	return TRUE;
}


/******************************************************************************

	EndWindow

	EBhȄI

******************************************************************************/

static BOOL EndWindow(HWND hWnd)
{
	HIMAGELIST hImgList;
	TCHAR path[BUF_SIZE];

	SwitchCursor(FALSE);

	ListView_DeleteAllItems(GetDlgItem(hWnd, IDC_LISTVIEW));

	//bZ[WEBhE
	if(MsgWnd != NULL){
		SendMessage(MsgWnd, WM_ENDDIALOG, 0, 0);
	}

	//OAvpt@C̍폜
	TStrJoin(path, DataDir, VIEW_FILE, TEXT("."), ViewFileSuffix, (TCHAR *)-1);
	DeleteFile(path);
#ifdef _WIN32_WCE
	TStrJoin(path, DataDir, EDIT_FILE, TEXT("."), EditFileSuffix, (TCHAR *)-1);
	DeleteFile(path);
#endif

	//̉
	NULLCHECK_FREE(FindStr);
	FindStr = NULL;

	//ׂẴ[{bNX̉
	FreeAllMailBox();
	NULLCHECK_FREE(g_Pass);

	//ݒ̉
	FreeIniInfo();
	FreeRasInfo();

	//^XNgC̃ACȐ
	ShowTrayIcon = 0;
	TrayMessage(hWnd, NIM_DELETE, TRAY_ID, NULL, NULL);

	//ACR̔j
	DestroyIcon(TrayIcon_Main);
	DestroyIcon(TrayIcon_Check);
	// (nPOP-Q)
	//DestroyIcon(TrayIcon_Mail);
	{	int i;
		for (i = 0; i < 10; i++) {
			if (TrayIcon_Mail[i]) DestroyIcon(TrayIcon_Mail[i]);
		}
	}

	//Xgr[̃TuNX̉
	DelListViewSubClass(GetDlgItem(hWnd, IDC_LISTVIEW));

	//GfBbgr[̃TuNX̉ (nPOP-Q)
	DelEditSubClass (g_hEditView);

	//C[WXg̔j
	hImgList = ListView_SetImageList(GetDlgItem(hWnd, IDC_LISTVIEW), NULL, LVSIL_SMALL);
	ImageList_Destroy((void *)hImgList);
	hImgList = ListView_SetImageList(GetDlgItem(hWnd, IDC_LISTVIEW), NULL, LVSIL_STATE);
	ImageList_Destroy((void *)hImgList);

	//EBhE̔j
#ifdef _WIN32_WCE
#ifdef _WIN32_WCE_PPC
    DestroyWindow(hMainToolBar);
#elif defined _WIN32_WCE_LAGENDA
	DestroyMenu(hMainMenu);
#else
	CommandBar_Destroy(GetDlgItem(hWnd, IDC_CB));
#endif
	DestroyIcon((HICON)SendMessage(hWnd, WM_GETICON, FALSE, 0));
#else
	DestroyWindow(GetDlgItem(hWnd, IDC_TB));
#endif
	DestroyWindow(GetDlgItem(hWnd, IDC_COMBO));
	DestroyWindow(GetDlgItem(hWnd, IDC_LISTVIEW));
	DestroyWindow(GetDlgItem(hWnd, IDC_STATUS));

	//tHg̔j
	if(hListFont != NULL){
		DeleteObject(hListFont);
	}
	DeleteObject(hEditFont);
	DeleteObject(hSmallFont);	// (nPOP-Q)

	SwitchCursor(TRUE);
	DestroyWindow(hWnd);
	return TRUE;
}


/******************************************************************************

	SendMail

	[̑MJn

******************************************************************************/

static BOOL SendMail(HWND hWnd, struct TPMAILITEM *tpMailItem, int EndMailFlag)
{
	struct TPMAILBOX *tpMailBox;
	TCHAR *pass;
	TCHAR ErrStr[BUF_SIZE];
	int BoxIndex;

	BoxIndex = GetNameToMailBox(tpMailItem->MailBox);
	if(BoxIndex == -1){
		ErrorSocketEnd(hWnd, MAILBOX_SEND);
		SocketErrorMessage(hWnd, STR_ERR_SELECTMAILBOX, MAILBOX_SEND);
		return FALSE;
	}
	tpMailBox = MailBox + BoxIndex;

	//_CAbvJn
	if(RasCon == 1 && SendMessage(hWnd, WM_RAS_START, BoxIndex, 0) == FALSE){
		ErrorSocketEnd(hWnd, MAILBOX_SEND);
		SetMailMenu(hWnd);
		return FALSE;
	}

	g_soc = 0;

	//SMTP Authentication
	if(tpMailBox->SmtpAuth == 1){
		//pX[hݒ肳ĂȂꍇ̓pX[h̓͂𑣂
		if(g_Pass != NULL){
			NULLCHECK_FREE(g_Pass);
			g_Pass = NULL;
		}
		if(tpMailBox->AuthUserPass == 1){
			pass = tpMailBox->SmtpPass;
			if(pass == NULL || *pass == TEXT('\0')){
				pass = tpMailBox->SmtpTmpPass;
			}
		}else{
			pass = tpMailBox->Pass;
			if(pass == NULL || *pass == TEXT('\0')){
				pass = tpMailBox->TmpPass;
			}
		}
		if(pass == NULL || *pass == TEXT('\0')){
			gPassSt = 1;
			if(DialogBoxParam(hInst, MAKEINTRESOURCE(IDD_DIALOG_INPUTPASS), hWnd, InputPassProc,
				(LPARAM)((tpMailBox->Name == NULL || *tpMailBox->Name == TEXT('\0'))
				? STR_MAILBOX_NONAME : tpMailBox->Name)) == FALSE){
				g_soc = -1;
				ErrorSocketEnd(hWnd, MAILBOX_SEND);
				SetMailMenu(hWnd);
				return FALSE;
			}
			if(gPassSt == 1){
				//ꎞpX[h̐ݒ
				if(tpMailBox->AuthUserPass == 1){
					tpMailBox->SmtpTmpPass = AllocCopy(g_Pass);
				}else{
					tpMailBox->TmpPass = AllocCopy(g_Pass);
				}
			}
		}
	}

	if(SocLog == 1) SaveLogSep(AppDir, LOG_FILE, TEXT("send"));

	SetTimer(hWnd, ID_TIMEOUT_TIMER, TIMEOUTTIME * TimeoutInterval, NULL);

	SwitchCursor(FALSE);
	RecvProc = SmtpProc;
	MailFlag = SMTP_START;
	ExecFlag = TRUE;

	*ErrStr = TEXT('\0');
	g_soc = SendMailItem(hWnd, tpMailBox, tpMailItem, EndMailFlag, ErrStr);
	if(g_soc == -1){
		ErrorSocketEnd(hWnd, MAILBOX_SEND);
		SocketErrorMessage(hWnd, ErrStr, MAILBOX_SEND);
		return FALSE;
	}
	RecvBox = MAILBOX_SEND;

#ifndef WSAASYNC
	SetTimer(hWnd, ID_RECV_TIMER, RECVTIME, NULL);
#endif
	SetMailMenu(hWnd);
	SetTrayIcon(hWnd, TrayIcon_Check, WINDOW_TITLE);
	SwitchCursor(TRUE);
	return TRUE;
}


/******************************************************************************

	RecvMailList

	[̈ꗗ̎M

******************************************************************************/

static BOOL RecvMailList(HWND hWnd, int BoxIndex, BOOL SmtpFlag)
{
	struct TPMAILBOX *tpMailBox;
	TCHAR ErrStr[BUF_SIZE];

	if(g_soc != -1 || BoxIndex == MAILBOX_SAVE || BoxIndex == MAILBOX_SEND){
		return FALSE;
	}
	g_soc = 0;

	tpMailBox = MailBox + BoxIndex;

	//VtȌ
	tpMailBox->NewMail = FALSE;

	//pX[hݒ肳ĂȂꍇ̓pX[h̓͂𑣂
	if(g_Pass != NULL){
		NULLCHECK_FREE(g_Pass);
		g_Pass = NULL;
	}
	if((tpMailBox->Pass == NULL || *tpMailBox->Pass == TEXT('\0')) &&
		(tpMailBox->TmpPass == NULL || *tpMailBox->TmpPass == TEXT('\0'))){
		gPassSt = 1;
		if(DialogBoxParam(hInst, MAKEINTRESOURCE(IDD_DIALOG_INPUTPASS), hWnd, InputPassProc,
			(LPARAM)((tpMailBox->Name == NULL || *tpMailBox->Name == TEXT('\0'))
			? STR_MAILBOX_NONAME : tpMailBox->Name)) == FALSE){
			g_soc = -1;
			return FALSE;
		}
		if(gPassSt == 1){
			//ꎞpX[h̐ݒ
			tpMailBox->TmpPass = AllocCopy(g_Pass);
		}
	}

	if(SocLog == 1) SaveLogSep(AppDir, LOG_FILE, TEXT("recv"));

	RecvBox = BoxIndex;

	//zXgIPAhX擾 (擾IP͕ۑĂ)
	SwitchCursor(FALSE);
	if(tpMailBox->PopIP == 0 || IPCache == 0){
		GetHostFlag = TRUE;
		tpMailBox->PopIP = GetHostByName(hWnd, tpMailBox->Server, ErrStr);
		GetHostFlag = FALSE;
		if(tpMailBox->PopIP == 0){
			ErrorSocketEnd(hWnd, BoxIndex);
			SocketErrorMessage(hWnd, ErrStr, BoxIndex);
			g_soc = -1;
			return FALSE;
		}
	}

	SetTimer(hWnd, ID_TIMEOUT_TIMER, TIMEOUTTIME * TimeoutInterval, NULL);

	//ڑJn
	RecvProc = ListPopProc;
	MailFlag = POP_START;
	PopBeforeSmtpFlag = SmtpFlag;
	g_soc = ConnectServer(hWnd,
		tpMailBox->PopIP, (unsigned short)tpMailBox->Port, ErrStr);
	if(g_soc == -1){
		ErrorSocketEnd(hWnd, BoxIndex);
		SocketErrorMessage(hWnd, ErrStr, BoxIndex);
		return FALSE;
	}
#ifndef WSAASYNC
	SetTimer(hWnd, ID_RECV_TIMER, RECVTIME, NULL);
#endif
	SetMailMenu(hWnd);
	SetTrayIcon(hWnd, TrayIcon_Check, WINDOW_TITLE);
	SwitchCursor(TRUE);
	return TRUE;
}


/******************************************************************************

	MailMarkCheck

	폜[Ȃ`FbN

******************************************************************************/

static BOOL MailMarkCheck(HWND hWnd, BOOL DelMsg, BOOL NoMsg)
{
	HWND hListView;
	int i;
	BOOL ret = FALSE;

	for(i = MAILBOX_USER; i < MailBoxCnt; i++){
		if((MailBox + i)->CyclicFlag == 1){
			continue;
		}
		if(Item_GetNextDonloadItem((MailBox + i), -1, NULL) == -1 &&
			Item_GetNextDeleteItem((MailBox + i), -1, NULL) == -1){
			continue;
		}
		ret = TRUE;
		if(DelMsg == TRUE && Item_GetNextDeleteItem((MailBox + i), -1, NULL) != -1){
			if(MessageBox(hWnd, STR_Q_DELSERVERMAIL,
				(MailBox + i)->Name, MB_ICONEXCLAMATION | MB_YESNO) == IDNO){
				SelectMailBox(hWnd, i);
				hListView = GetDlgItem(hWnd, IDC_LISTVIEW);
				if((i = ListView_GetNextDeleteItem(hListView, -1)) != -1){
					ListView_SetItemState(hListView, -1, 0, LVIS_SELECTED);
					ListView_SetItemState(hListView, i,
						LVIS_FOCUSED | LVIS_SELECTED, LVIS_FOCUSED | LVIS_SELECTED);
					ListView_EnsureVisible(hListView, i, TRUE);
				}
				return FALSE;
			}
			break;
		}
	}
	if(Item_GetNextSendItem((MailBox + MAILBOX_SEND), -1, NULL) != -1){
		ret = TRUE;
	}
	if(NoMsg == TRUE && ret == FALSE){
		MessageBox(hWnd,
			STR_MSG_NOMARK, STR_TITLE_ALLEXEC, MB_ICONEXCLAMATION | MB_OK);
	}
	return ret;
}


/******************************************************************************

	ExecItem

	}[N̂s

******************************************************************************/

static BOOL ExecItem(HWND hWnd, int BoxIndex)
{
	struct TPMAILBOX *tpMailBox;
	TCHAR ErrStr[BUF_SIZE];

	if(g_soc != -1){
		return FALSE;
	}

	tpMailBox = MailBox + BoxIndex;

	//M̏ꍇ͑Ms
	if(BoxIndex == MAILBOX_SEND){
		if(Item_GetNextSendItem(tpMailBox, -1, NULL) == -1){
			return FALSE;
		}
		AllCheck = TRUE;
		gSockFlag = TRUE;
		KeyShowHeader = FALSE;
		SmtpWait = 0;
		CheckBox = MAILBOX_USER - 1;
		SetTimer(hWnd, ID_SMTP_TIMER, SMTPTIME, NULL);
		return TRUE;
	}

	if(Item_GetNextDonloadItem(tpMailBox, -1, NULL) == -1 &&
		Item_GetNextDeleteItem(tpMailBox, -1, NULL) == -1){
		return FALSE;
	}
	g_soc = 0;

	NULLCHECK_FREE(g_Pass);
	g_Pass = NULL;
	if((tpMailBox->Pass == NULL || *tpMailBox->Pass == TEXT('\0')) &&
		(tpMailBox->TmpPass == NULL || *tpMailBox->TmpPass == TEXT('\0'))){
		gPassSt = 1;
		if(DialogBoxParam(hInst, MAKEINTRESOURCE(IDD_DIALOG_INPUTPASS), hWnd, InputPassProc,
			(LPARAM)((tpMailBox->Name == NULL || *tpMailBox->Name == TEXT('\0'))
			? STR_MAILBOX_NONAME : tpMailBox->Name)) == FALSE){
			g_soc = -1;
			return FALSE;
		}
		if(gPassSt == 1){
			//ꎞpX[h̐ݒ
			tpMailBox->TmpPass = AllocCopy(g_Pass);
		}
	}

	if(SocLog == 1) SaveLogSep(AppDir, LOG_FILE, TEXT("exec"));

	RecvBox = BoxIndex;

	//zXgIPAhX擾 (擾IP͕ۑĂ)
	SwitchCursor(FALSE);
	if(tpMailBox->PopIP == 0 || IPCache == 0){
		GetHostFlag = TRUE;
		tpMailBox->PopIP = GetHostByName(hWnd, tpMailBox->Server, ErrStr);
		GetHostFlag = FALSE;
		if(tpMailBox->PopIP == 0){
			ErrorSocketEnd(hWnd, BoxIndex);
			SocketErrorMessage(hWnd, ErrStr, BoxIndex);
			g_soc = -1;
			return FALSE;
		}
	}

	SetTimer(hWnd, ID_TIMEOUT_TIMER, TIMEOUTTIME * TimeoutInterval, NULL);

	//ڑJn
	RecvProc = DownLoadPopProc;
	MailFlag = POP_START;
	g_soc = ConnectServer(hWnd,
		tpMailBox->PopIP, (unsigned short)tpMailBox->Port, ErrStr);
	if(g_soc == -1){
		ErrorSocketEnd(hWnd, BoxIndex);
		SocketErrorMessage(hWnd, ErrStr, BoxIndex);
		return FALSE;
	}
#ifndef WSAASYNC
	SetTimer(hWnd, ID_RECV_TIMER, RECVTIME, NULL);
#endif
	SetMailMenu(hWnd);
	SetTrayIcon(hWnd, TrayIcon_Check, WINDOW_TITLE);
	SwitchCursor(TRUE);
	return TRUE;
}


/******************************************************************************

	OpenItem

	ACeJ

******************************************************************************/

static void OpenItem(HWND hWnd, BOOL MsgFlag, BOOL NoAppFlag)
{
	struct TPMAILITEM *tpMailItem;
	HWND hListView;
	int i;

	hListView = GetDlgItem(hWnd, IDC_LISTVIEW);
	if(ListView_GetSelectedCount(hListView) <= 0){
		return;
	}
	i = ListView_GetNextItem(hListView, -1, LVNI_FOCUSED);
	if(i == -1){
		return;
	}
	ListView_EnsureVisible(hListView, i, TRUE);
	tpMailItem = (struct TPMAILITEM *)ListView_GetlParam(hListView, i);
	if(tpMailItem == NULL){
		return;
	}
	if(SelBox == MAILBOX_SEND){
		if(Edit_InitInstance(hInst, hWnd, -1, tpMailItem, EDIT_OPEN, 0) == EDIT_INSIDEEDIT){
#ifdef _WIN32_WCE
#ifndef _CENET
			ShowWindow(hWnd, SW_HIDE);
#endif
#endif
		}
		return;
	}
	if(tpMailItem->Body == NULL && SelBox != MAILBOX_SAVE){
		if(MsgFlag == TRUE){
			MessageBox(hWnd, STR_MSG_NOBODY, STR_TITLE_OPEN, MB_ICONEXCLAMATION | MB_OK);
			return;
		}
		if(tpMailItem->Status == ICON_DOWN){
			tpMailItem->Status = ICON_NON;
			ListView_SetItemState(hListView, i, LVIS_CUT, LVIS_CUT);
		}else{
			tpMailItem->Status = ICON_DOWN;
			ListView_SetItemState(hListView, i, 0, LVIS_CUT);
		}
		ListView_RedrawItems(hListView, i, i);
		UpdateWindow(hListView);
		return;
	}
	if(View_InitInstance(hInst,
		(LPVOID)ListView_GetlParam(hListView, i), NoAppFlag) == TRUE){
#ifdef _WIN32_WCE
#ifndef _CENET
		ShowWindow(hWnd, SW_HIDE);
#endif
#endif
	}
}


/******************************************************************************

	ReMessageItem

	ԐM̍쐬

******************************************************************************/

static void ReMessageItem(HWND hWnd)
{
	HWND hListView;
	int i;

	hListView = GetDlgItem(hWnd, IDC_LISTVIEW);
	i = ListView_GetNextItem(hListView, -1, LVNI_FOCUSED);
	if(i == -1){
		return;
	}
	if(SelBox == MAILBOX_SEND){
		DialogBoxParam(hInst, MAKEINTRESOURCE(IDD_DIALOG_SETSEND), hWnd, SetSendProc,
			(LPARAM)ListView_GetlParam(hListView, i));
		ListView_RedrawItems(hListView, i, i);
		UpdateWindow(hListView);
	}else{
		if(Edit_InitInstance(hInst, hWnd, SelBox,
			(struct TPMAILITEM *)ListView_GetlParam(hListView, i), EDIT_REPLY, 0) == EDIT_INSIDEEDIT){
#ifdef _WIN32_WCE
#ifndef _CENET
			ShowWindow(hWnd, SW_HIDE);
#endif
#endif
		}
	}
}


/******************************************************************************

	ItemToSaveBox

	ۑփACẽRs[

******************************************************************************/

static void ItemToSaveBox(HWND hWnd)
{
	struct TPMAILBOX *tpMailBox;
	struct TPMAILITEM *tpMailItem;
	struct TPMAILITEM *tpTmpMailItem;
	HWND hListView;
	TCHAR *buf;
	TCHAR msgbuf[BUF_SIZE];
	int i, j, SelPoint = -1;

	hListView = GetDlgItem(hWnd, IDC_LISTVIEW);
	if((i = ListView_GetSelectedCount(hListView)) <= 0){
		return;
	}
	if(SelBox == MAILBOX_SEND){
		tpMailBox = MailBox + MAILBOX_SEND;
	}else{
		if(SaveMsg == 1){
			wsprintf(msgbuf, STR_Q_COPY, i);
			if(MessageBox(hWnd, msgbuf, STR_TITLE_COPY, MB_ICONQUESTION | MB_YESNO) == IDNO){
				return;
			}
		}
		tpMailBox = MailBox + MAILBOX_SAVE;
	}

	SwitchCursor(FALSE);
	i = -1;
	while((i = ListView_GetNextItem(hListView, i, LVNI_SELECTED)) != -1){
		tpMailItem = (struct TPMAILITEM *)ListView_GetlParam(hListView, i);
		if(tpMailItem == NULL){
			continue;
		}

		if(SelBox == MAILBOX_SEND){
			//MɃRs[쐬
			if((tpTmpMailItem = Item_CopyMailBox(tpMailBox, tpMailItem, NULL, TRUE)) == NULL){
				SwitchCursor(TRUE);
				ErrorMessage(hWnd, STR_ERR_CREATECOPY);
				break;
			}
			j = ListView_InsertItemEx(hListView,
				(TCHAR *)LPSTR_TEXTCALLBACK, 0, I_IMAGECALLBACK, (long)tpTmpMailItem,
				ListView_GetItemCount(hListView));
			if(tpTmpMailItem->Multipart == TRUE){
				ListView_SetItemState(hListView, j, INDEXTOSTATEIMAGEMASK(1), LVIS_STATEIMAGEMASK)
				ListView_RedrawItems(hListView, j, j);
				UpdateWindow(hListView);
			}
			if(SelPoint == -1){
				SelPoint = j;
			}
		}else{
			//ɑ݂ĂȂׂ
			j = Item_FindThread(tpMailBox, tpMailItem->MessageID, tpMailBox->MailItemCnt);
			if(j != -1){
				//Rs[_E[hς݂Rs[悪_E[ĥ̂̏ꍇ͊mFsȂ
				if(tpMailItem->Download == TRUE
					|| (*(tpMailBox->tpMailItem + j))->Download == FALSE){
					FreeMailItem((tpMailBox->tpMailItem + j), 1);
				}else{
					//㏑̊mF
					buf = (TCHAR *)LocalAlloc(LMEM_FIXED,
						sizeof(TCHAR) * (lstrlen(tpMailItem->Subject) + lstrlen(STR_Q_COPY) + 1));
					if(buf != NULL){
						wsprintf(buf, STR_Q_COPY, tpMailItem->Subject);
						SwitchCursor(TRUE);
						if(MessageBox(hWnd, buf, STR_TITLE_COPY, MB_ICONEXCLAMATION | MB_YESNO) == IDNO){
							LocalFree(buf);
							continue;
						}
						LocalFree(buf);
					}
					FreeMailItem((tpMailBox->tpMailItem + j), 1);
				}
			}
			//[ACẽRs[
			if(Item_CopyMailBox(tpMailBox, tpMailItem, (MailBox + SelBox)->Name, FALSE) == NULL){
				SwitchCursor(TRUE);
				ErrorMessage(hWnd, STR_ERR_SAVECOPY);
				break;
			}
		}
	}
	Item_Resize(tpMailBox);
	SetItemCntStatusText(hWnd, NULL);
	if(SelPoint != -1){
		//ǉꂽACeI
		ListView_SetItemState(hListView, -1, 0, LVIS_SELECTED);
		ListView_SetItemState(hListView, SelPoint,
			LVIS_FOCUSED | LVIS_SELECTED, LVIS_FOCUSED | LVIS_SELECTED);
		ListView_EnsureVisible(hListView, SelPoint, TRUE);
		SendDlgItemMessage(hWnd, IDC_LISTVIEW, WM_VSCROLL, SB_LINEDOWN, 0);
	}
	SwitchCursor(TRUE);
}


/******************************************************************************

	ListDeleteItem

	ꗗACe폜

******************************************************************************/

static void ListDeleteItem(HWND hWnd)
{
	struct TPMAILITEM *tpMailItem;
	HWND hListView;
	TCHAR buf[BUF_SIZE];
	int i;

	hListView = GetDlgItem(hWnd, IDC_LISTVIEW);
	if((i = ListView_GetSelectedCount(hListView)) <= 0){
		return;
	}
	wsprintf(buf, STR_Q_DELLISTMAIL, i, (SelBox >= MAILBOX_USER)
		? STR_Q_DELLISTMAIL_NOSERVER : TEXT(""));
	if(MessageBox(hWnd, buf, STR_TITLE_DELETE, MB_ICONEXCLAMATION | MB_YESNO) == IDNO){
		return;
	}

	SwitchCursor(FALSE);
	ListView_SetRedraw(hListView, FALSE);
	while((i = ListView_GetNextItem(hListView, -1, LVNI_SELECTED)) != -1){
		tpMailItem = (struct TPMAILITEM *)ListView_GetlParam(hListView, i);
		if(tpMailItem != NULL){
			tpMailItem->Status = -1;
		}
		ListView_DeleteItem(hListView, i);
	}
	//NULLɐݒ
	for(i = 0; i < (MailBox + SelBox)->MailItemCnt; i++){
		if(*((MailBox + SelBox)->tpMailItem + i) == NULL ||
			(*((MailBox + SelBox)->tpMailItem + i))->Status != -1){
			continue;
		}
		FreeMailItem(((MailBox + SelBox)->tpMailItem + i), 1);
	}
	Item_Resize(MailBox + SelBox);

	ListView_SetRedraw(hListView, TRUE);
	SetItemCntStatusText(hWnd, NULL);
	SwitchCursor(TRUE);

	//Tv݂̌̕\폜 (nPOP-Q)
	if (g_hEditView != NULL) {
		SetWindowText (g_hEditView, TEXT(""));
		EditView_RestNo ();
	}
}


/******************************************************************************

	SetDownloadMark

	ACeɎM}[Nt

******************************************************************************/

static void SetDownloadMark(HWND hWnd, BOOL Flag)
{
#define DOWN_ICON	((SelBox == MAILBOX_SEND) ? ICON_SEND : ICON_DOWN)
	struct TPMAILITEM *tpMailItem;
	HWND hListView;
	int i;

	hListView = GetDlgItem(hWnd, IDC_LISTVIEW);
	if(ListView_GetSelectedCount(hListView) <= 0){
		return;
	}
	i = -1;
	while((i = ListView_GetNextItem(hListView, i, LVNI_SELECTED)) != -1){
		tpMailItem = (struct TPMAILITEM *)ListView_GetlParam(hListView, i);
		if(tpMailItem == NULL){
			continue;
		}
		if(tpMailItem->Status == DOWN_ICON && Flag == TRUE){
			tpMailItem->Status = tpMailItem->MailStatus;
			if(SelBox != MAILBOX_SEND && tpMailItem->Download == FALSE){
				ListView_SetItemState(hListView, i, LVIS_CUT, LVIS_CUT);
			}
		}else{
			tpMailItem->Status = DOWN_ICON;
			ListView_SetItemState(hListView, i, 0, LVIS_CUT);
		}
		ListView_RedrawItems(hListView, i, i);
	}
	UpdateWindow(hListView);
}


/******************************************************************************

	SetDeleteMark

	ACeɍ폜}[Nt

******************************************************************************/

static void SetDeleteMark(HWND hWnd)
{
	struct TPMAILITEM *tpMailItem;
	HWND hListView;
	int i;

	hListView = GetDlgItem(hWnd, IDC_LISTVIEW);
	if(ListView_GetSelectedCount(hListView) <= 0){
		return;
	}
	i = -1;
	while((i = ListView_GetNextItem(hListView, i, LVNI_SELECTED)) != -1){
		tpMailItem = (struct TPMAILITEM *)ListView_GetlParam(hListView, i);
		if(tpMailItem == NULL){
			continue;
		}
		tpMailItem->Status = ICON_DEL;
		ListView_SetItemState(hListView, i, 0, LVIS_CUT);
		ListView_RedrawItems(hListView, i, i);
	}
	UpdateWindow(hListView);
}


/******************************************************************************

	UnMark

	ACẽ}[N

******************************************************************************/

static void UnMark(HWND hWnd)
{
	struct TPMAILITEM *tpMailItem;
	HWND hListView;
	int i;

	hListView = GetDlgItem(hWnd, IDC_LISTVIEW);
	if(ListView_GetSelectedCount(hListView) <= 0){
		return;
	}
	i = -1;
	while((i = ListView_GetNextItem(hListView, i, LVNI_SELECTED)) != -1){
		tpMailItem = (struct TPMAILITEM *)ListView_GetlParam(hListView, i);
		if(tpMailItem == NULL){
			continue;
		}
		tpMailItem->Status = tpMailItem->MailStatus;
		if(SelBox != MAILBOX_SEND && tpMailItem->Download == FALSE){
			ListView_SetItemState(hListView, i, LVIS_CUT, LVIS_CUT);
		}
		ListView_RedrawItems(hListView, i, i);
	}
	UpdateWindow(hListView);
}


/******************************************************************************

	SetReadMail

	I[Jς݁AJɂ

******************************************************************************/

static void SetMailStats(HWND hWnd, int St)
{
	struct TPMAILITEM *tpMailItem;
	HWND hListView;
	int i;

	hListView = GetDlgItem(hWnd, IDC_LISTVIEW);
	if(ListView_GetSelectedCount(hListView) <= 0){
		return;
	}
	i = -1;
	while((i = ListView_GetNextItem(hListView, i, LVNI_SELECTED)) != -1){
		tpMailItem = (struct TPMAILITEM *)ListView_GetlParam(hListView, i);
		if(tpMailItem == NULL ||
			tpMailItem->MailStatus == ICON_NON || tpMailItem->MailStatus >= ICON_SENDMAIL){
			continue;
		}
		tpMailItem->MailStatus = St;
		if(tpMailItem->Status != ICON_DOWN && tpMailItem->Status != ICON_DEL){
			tpMailItem->Status = St;
		}
		ListView_RedrawItems(hListView, i, i);
	}
	UpdateWindow(hListView);
	SetItemCntStatusText(hWnd, NULL);
}


/******************************************************************************

	Tbico_NewMailNo (nPOP-Q)

	V[̂AJEgԍԂ

******************************************************************************/

static int Tbico_NewMailNo(void)
{
	int i;
	int no, cnt;

	if(ShowMsgFlag == TRUE){
		return 0;
	}

	no = 0;
	cnt = 0;
	for(i = MAILBOX_USER; i < MailBoxCnt; i++){
		if ((MailBox + i)->NewMail) {
			no = i - MAILBOX_USER + 1;
			cnt++;
		}
	}
	if (cnt > 1 || no > 9) no = 0;
	return no;
}


/******************************************************************************

	EndSocketFunc

	ʐMȈ

******************************************************************************/

static void EndSocketFunc(HWND hWnd)
{
	HWND hListView;
	int i;

	if(RasCheckEndDisCon == 1){
		RasDisconnect();
	}
	SetMailMenu(hWnd);

	if(NewMail_Flag == TRUE &&
		(IsWindowVisible(hWnd) == 0 ||
#ifndef _WIN32_WCE
		IsIconic(hWnd) != 0 ||
#endif
		GetForegroundWindow() != hWnd)){
		// (nPOP-Q)
		if (g_Winpos.TbIconType == 1) {
			int no = Tbico_NewMailNo();
			SetTrayIcon(hWnd, TrayIcon_Mail[no], WINDOW_TITLE);
		}
		else if (g_Winpos.TbIconType == 2) {
			int no = NewMailCnt;
			if (no > 9) no = 0;
			SetTrayIcon(hWnd, TrayIcon_Mail[no], WINDOW_TITLE);
		}
		else {
			SetTrayIcon(hWnd, TrayIcon_Mail[0], WINDOW_TITLE);
		}
		//SetTrayIcon(hWnd, TrayIcon_Mail[0], WINDOW_TITLE);
	}else{
		NewMail_Flag = FALSE;
		SetTrayIcon(hWnd, TrayIcon_Main, WINDOW_TITLE);
	}

	if(EndThreadSortFlag == TRUE){
		//\[g
		SwitchCursor(FALSE);
		hListView = GetDlgItem(hWnd, IDC_LISTVIEW);
		if(LvThreadView == 1){
			Item_SetThread(MailBox + SelBox);
			ListView_SortItems(hListView, CompareFunc, SORT_THREAD + 1);
		}else if(LvAutoSort == 2){
			ListView_SortItems(hListView, CompareFunc, LvSortItem);

			i = ListView_GetNextNoReadItem(hListView, -1, ListView_GetItemCount(hListView));
			if(i != -1){
				//J[I
				ListView_SetItemState(hListView, -1, 0, LVIS_FOCUSED | LVIS_SELECTED);
				ListView_SetItemState(hListView, i,
					LVIS_FOCUSED | LVIS_SELECTED, LVIS_FOCUSED | LVIS_SELECTED);
			}

		}
		ListView_EnsureVisible(hListView,
			ListView_GetNextItem(hListView, -1, LVNI_FOCUSED), TRUE);
		SwitchCursor(TRUE);

		EndThreadSortFlag = FALSE;
	}

	//ʐMĨTEhAexeN\ɂ (nPOP-Q)
#ifndef _UNICODE
		#define wcsrchr 	strrchr
#endif
	if(ExecFlag == TRUE && ExecEndSound == 1){
		int fBuzzer = FALSE;
		if(ExecEndSoundFile == NULL || *ExecEndSoundFile == '\0') {
			fBuzzer = TRUE;
		}
		else {
			TCHAR* p = wcsrchr (ExecEndSoundFile, TEXT('.'));
			if (p == NULL) p = TEXT("");
			if (TStrCmpNI(p,TEXT(".wav"),4) != 0) {
				SHELLEXECUTEINFO sei;
				tZeroMemory(&sei, sizeof(SHELLEXECUTEINFO));
				sei.cbSize = sizeof(sei);
				sei.fMask = 0;
				sei.hwnd = NULL;
				sei.lpVerb = NULL;
				sei.lpFile = ExecEndSoundFile;
				sei.lpParameters = NULL;
				sei.lpDirectory = NULL;
				sei.nShow = SW_SHOWNORMAL;
				sei.hInstApp = hInst;
				if (ShellExecuteEx(&sei) == FALSE)
					fBuzzer = TRUE;
			}
			else {
				if (sndPlaySound(ExecEndSoundFile, SND_ASYNC | SND_NODEFAULT) == FALSE)
					fBuzzer = TRUE;
			}
		}
		if (fBuzzer) {
#ifdef _WIN32_WCE_LAGENDA
			MessageBuzzer(0xFFFFFFFF);
#else
			MessageBeep(MB_ICONASTERISK);
#endif
		}
	}
	ExecFlag = FALSE;
}


/******************************************************************************

	CheckEndAutoExec

	`FbN̎s

******************************************************************************/

static BOOL CheckEndAutoExec(HWND hWnd, int SocBox, int cnt, BOOL AllFlag)
{
	if(cnt == -1){
		return FALSE;
	}
	if(g_soc != -1){
		return FALSE;
	}

	if(AllFlag == TRUE){
		//s
		ShowError = TRUE;
		if(MailMarkCheck(hWnd, ((CheckEndExecNoDelMsg == 1) ? TRUE : FALSE), FALSE) == FALSE){
			ShowError = FALSE;
			return FALSE;
		}
		ShowError = FALSE;

		AutoCheckFlag = FALSE;
		AllCheck = TRUE;
		ExecFlag = FALSE;		//FALSE ɂ邱ƂŃ`FbNƎs̃[v
		KeyShowHeader = FALSE;
		CheckBox = MAILBOX_USER - 1;

		gSockFlag = TRUE;
		SetTimer(hWnd, ID_EXEC_TIMER, CHECKTIME, NULL);
	}else{
		//s
		if(Item_GetNextDonloadItem((MailBox + SocBox), -1, NULL) == -1 &&
			Item_GetNextDeleteItem((MailBox + SocBox), -1, NULL) == -1 &&
			Item_GetNextSendItem((MailBox + SocBox), -1, NULL) == -1){
			return FALSE;
		}
		if(CheckEndExecNoDelMsg == 1 && Item_GetNextDeleteItem((MailBox + SocBox), -1, NULL) != -1){
			ShowError = TRUE;
			if(MessageBox(hWnd, STR_Q_DELSERVERMAIL,
				STR_TITLE_EXEC, MB_ICONEXCLAMATION | MB_YESNO) == IDNO){
				ShowError = FALSE;
				return FALSE;
			}
			ShowError = FALSE;
		}
		AutoCheckFlag = FALSE;
		AllCheck = FALSE;
		ExecFlag = FALSE;		//FALSE ɂ邱ƂŃ`FbNƎs̃[v
		KeyShowHeader = FALSE;
		ExecItem(hWnd, SocBox);
	}

	// vr[ĕ` (nPOP-Q)
	EditView_RestNo2 (hWnd);

	return TRUE;
}


/******************************************************************************

	Init_NewMailFlag

	V[tȌ

******************************************************************************/

static void Init_NewMailFlag(void)
{
	int i;

	if(ShowMsgFlag == TRUE){
		return;
	}

	for(i = MAILBOX_USER; i < MailBoxCnt; i++){
		(MailBox + i)->NewMail = FALSE;
	}
}


/******************************************************************************

	NewMail_Massage

	V[`FbNʂ̃bZ[W

******************************************************************************/

static void NewMail_Massage(HWND hWnd, int cnt)
{
	TCHAR *p;
	int i, j;

	if(cnt == -1){
		return;
	}
	if(cnt == 0){
		if(ShowError == FALSE && ShowNoMailMessage == 1 && ShowMsgFlag == FALSE
			&& AutoCheckFlag == FALSE){
			//bZ[W{bNX̕\
			MessageBox(hWnd, STR_MSG_NONEWMAIL, WINDOW_TITLE,
				MB_ICONINFORMATION | MB_OK | MB_SETFOREGROUND);
		}
		return;
	}

	if(IsWindowVisible(hWnd) == 0 ||
#ifndef _WIN32_WCE
		IsIconic(hWnd) != 0 ||
#endif
		GetForegroundWindow() != hWnd){
		// (nPOP-Q)
		if (g_Winpos.TbIconType == 1) {
			int no = Tbico_NewMailNo();
			SetTrayIcon(hWnd, TrayIcon_Mail[no], WINDOW_TITLE);
		}
		else if (g_Winpos.TbIconType == 2) {
			int no = NewMailCnt;
			if (no > 9) no = 0;
			SetTrayIcon(hWnd, TrayIcon_Mail[no], WINDOW_TITLE);
		}
		else {
			SetTrayIcon(hWnd, TrayIcon_Mail[0], WINDOW_TITLE);
		}
		NewMail_Flag = TRUE;
	}

	//R{{bNXɐV "*" t
	j = SendDlgItemMessage(hWnd, IDC_COMBO, CB_GETCURSEL, 0, 0);
	for(i = MAILBOX_USER; i < MailBoxCnt; i++){
		if(SelBox == i || (MailBox + i)->NewMail == FALSE ||
			((ListGetLine > 0 || ShowHeader == 1 || ListDownload == 1) &&
			CheckNoReadMailBox(i, FALSE) == FALSE)){
			continue;
		}
		(MailBox + i)->NoRead = TRUE;
		SendDlgItemMessage(hWnd, IDC_COMBO, CB_DELETESTRING, i, 0);
		if((MailBox + i)->Name == NULL || *(MailBox + i)->Name == TEXT('\0')){
			SendDlgItemMessage(hWnd, IDC_COMBO, CB_INSERTSTRING, i,
				(LPARAM)STR_MAILBOX_NONAME\
				TEXT(" *"));
		}else{
			p = (TCHAR *)LocalAlloc(LMEM_FIXED, sizeof(TCHAR) * (lstrlen((MailBox + i)->Name) + 3));
			if(p != NULL){
				TStrJoin(p, (MailBox + i)->Name, TEXT(" *"), (TCHAR *)-1);
				SendDlgItemMessage(hWnd, IDC_COMBO, CB_INSERTSTRING, i, (LPARAM)p);
				LocalFree(p);
			}
		}
		// c[̍ڂZbgȂ (nPOP-Q)
		if (g_hTreeView) TreeView_SelMailBox (g_hTreeView, i, TRUE);
	}
	SendDlgItemMessage(hWnd, IDC_COMBO, CB_SETCURSEL, j, 0);

	SetNoReadCntTitle(hWnd);

	//Ṽ[{bNX̃CfbNX擾
	for(i = MAILBOX_USER; i < MailBoxCnt; i++){
		if((MailBox + i)->NewMail == TRUE){
			break;
		}
	}

	//VTEhAexeN\ɂ (nPOP-Q)
#ifndef _UNICODE
		#define wcsrchr 	strrchr
#endif
	if(NewMailSound == 1){
		int fBuzzer = FALSE;
		if(NewMailSoundFile == NULL || *NewMailSoundFile == '\0') {
			fBuzzer = TRUE;
		}
		else {
			TCHAR* p = wcsrchr (NewMailSoundFile, TEXT('.'));
			if (p == NULL) p = TEXT("");
			if (TStrCmpNI(p,TEXT(".wav"),4) != 0) {
				SHELLEXECUTEINFO sei;
				tZeroMemory(&sei, sizeof(SHELLEXECUTEINFO));
				sei.cbSize = sizeof(sei);
				sei.fMask = 0;
				sei.hwnd = NULL;
				sei.lpVerb = NULL;
				sei.lpFile = NewMailSoundFile;
				sei.lpParameters = NULL;
				sei.lpDirectory = NULL;
				sei.nShow = SW_SHOWNORMAL;
				sei.hInstApp = hInst;
				if (ShellExecuteEx(&sei) == FALSE)
					fBuzzer = TRUE;
			}
			else {
				if (sndPlaySound(NewMailSoundFile, SND_ASYNC | SND_NODEFAULT) == FALSE)
					fBuzzer = TRUE;
			}
		}
		if (fBuzzer) {
#ifdef _WIN32_WCE_LAGENDA
			MessageBuzzer(0xFFFFFFFF);
#else
			MessageBeep(MB_ICONASTERISK);
#endif
		}
	}

	//bZ[W{bNX̕\
#ifdef _WCE_OLD
	//bZ[W\Ȃݒ肩ݕ\Ă郁[{bNX̏ꍇ̓bZ[W{bNXoȂ
	if(ShowError == TRUE || ShowNewMailMessgae == 0 ||
		(AutoCheckFlag == FALSE && hWnd == GetForegroundWindow() && i == SelBox)){
		return;
	}
	if(MsgWnd == NULL){
		CreateDialogParam(hInst, MAKEINTRESOURCE(IDD_DIALOG_MSG), NULL, NewMailMessageProc, 0);
	}else{
		ShowWindow(MsgWnd, SW_SHOW);
		_SetForegroundWindow(MsgWnd);
	}
#else
	//bZ[W\Ȃݒ肩ݕ\Ă郁[{bNX̏ꍇ̓bZ[W{bNXoȂ
	if(ShowError == TRUE || ShowNewMailMessgae == 0 || ShowMsgFlag == TRUE ||
		(AutoCheckFlag == FALSE && hWnd == GetForegroundWindow() && i == SelBox)){
		return;
	}
	SendMessage(MsgWnd,	WM_SHOWDIALOG, 0, 0);
#endif

}


/******************************************************************************

	WndProc

	CEBhEvV[W

******************************************************************************/

static LRESULT CALLBACK WndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	static BOOL SepMoveFlag;	// Xsbgo[ړ (nPOP-Q)
	static int  SepMoveType;	// 0:c 1: 2:E 3:Ec (nPOP-Q)
#if defined(_WIN32_WCE_PPC) || defined(_WIN32_WCE_LAGENDA)
	static BOOL SipFlag = FALSE;
#endif
	static BOOL save_flag = FALSE;
	int i;
#ifdef _CENET
	static POINT pos;
	static POINT pst;
	static RECT rcwnd;
	static int nSizeBorder = 0;
#endif

	switch(msg)
	{
	case WM_CREATE:
		MainWnd = hWnd;
		SwitchCursor(FALSE);

#ifdef _WIN32_WCE_LAGENDA
		GetClientRect(hWnd, &wnd_size);
#endif

		//[{bNX̏
		if(InitMailBox() == FALSE){
			SwitchCursor(TRUE);
			ErrorMessage(NULL, STR_ERR_INIT);
			DestroyWindow(hWnd);
			break;
		}

		//INIt@C̓ǂݍ
		if(GetINI(hWnd) == FALSE){
			SwitchCursor(TRUE);
			ErrorMessage(NULL, STR_ERR_INIT);
			DestroyWindow(hWnd);
			break;
		}

		if(ReadMailBox() == FALSE){
			SwitchCursor(TRUE);
			ErrorMessage(NULL, STR_ERR_INIT);
			DestroyWindow(hWnd);
			break;
		}

#ifndef _WIN32_WCE
		SetWindowPos(hWnd, 0, MainRect.left, MainRect.top, MainRect.right, MainRect.bottom,
			SWP_NOZORDER | SWP_HIDEWINDOW);
#endif
#ifdef _CENET
		SetWindowPos(hWnd, 0, MainRect.left, MainRect.top, MainRect.right, MainRect.bottom,
			SWP_NOZORDER | SWP_HIDEWINDOW);
#endif

		//EBhẼRg[̍쐬
		if(InitWindow(hWnd) == FALSE){
			SwitchCursor(TRUE);
			ErrorMessage(NULL, STR_ERR_INIT);
			DestroyWindow(hWnd);
			break;
		}
		SelectMailBox(hWnd, MAILBOX_USER);

		if(SocLog == 1) LogClear(AppDir, LOG_FILE);
		SwitchCursor(TRUE);

		//^XNgC̐ݒ
		TrayIcon_Main = LoadImage(hInst, MAKEINTRESOURCE(IDI_ICON_NOCHECK),
			IMAGE_ICON, SICONSIZE, SICONSIZE, 0);
		TrayIcon_Check = LoadImage(hInst, MAKEINTRESOURCE(IDI_ICON_CHECK),
			IMAGE_ICON, SICONSIZE, SICONSIZE, 0);
		// (nPOP-Q)
		{	int id[10] = {IDI_ICON_MAIN,IDI_MAIL01,IDI_MAIL02,IDI_MAIL03,IDI_MAIL04,IDI_MAIL05,IDI_MAIL06,IDI_MAIL07,IDI_MAIL08,IDI_MAIL09};
			int i;
			for (i = 0; i < 10; i++) {
			TrayIcon_Mail[i] = LoadImage(hInst, MAKEINTRESOURCE(id[i]),
				IMAGE_ICON, SICONSIZE, SICONSIZE, 0);
			}
		}
		if(ShowTrayIcon == 1 && TrayIcon_Main != NULL){
			TrayMessage(hWnd, NIM_ADD, TRAY_ID, TrayIcon_Main, WINDOW_TITLE);
		}

		//`FbNp^C}[̋N
		if(AutoCheck == 1){
			SetTimer(hWnd, ID_AUTOCHECK_TIMER, AUTOCHECKTIME, NULL);
		}

		//N
		if(first_start == TRUE){
			ShowWindow(hWnd, SW_SHOW);
			SetMailBoxOption(hWnd);
			PutINI(hWnd, FALSE);
			break;
		}
		
		//N`FbN̊Jn
		if(StartCheck == 1){
			SendMessage(hWnd, WM_COMMAND, ID_MENUITEM_ALLCHECK, 0);
		}

		//R}hC̃[AhX烁[̕ҏW
		if(CmdLine != NULL){
			SetTimer(hWnd, ID_NEWMAIL_TIMER, 1, NULL);
		}
		break;

	case WM_COPYDATA:
#ifdef _WIN32_WCE
		CloseViewWindow(1);
		FocusWnd = hWnd;
		ShowWindow(hWnd, SW_SHOW);
		if(CommandLine(hWnd, CmdLine) == TRUE){
			_SetForegroundWindow(hWnd);
			if(Edit_MailToSet(hInst, hWnd, ((PCOPYDATASTRUCT)lParam)->lpData, -1) == EDIT_INSIDEEDIT){
				ShowWindow(hWnd, SW_HIDE);
			}
		}
#else
		if(ShowPass == 1 &&
			(IsWindowVisible(hWnd) == 0 || IsIconic(hWnd) != 0) &&
			Password != NULL && *Password != TEXT('\0') &&
			ConfirmPass(hWnd, Password) == FALSE){
			break;
		}
		if(CommandLine(hWnd, ((PCOPYDATASTRUCT)lParam)->lpData) == TRUE){
			Edit_MailToSet(hInst, hWnd, ((PCOPYDATASTRUCT)lParam)->lpData, -1);
		}
#endif
		break;

#ifdef _WIN32_WCE_LAGENDA
	case COSH_EXECUTEAPP:
		//2dN
		{
			TCHAR buf[BUF_SIZE];

			tZeroMemory(buf, sizeof(TCHAR) * BUF_SIZE);
			if(CoshGetCommandLine(hWnd, lParam, buf, BUF_SIZE) == FALSE || *buf == TEXT('\0')){
				SendMessage(hWnd, WM_SHOWLASTWINDOW, 0, 0);
				break;
			}
			CloseViewWindow(1);
			FocusWnd = hWnd;
			ShowWindow(hWnd, SW_SHOW);
			_SetForegroundWindow(hWnd);
			if(CommandLine(hWnd, buf) == TRUE && Edit_MailToSet(hInst, hWnd, buf, -1) == EDIT_INSIDEEDIT){
				ShowWindow(hWnd, SW_HIDE);
			}
		}
		break;
#endif

#ifdef _WIN32_WCE_PPC
	case WM_SETTINGCHANGE:
		if (SPI_SETSIPINFO == wParam && GetForegroundWindow() == hWnd){
			SHACTIVATEINFO sai;

			memset(&sai, 0, sizeof(SHACTIVATEINFO));
			SHHandleWMSettingChange(hWnd, -1, 0, &sai);
			SipFlag = sai.fSipUp;
			//SetWindowSize(hWnd, 0, 0);
			SetWindowSize(hWnd, 0, 0, FALSE);	// (nPOP-Q)

			ListView_EnsureVisible(GetDlgItem(hWnd, IDC_LISTVIEW),
				ListView_GetNextItem(GetDlgItem(hWnd, IDC_LISTVIEW), -1, LVNI_FOCUSED), TRUE);
		}
		break;
#elif defined _WIN32_WCE_LAGENDA
	case WM_SETTINGCHANGE:
		if(SPI_SETSIPINFO == wParam && GetForegroundWindow() == hWnd){
			SipFlag = SetWindowSize(hWnd, 0, 0);

			ListView_EnsureVisible(GetDlgItem(hWnd, IDC_LISTVIEW),
				ListView_GetNextItem(GetDlgItem(hWnd, IDC_LISTVIEW), -1, LVNI_FOCUSED), TRUE);
		}
		break;
#endif

	//Ëړ  (nPOP-Q)
	case WM_LBUTTONDOWN:
		if(GetForegroundWindow() != hWnd){
			break;
		}
#ifdef _CENET
		{
			int x = LOWORD(lParam);
			int y = HIWORD(lParam);
			RECT rccnt;
			GetClientRect (hWnd, &rccnt);
			GetWindowRect (hWnd, &rcwnd);
			if (x >= rccnt.right - 4 - 4) {
				pos.x = pst.x = x;
				pos.y = pst.y = y;
				nSizeBorder = 1;
				SetCapture(hWnd);
				break;
			}
		}
#endif
		if(SepMoveFlag == FALSE){
			POINT cur, ccc;
			ccc.x = cur.x = LOWORD (lParam);
			ccc.y = cur.y = HIWORD (lParam);
			ClientToScreen (hWnd, &cur);
			if(FrameInitialize(hWnd) == FALSE){
				break;
			}
			SepMoveFlag = TRUE;
			SepMoveType = -1;	// 0:c 1: 2:E 3:Ec 

			if (ccc.x >= g_Winpos.xVertSplit && ccc.x <= g_Winpos.xVertSplit+SEPWIDE)
				SepMoveType = 0;

			if (ccc.x < g_Winpos.xVertSplit-2) 
				SepMoveType = 1;

			if (g_Winpos.typSmpView == 0 &&
				ccc.x > g_Winpos.xVertSplit+SEPWIDE+2)
				SepMoveType = 2;

			if (g_Winpos.typSmpView == 1 &&
				ccc.x > g_Winpos.xVertSplit+SEPWIDE+2)
				SepMoveType = 3;

			if (SepMoveType == -1) {
				SepMoveFlag = FALSE;
				break;
			}
			switch (SepMoveType) {
			case 0:
				SetCursor (LoadCursor(hInst, MAKEINTRESOURCE(IDC_CURSOR_SEP)));
				FrameDraw(hWnd, cur.x, cur.y);
				break;
			case 1:
				SetCursor (LoadCursor(hInst, MAKEINTRESOURCE(IDC_CURSOR_HSP)));
				FrameDrawHL(hWnd, cur.x, cur.y);
				break;
			case 2:
				SetCursor (LoadCursor(hInst, MAKEINTRESOURCE(IDC_CURSOR_HSP)));
				FrameDrawHR(hWnd, cur.x, cur.y);
				break;
			case 3:
				SetCursor (LoadCursor(hInst, MAKEINTRESOURCE(IDC_CURSOR_SEP)));
				FrameDraw(hWnd, cur.x, cur.y);
				break;
			}
			SetTimer(hWnd, TIMER_SEP, 100, NULL);
		}
		break;

	case WM_MOUSEMOVE:
#ifdef _CENET
		{
			if (nSizeBorder) {
				int x = LOWORD(lParam);
				int y = HIWORD(lParam);
				if (abs(pst.x-x) > 4 || abs(pst.y-y) >= 2) {
					int mx, my;
					int sx, sy;
					pst.x = x;
					pst.y = y;
					mx = x - pos.x;
					my = y - pos.y;
					sx = rcwnd.right  - rcwnd.left + mx;
					sy = rcwnd.bottom - rcwnd.top  + my;
					SetWindowPos (hWnd, HWND_TOP, rcwnd.left,rcwnd.top, sx,sy, 0);
				}
				break;
			}
		}
#endif
		if(SepMoveFlag == TRUE){
			POINT cur;
			cur.x = LOWORD (lParam);
			cur.y = HIWORD (lParam);
			if (SepMoveType == 3) {
				if (cur.x < g_Winpos.xVertSplit+SEPWIDE+2)
					cur.x = g_Winpos.xVertSplit+SEPWIDE+2;
			}
			ClientToScreen (hWnd, &cur);
			switch (SepMoveType) {
			case 0:
				FrameDraw(hWnd, cur.x, cur.y);
				break;
			case 1:
				FrameDrawHL(hWnd, cur.x, cur.y);
				break;
			case 2:
				FrameDrawHR(hWnd, cur.x, cur.y);
				break;
			case 3:
				FrameDraw(hWnd, cur.x, cur.y);
				break;
			}
		}
		break;

	case WM_LBUTTONUP:
#ifdef _CENET
		{
			if (nSizeBorder) {
				nSizeBorder = 0;
				ReleaseCapture();
				break;
			}
		}
#endif
		if(SepMoveFlag == TRUE){
			int ret;
			RECT rect;
			SetCursor(LoadCursor(hInst, MAKEINTRESOURCE(IDC_CURSOR_CNT)));
			SepMoveFlag = FALSE;

			KillTimer(hWnd, TIMER_SEP);
			GetClientRect (hWnd, &rect);

			ret = FrameDrawEnd(hWnd);
			switch (SepMoveType) {
			case 0:
				if(LOWORD(ret) != -1) g_Winpos.xVertSplit = LOWORD(ret);
				break;
			case 1:
				if(HIWORD(ret) != -1) g_Winpos.yLeftSplit = HIWORD(ret);
				break;
			case 2:
				if(HIWORD(ret) != -1) g_Winpos.yRightSplit = HIWORD(ret);
				break;
			case 3:
				if(LOWORD(ret) != -1) g_Winpos.xRightSplit = rect.right - LOWORD(ret);
				break;
			}
			SetWindowSize(hWnd, 0, 0, FALSE);
		}
		break;
	//--------

	case WM_SIZE:
#ifndef _WIN32_WCE
		if(wParam == SIZE_MINIMIZED) {
			confirm_flag = 1;
		} 
#endif
		if(wParam == SIZE_MINIMIZED && ShowTrayIcon == 1 && MinsizeHide == 1){
			ShowWindow(hWnd, SW_HIDE);
			return 0;
		}
#ifndef _WIN32_WCE
		if(ShowPass == 1 &&
			(wParam == SIZE_RESTORED || wParam == SIZE_MAXIMIZED) &&
			Password != NULL && *Password != TEXT('\0') && confirm_flag == 1) {
			ShowWindow(hWnd, SW_MINIMIZE);
			return 0;
		}
		SetWindowSize(hWnd, wParam, lParam, TRUE);	// (nPOP-Q)
		if(wParam != SIZE_MINIMIZED) {
			confirm_flag = 0;
		} 
#endif
		break;

#ifndef _WIN32_WCE
	case WM_EXITSIZEMOVE:
		if(IsWindowVisible(hWnd) != 0 &&
			IsIconic(hWnd) == 0 && IsZoomed(hWnd) == 0){
			GetWindowRect(hWnd, (LPRECT)&MainRect);
			MainRect.right -= MainRect.left;
			MainRect.bottom -= MainRect.top;
		}
		break;

	case WM_QUERYENDSESSION:
		if(SaveWindow(hWnd) == FALSE){
			return FALSE;
		}
		save_flag = TRUE;
		return TRUE;

	case WM_ENDSESSION:
		EndWindow(hWnd);
		return 0;
#endif

#ifdef _WIN32_WCE
	case WM_HIBERNATE:
		CloseViewWindow(1);
		FocusWnd = hWnd;
		break;
#endif

	case WM_CLOSE:
		if(ShowTrayIcon == 1 && CloseHide == 1){
			ShowWindow(hWnd, SW_HIDE);
#ifdef _WIN32_WCE
			CloseViewWindow(1);
#endif
			FocusWnd = hWnd;
#ifdef _WIN32_WCE_LAGENDA
			ShowWindow(hWnd, SW_SHOW);
#endif
			break;
		}
		if(SaveWindow(hWnd) == FALSE){
			break;
		}
		save_flag = TRUE;
		EndWindow(hWnd);
		break;

	case WM_DESTROY:
		if (save_flag == FALSE) {
			SaveWindow(hWnd);
		}
		PostQuitMessage(0);
		break;

	case WM_NOTIFY:
		return NotifyProc(hWnd, wParam, lParam);

	case WM_SETFOCUS:
#ifdef _WIN32_WCE_PPC
		SHSipPreference(hWnd, (SipFlag) ? SIP_UP : SIP_DOWN);
#elif defined _WIN32_WCE_LAGENDA
		SipShowIM((SipFlag) ? SIPF_ON : SIPF_OFF);
#endif
		SetFocus(GetDlgItem(hWnd, IDC_LISTVIEW));
	case WM_INITTRAYICON:
		if(g_soc == -1){
			SetTrayIcon(hWnd, TrayIcon_Main, WINDOW_TITLE);
		}
		NewMail_Flag = FALSE;
		break;

	case WM_TIMER:
		switch(wParam)
		{
		//Ëړ (nPOP-Q)
		case TIMER_SEP:
			if(hWnd != GetForegroundWindow() || GetAsyncKeyState(VK_ESCAPE) < 0)
			//	GetAsyncKeyState(VK_RBUTTON) < 0)
			{
				KillTimer(hWnd, wParam);
				FrameFree();
				SepMoveFlag = FALSE;
				InvalidateRect(hWnd, NULL, FALSE);
				UpdateWindow(hWnd);
			}
			break;

		// Tv\  (nPOP-Q)
		case TIMER_VIEW:
			KillTimer(hWnd, wParam);
			{
				if (g_fEditView == 0) {
					g_fEditView = 1;
					if (g_hEditView)
						EditView_SetText(hWnd, SelBox);
					g_fEditView = 0;
				}
			}
			break;

#ifndef WSAASYNC
		//M
		case ID_RECV_TIMER:
			if(g_soc == -1){
				KillTimer(hWnd, wParam);
				if(AllCheck == FALSE){
					if(CheckEndExec == 1 &&
						CheckEndAutoExec(hWnd, RecvBox, NewMailCnt, FALSE) == TRUE){
						//`FbNs
						break;
					}
					if(ExecFlag == TRUE && CheckAfterUpdate == 1 && RecvBox != MAILBOX_SEND){
						//s`FbN
						ExecFlag = FALSE;
						RecvMailList(hWnd, RecvBox, FALSE);
						break;
					}
					RecvBox = -1;
					EndSocketFunc(hWnd);
					NewMail_Massage(hWnd, NewMailCnt);
				}else{
					RecvBox = -1;
					SetMailMenu(hWnd);
				//	SetItemCntStatusText(hWnd, NULL);
				}
				break;
			}
			switch(RecvSelect(hWnd, g_soc))
			{
			//G[
			case SELECT_MEM_ERROR:
				ErrorSocketEnd(hWnd, RecvBox);
				SocketErrorMessage(hWnd, STR_ERR_MEMALLOC, RecvBox);
				break;

			//selectG[
			case SELECT_SOC_ERROR:
				ErrorSocketEnd(hWnd, RecvBox);
				SocketErrorMessage(hWnd, STR_ERR_SOCK_SELECT, RecvBox);
				break;

			//ؒf
			case SELECT_SOC_CLOSE:
				if(MailFlag != POP_QUIT){
					ErrorSocketEnd(hWnd, RecvBox);
					SocketErrorMessage(hWnd, STR_ERR_SOCK_DISCONNECT, RecvBox);
				}else{
					SocketClose(hWnd, g_soc);
					KillTimer(hWnd, ID_TIMEOUT_TIMER);
					g_soc = -1;
					SetItemCntStatusText(hWnd, NULL);
				}
				break;

			//Mf[^L
			case SELECT_SOC_SUCCEED:
				SetTimer(hWnd, ID_TIMEOUT_TIMER, TIMEOUTTIME * TimeoutInterval, NULL);
				break;
			}
			break;
#endif
		//PM
		case ID_SMTP_ONE_TIMER:
			if(g_soc != -1){
				break;
			}
			if(SmtpWait > 0){
				SmtpWait--;
				break;
			}
			KillTimer(hWnd, wParam);

			AutoCheckFlag = FALSE;
			AllCheck = FALSE;
			ExecFlag = TRUE;
			KeyShowHeader = FALSE;
			gSockFlag = FALSE;

			//[̑M
			SendMail(hWnd, (struct TPMAILITEM *)wkSendMailItem, SMTP_SENDEND);
			wkSendMailItem = NULL;
			break;

		//M
		case ID_SMTP_TIMER:
			if(g_soc != -1){
				break;
			}
			if(SmtpWait > 0){
				SmtpWait--;
				break;
			}
			if(CheckBox >= MAILBOX_USER &&
				Item_GetNextMailBoxSendItem((MailBox + MAILBOX_SEND), -1, CheckBox) != -1){
				//[̑M
				SendMail(hWnd, *((MailBox + MAILBOX_SEND)->tpMailItem +
					Item_GetNextMailBoxSendItem((MailBox + MAILBOX_SEND), -1, CheckBox)), SMTP_NEXTSEND);
				break;
			}

			CheckBox++;
			if(CheckBox >= MailBoxCnt){
				KillTimer(hWnd, wParam);
				gSockFlag = FALSE;
				EndSocketFunc(hWnd);
				NewMail_Massage(hWnd, NewMailCnt);
				break;
			}
			if((MailBox + CheckBox)->PopBeforeSmtp != 0 &&
				Item_GetNextMailBoxSendItem((MailBox + MAILBOX_SEND), -1, CheckBox) != -1){
				//POP before SMTP
				if(RasCon == 1 && SendMessage(hWnd, WM_RAS_START, CheckBox, 0) == FALSE){
					ErrorSocketEnd(hWnd, CheckBox);
					SetMailMenu(hWnd);
					break;
				}
				if(PopBeforeSmtpIsLoginOnly == 0 && NewMailCnt == -1) NewMailCnt = 0;
				RecvMailList(hWnd, CheckBox, (PopBeforeSmtpIsLoginOnly == 1) ? TRUE : FALSE);
				SmtpWait = PopBeforeSmtpWait / SMTPTIME;
			}
			break;

		//`FbN
		case ID_CHECK_TIMER:
			if(g_soc != -1){
				break;
			}

			CheckBox++;
			if(CheckBox >= MailBoxCnt){
				//ׂẴ[{bNX̃`FbN
				KillTimer(hWnd, wParam);
				gSockFlag = FALSE;
				if(CheckEndExec == 1 &&
					CheckEndAutoExec(hWnd, 0, NewMailCnt, TRUE) == TRUE){
					//`FbNs
					break;
				}
				EndSocketFunc(hWnd);
				NewMail_Massage(hWnd, NewMailCnt);
				AutoCheckFlag = FALSE;
				break;
			}
			//񂵂Ȃݒ̃[{bNX
			if((MailBox + CheckBox)->CyclicFlag == 1){
				break;
			}
			//_CAbvJn
			if(RasCon == 1 && SendMessage(hWnd, WM_RAS_START, CheckBox, 0) == FALSE){
				ErrorSocketEnd(hWnd, CheckBox);
				SetMailMenu(hWnd);
				break;
			}
			//[MJn
			RecvMailList(hWnd, CheckBox, FALSE);
			break;

		//s
		case ID_EXEC_TIMER:
			if(g_soc != -1){
				break;
			}
			if(SmtpWait > 0){
				SmtpWait--;
				break;
			}
			if(CheckBox >= MAILBOX_USER && (MailBox + CheckBox)->CyclicFlag == 0 &&
				Item_GetNextMailBoxSendItem((MailBox + MAILBOX_SEND), -1, CheckBox) != -1){
				//M[̎s (POP before SMTP)
				SendMail(hWnd, *((MailBox + MAILBOX_SEND)->tpMailItem +
					Item_GetNextMailBoxSendItem((MailBox + MAILBOX_SEND), -1, CheckBox)), SMTP_NEXTSEND);
				break;
			}
			if(CheckBox >= MAILBOX_USER && (MailBox + CheckBox)->CyclicFlag == 0 &&
				CheckAfterUpdate == 1 && ExecCheckFlag == FALSE){
				//s`FbN
				RecvMailList(hWnd, CheckBox, FALSE);
				ExecCheckFlag = TRUE;
				break;
			}
			ExecCheckFlag = FALSE;

			CheckBox++;
			if(CheckBox >= MailBoxCnt){
				KillTimer(hWnd, wParam);
				if(Item_GetNextSendItem((MailBox + MAILBOX_SEND), -1, NULL) != -1){
					//M
					ExecItem(hWnd, MAILBOX_SEND);
					break;
				}
				//sI
				gSockFlag = FALSE;
				EndSocketFunc(hWnd);
				NewMail_Massage(hWnd, NewMailCnt);
				break;
			}
			//񂵂Ȃݒ̃[{bNX
			if((MailBox + CheckBox)->CyclicFlag == 1){
				break;
			}
			if(Item_GetNextDonloadItem((MailBox + CheckBox), -1, NULL) != -1 ||
				Item_GetNextDeleteItem((MailBox + CheckBox), -1, NULL) != -1 ||
				CheckAfterUpdate == 1){
				//_CAbvJn
				if(RasCon == 1 && SendMessage(hWnd, WM_RAS_START, CheckBox, 0) == FALSE){
					ErrorSocketEnd(hWnd, CheckBox);
					SetMailMenu(hWnd);
					break;
				}
			}
			//}[Ns
			i = ExecItem(hWnd, CheckBox);
			if((MailBox + CheckBox)->PopBeforeSmtp != 0 &&
				Item_GetNextMailBoxSendItem((MailBox + MAILBOX_SEND), -1, CheckBox) != -1){
				if(i == FALSE){
					//POP before SMTP
					if(PopBeforeSmtpIsLoginOnly == 0 && NewMailCnt == -1) NewMailCnt = 0;
					RecvMailList(hWnd, CheckBox, (PopBeforeSmtpIsLoginOnly == 1) ? TRUE : FALSE);
				}
				SmtpWait = PopBeforeSmtpWait / SMTPTIME;
			}
			break;

		//`FbN
		case ID_AUTOCHECK_TIMER:
			if(AutoCheck == 0){
				KillTimer(hWnd, wParam);
				AutoCheckCnt = 0;
				break;
			}
			AutoCheckCnt++;
			if(AutoCheckCnt < AutoCheckTime){
				break;
			}
			AutoCheckCnt = 0;

			if(g_soc != -1 || ShowError == TRUE){
				break;
			}
			AutoCheckFlag = TRUE;
			AllCheck = TRUE;
			KeyShowHeader = FALSE;
			NewMailCnt = 0;
			CheckBox = MAILBOX_USER - 1;
			Init_NewMailFlag();

			gSockFlag = TRUE;
			ExecFlag = FALSE;
			SetTimer(hWnd, ID_CHECK_TIMER, CHECKTIME, NULL);
			break;

		//^CAEg
		case ID_TIMEOUT_TIMER:
			if(g_soc == -1){
				KillTimer(hWnd, wParam);
				break;
			}
			ErrorSocketEnd(hWnd, RecvBox);
			SocketErrorMessage(hWnd, STR_ERR_SOCK_TIMEOUT, RecvBox);
			break;

		//NbZ[W쐬
		case ID_NEWMAIL_TIMER:
			KillTimer(hWnd, wParam);
			if(CmdLine != NULL){
				if(CommandLine(hWnd, CmdLine) == TRUE && Edit_MailToSet(hInst, hWnd, CmdLine, -1) == EDIT_INSIDEEDIT){
#ifdef _WIN32_WCE
					ShowWindow(hWnd, SW_HIDE);
#endif
				}
				LocalFree(CmdLine);
				CmdLine = NULL;
				break;
			}
			break;

		//RAS̑ҋ@
		case ID_RASWAIT_TIMER:
			KillTimer(hWnd, wParam);
			if(hEvent != NULL){
				SetEvent(hEvent);
			}
			break;
		}
		break;

	case WM_COMMAND:
		switch (GET_WM_COMMAND_ID(wParam, lParam))
		{
		//ȈՃAhX_uNbN (nPOP-Q)
		case IDC_ADRLIST:
			switch (HIWORD(wParam)) {
			case LBN_DBLCLK:
				AdrList_SendMail(hWnd);
				break;
			}
			break;

		//\AJEg̐؂ւ
		case IDC_COMBO:
			if(HIWORD(wParam) == CBN_CLOSEUP){
				if(SelBox == SendDlgItemMessage(hWnd, IDC_COMBO, CB_GETCURSEL, 0, 0)){
					break;
				}
				SetFocus(GetDlgItem(hWnd, IDC_LISTVIEW));
				SelectMailBox(hWnd, SendDlgItemMessage(hWnd, IDC_COMBO, CB_GETCURSEL, 0, 0));
				SwitchCursor(TRUE);
			}
			break;

		//̃AJEgɈړ
		case ID_KEY_ALTUP:
			if(SelBox == 0){
				break;
			}
			SelectMailBox(hWnd, SelBox - 1);
			break;

		//̃AJEgɈړ
		case ID_KEY_ALTDOWN:
			if(SelBox + 1 >= MailBoxCnt){
				break;
			}
			SelectMailBox(hWnd, SelBox + 1);
			break;

		//R{{bNXƃXgr[̃tH[JX؂ւ
		case ID_KEY_TAB:
			SetFocus(GetDlgItem(hWnd, (GetFocus() == GetDlgItem(hWnd, IDC_LISTVIEW))
				? IDC_COMBO : IDC_LISTVIEW));
			break;

		//IACëʒuɃ|bvAbvj[\
		case ID_KEY_SHOWMENU:
		case ID_KEY_ESC:
			if(IsWindowVisible(hWnd) == 0 ||
#ifndef _WIN32_WCE
				IsIconic(hWnd) != 0 ||
#endif
				GetForegroundWindow() != hWnd){
				break;
			}
			if(GetFocus() == GetDlgItem(hWnd, IDC_COMBO)){
				if(SendDlgItemMessage(hWnd, IDC_COMBO, CB_GETDROPPEDSTATE, 0, 0) == FALSE){
					SetFocus(GetDlgItem(hWnd, IDC_LISTVIEW));
				}else{
					SendDlgItemMessage(hWnd, IDC_COMBO, CB_SHOWDROPDOWN, FALSE, 0);
				}
				break;
			}
			SetFocus(GetDlgItem(hWnd, IDC_LISTVIEW));
#ifdef _WIN32_WCE
#ifdef _WIN32_WCE_PPC
			ShowMenu(hWnd, SHGetSubMenu(hMainToolBar, ID_MENUITEM_MAIL), 0, 1, FALSE);
#elif defined(_WIN32_WCE_LAGENDA)
			ShowMenu(hWnd, hMainMenu, MailMenuPos, 1, FALSE);
#else
			ShowMenu(hWnd, CommandBar_GetMenu(GetDlgItem(hWnd, IDC_CB), 0), MailMenuPos, 1, FALSE);
#endif
#else
			ShowMenu(hWnd, GetMenu(hWnd), MailMenuPos, 1, FALSE);
#endif
			break;

		//}EẌʒuɃ|bvAbvj[\
		case ID_MENU:
#ifdef _WIN32_WCE
#ifdef _WIN32_WCE_PPC
			ShowMenu(hWnd, SHGetSubMenu(hMainToolBar, ID_MENUITEM_MAIL), 0, 0, FALSE);
#elif defined(_WIN32_WCE_LAGENDA)
			ShowMenu(hWnd, hMainMenu, MailMenuPos, 1, FALSE);
#else
			ShowMenu(hWnd, CommandBar_GetMenu(GetDlgItem(hWnd, IDC_CB), 0), MailMenuPos, 0, FALSE);
#endif
#else
			ShowMenu(hWnd, GetMenu(hWnd), MailMenuPos, 0, FALSE);
#endif
			break;

		//====== t@C =========
		//bZ[W̍쐬
		case ID_MENUITEM_NEWMAIL:
#ifndef _WIN32_WCE
			if(ShowPass == 1 &&
				(IsWindowVisible(hWnd) == 0 || IsIconic(hWnd) != 0) &&
				Password != NULL && *Password != TEXT('\0') &&
				ConfirmPass(hWnd, Password) == FALSE){
				break;
			}
#endif
			if(Edit_InitInstance(hInst, hWnd, -1, NULL, EDIT_NEW, 0) == EDIT_INSIDEEDIT){
#ifdef _WIN32_WCE
#ifndef _CENET
				ShowWindow(hWnd, SW_HIDE);
#endif
#endif
			}
			break;

		//AhX̃[ (nPOP-Q)
		case ID_MENUITEM_ADRMAIL:
			AdrList_SendMail(hWnd);
			break;

		//AhX̃j[ (nPOP-Q)
		case ID_MENU_ADDR:
			ShowMenu(hWnd, hPOPUP, 1, 0, FALSE);
			break;

		//c[̃j[ (nPOP-Q)
		case ID_MENU_TREE:
			{
				int Sel;
				HWND      hTreeView = GetDlgItem(hWnd, IDC_TREEVIEW);
				HTREEITEM hTreeSele  = (HTREEITEM)SendDlgItemMessage(hWnd, 
					IDC_TREEVIEW, TVM_GETNEXTITEM, TVGN_DROPHILITE, 0);
				if(hTreeSele == NULL){
					hTreeSele = TreeView_GetSelection(hTreeView);
				}
				TreeView_SelectDropTarget(hTreeView, hTreeSele);
				Sel = TreeView_GetIndex (hTreeSele);
				if (Sel > 0) {
					SelectMailBox(hWnd, Sel);
#ifdef _WIN32_WCE
					ShowMenu(hWnd, CommandBar_GetMenu(GetDlgItem(hWnd, IDC_CB), 0), 1, 3, FALSE);
#else
					ShowMenu(hWnd, GetMenu(hWnd), 1, 3, FALSE);
#endif
				}
				TreeView_SelectDropTarget(hTreeView, NULL);
			}
			break;

		//AhX
		case ID_MENUITEM_ADDRESS:
			DialogBoxParam(hInst, MAKEINTRESOURCE(IDD_DIALOG_ADDRESS),
				hWnd, AddressListProc, 0);
			break;

		//IvV
		case ID_MENUITEM_OPTION:
			SetOption(hWnd);

			SwitchCursor(FALSE);
			//`FbN^C}[̐ݒ
			if(AutoCheck == 1){
				SetTimer(hWnd, ID_AUTOCHECK_TIMER, AUTOCHECKTIME, NULL);
			}else{
				KillTimer(hWnd, ID_AUTOCHECK_TIMER);
				AutoCheckCnt = 0;
			}
			//^XNgC̃ACR̐ݒ
			if(ShowTrayIcon == 1){
				SetTrayIcon(hWnd, TrayIcon_Main, WINDOW_TITLE);
			}else{
				TrayMessage(hWnd, NIM_DELETE, TRAY_ID, NULL, NULL);
			}
			if(AutoSave == 1){
				PutINI(hWnd, FALSE);
			}
			SwitchCursor(TRUE);
			//EChE̍Ĕzu (nPOP-Q)
			SetWindowSize(hWnd, 0, 0, FALSE);
			break;

		//_CAbvڑ
		case ID_MENUITEM_RAS_CONNECT:
			if(g_soc != -1){
				break;
			}
			SendMessage(hWnd, WM_RAS_START, SelBox, 0);
			break;

		//_CAbvؒf
		case ID_MENUITEM_RAS_DISCONNECT:
			RasDisconnect();
			break;

		//LANڑ
		case ID_MENUITEM_LAN:
			EnableLAN = (EnableLAN == 1) ? 0 : 1;
#ifdef _WIN32_WCE
#ifdef _WIN32_WCE_PPC
			CheckMenuItem(SHGetSubMenu(hMainToolBar, ID_MENUITEM_FILE), ID_MENUITEM_LAN, (EnableLAN == 1) ? MF_CHECKED : MF_UNCHECKED);
#elif defined(_WIN32_WCE_LAGENDA)
			CheckMenuItem(GetSubMenu(hMainMenu, 0), ID_MENUITEM_LAN, (EnableLAN == 1) ? MF_CHECKED : MF_UNCHECKED);
#else
			CheckMenuItem(CommandBar_GetMenu(GetDlgItem(hWnd, IDC_CB), 0), ID_MENUITEM_LAN, (EnableLAN == 1) ? MF_CHECKED : MF_UNCHECKED);
#endif
#else
			CheckMenuItem(GetMenu(hWnd), ID_MENUITEM_LAN, (EnableLAN == 1) ? MF_CHECKED : MF_UNCHECKED);
#endif
			SetMailMenu(hWnd);
			break;

		//o[W
		case ID_MENUITEM_ABOUT:
		//	MessageBox(hWnd,
		//		APP_NAME
		//		TEXT("\n(C) Copyright 1999-2002 By Tomoaki Nakashima. All right reserved.\n\n")
		//		TEXT("HOME PAGE: http://www.nakka.com/\nE-MAIL: nakka@nakka.com"),
		//		TEXT("About"), MB_OK | MB_ICONINFORMATION);
			// (nPOP-Q)
			MessageBox(hWnd,
				APP_NAMEEX
				TEXT("\n(C) Copyright 1999-2005 By Tatsuya Sakamoto. All right reserved.\n\n")
#ifndef _WIN32_WCE
				TEXT("HOME PAGE : http://homepage2.nifty.com/qta/")
				TEXT("\n\n\n")
#endif
				APP_NAME
				TEXT("\n(C) Copyright 1996-2005 By Tomoaki Nakashima. All right reserved.\n\n")
#ifndef _WIN32_WCE
				TEXT("HOME PAGE: http://www.nakka.com/\nE-MAIL: nakka@nakka.com")
#endif
				,TEXT("About"), MB_OK | MB_ICONINFORMATION);
			break;

		//I
		case ID_MENUITE_QUIT:
			if(SaveWindow(hWnd) == FALSE){
				break;
			}
			save_flag = TRUE;
			EndWindow(hWnd);
			break;

#ifdef _WIN32_WCE_LAGENDA
		//
		case CSOBAR_ADORNMENTID_CLOSE:
			SendMessage(hWnd, WM_CLOSE, 0, 0);
			break;
#endif
		//====== AJEg =========
		//AJEg̒ǉ
		case ID_MENUITEM_ADDMAILBOX:
			SelectMailBox(hWnd, CreateMailBox(hWnd, TRUE));
			if(SetMailBoxOption(hWnd) == FALSE){
				SelectMailBox(hWnd, DeleteMailBox(hWnd, SelBox));
				break;
			}
			if(AutoSave == 1){
				SwitchCursor(FALSE);
				PutINI(hWnd, FALSE);
				SwitchCursor(TRUE);
			}
			break;

		//AJEg̐ݒ
		case ID_MENUITEM_SETMAILBOX:
			if(SetMailBoxOption(hWnd) == FALSE){
				break;
			}
			if(AutoSave == 1){
				SwitchCursor(FALSE);
				PutINI(hWnd, FALSE);
				SwitchCursor(TRUE);
			}
			break;

		//AJEg̍폜
		case ID_MENUITEM_DELETEMAILBOX:
			if(SelBox == MAILBOX_SAVE || SelBox == MAILBOX_SEND || SelBox == RecvBox){
				break;
			}
			if(MessageBox(hWnd, STR_Q_DELMAILBOX, STR_TITLE_DELETE, MB_ICONEXCLAMATION | MB_YESNO) == IDNO){
				break;
			}
			if(g_soc != -1 && SelBox < RecvBox){
				RecvBox--;
			}
			SelectMailBox(hWnd, DeleteMailBox(hWnd, SelBox));
			break;

		//AJEgɈړ
		case ID_MENUITEM_MOVEUPMAILBOX:
			MoveUpMailBox(hWnd);
			//c[̕\XV (nPOP-Q)
			if (g_hTreeView) TreeView_ResetMailBox (g_hTreeView, FALSE);
			break;

		//AJEgɈړ
		case ID_MENUITEM_MOVEDOWNMAILBOX:
			MoveDownMailBox(hWnd);
			//c[̕\XV (nPOP-Q)
			if (g_hTreeView) TreeView_ResetMailBox (g_hTreeView, FALSE);
			break;

		//ACRɃ\[g
		case ID_MENUITEM_ICONSORT:
			LvThreadView = 0;
#ifdef _WIN32_WCE
#ifdef _WIN32_WCE_PPC
			CheckMenuItem(SHGetSubMenu(hMainToolBar, ID_MENUITEM_MAIL), ID_MENUITEM_THREADVIEW, MF_UNCHECKED);
#elif defined(_WIN32_WCE_LAGENDA)
			CheckMenuItem(GetSubMenu(hMainMenu, 1), ID_MENUITEM_THREADVIEW, MF_UNCHECKED);
#else
			CheckMenuItem(CommandBar_GetMenu(GetDlgItem(hWnd, IDC_CB), 0), ID_MENUITEM_THREADVIEW, MF_UNCHECKED);
#endif
#else
			CheckMenuItem(GetMenu(hWnd), ID_MENUITEM_THREADVIEW, MF_UNCHECKED);
#endif
			LvSortFlag = (ABS(LvSortFlag) == (SORT_IOCN + 1)) ? (LvSortFlag * -1) : (SORT_IOCN + 1);
			//\[g
			SwitchCursor(FALSE);
			ListView_SortItems(GetDlgItem(hWnd, IDC_LISTVIEW), CompareFunc, LvSortFlag);
			SwitchCursor(TRUE);

			ListView_EnsureVisible(GetDlgItem(hWnd, IDC_LISTVIEW),
				ListView_GetNextItem(GetDlgItem(hWnd, IDC_LISTVIEW), -1, LVNI_FOCUSED), TRUE);

			if(SelBox == MAILBOX_SAVE || LvAutoSort == 2){
				LvSortItem = LvSortFlag;
			}
			break;

		//Xbh\
		case ID_MENUITEM_THREADVIEW:
			SwitchCursor(FALSE);
			if(LvThreadView == 1){
				LvThreadView = 0;
				ListView_SortItems(GetDlgItem(hWnd, IDC_LISTVIEW), CompareFunc, LvSortFlag);
			}else{
				LvThreadView = 1;
				Item_SetThread(MailBox + SelBox);
				ListView_SortItems(GetDlgItem(hWnd, IDC_LISTVIEW), CompareFunc, SORT_THREAD + 1);
			}
			SwitchCursor(TRUE);

#ifdef _WIN32_WCE
#ifdef _WIN32_WCE_PPC
			CheckMenuItem(SHGetSubMenu(hMainToolBar, ID_MENUITEM_MAIL), ID_MENUITEM_THREADVIEW, (LvThreadView == 1) ? MF_CHECKED : MF_UNCHECKED);
#elif defined(_WIN32_WCE_LAGENDA)
			CheckMenuItem(GetSubMenu(hMainMenu, 1), ID_MENUITEM_THREADVIEW, (LvThreadView == 1) ? MF_CHECKED : MF_UNCHECKED);
#else
			CheckMenuItem(CommandBar_GetMenu(GetDlgItem(hWnd, IDC_CB), 0), ID_MENUITEM_THREADVIEW, (LvThreadView == 1) ? MF_CHECKED : MF_UNCHECKED);
#endif
#else
			CheckMenuItem(GetMenu(hWnd), ID_MENUITEM_THREADVIEW, (LvThreadView == 1) ? MF_CHECKED : MF_UNCHECKED);
#endif

			ListView_EnsureVisible(GetDlgItem(hWnd, IDC_LISTVIEW),
				ListView_GetNextItem(GetDlgItem(hWnd, IDC_LISTVIEW), -1, LVNI_FOCUSED), TRUE);
			break;

		//V擾ʒȕ
		case ID_MENUITEM_LISTINIT:
			if(DialogBoxParam(hInst, MAKEINTRESOURCE(IDD_DIALOG_INITMAILBOX),
				hWnd, InitMailBoxProc, (LPARAM)(MailBox + SelBox)) == FALSE){
				break;
			}
			NULLCHECK_FREE((MailBox + SelBox)->LastMessageId);
			(MailBox + SelBox)->LastMessageId = NULL;
			break;

		//`FbN(nPOP-Q)
		case ID_MENUITEM_CHCYCLIC:
			if (SelBox >= MAILBOX_USER) {
				(MailBox + SelBox)->CyclicFlag = 1 - (MailBox + SelBox)->CyclicFlag;
				SetMailMenu(hWnd);
			}
			break;

		//====== M =========
		//V`FbN
		case ID_MENUITEM_RECV:
			if(g_soc != -1){
				break;
			}
			i = SelBox;
			AutoCheckFlag = FALSE;
			//_CAbvJn
			if(RasCon == 1 && SendMessage(hWnd, WM_RAS_START, i, 0) == FALSE){
				break;
			}
			AllCheck = FALSE;
			ExecFlag = FALSE;
			KeyShowHeader = FALSE;
			NewMailCnt = 0;
			Init_NewMailFlag();

			//[MJn
			RecvMailList(hWnd, i, FALSE);
			break;

		//`FbN
		case ID_MENUITEM_ALLCHECK:
			if(g_soc != -1 || ShowError == TRUE){
				break;
			}
			AutoCheckFlag = FALSE;
			AllCheck = TRUE;
			ExecFlag = FALSE;
			KeyShowHeader = FALSE;
			NewMailCnt = 0;
			CheckBox = MAILBOX_USER - 1;
			Init_NewMailFlag();

			gSockFlag = TRUE;
			SetTimer(hWnd, ID_CHECK_TIMER, CHECKTIME, NULL);
			SendMessage(hWnd, WM_TIMER, ID_CHECK_TIMER, 0);
			break;

		//}[N̂s
		case ID_MENUITEM_EXEC:
			if(g_soc != -1){
				break;
			}
			KeyShowHeader = (GetKeyState(VK_SHIFT) < 0) ? TRUE : FALSE;

			if(Item_GetNextDonloadItem((MailBox + SelBox), -1, NULL) == -1 &&
				Item_GetNextDeleteItem((MailBox + SelBox), -1, NULL) == -1 &&
				Item_GetNextSendItem((MailBox + SelBox), -1, NULL) == -1){
				MessageBox(hWnd,
					STR_MSG_NOMARK, STR_TITLE_EXEC, MB_ICONEXCLAMATION | MB_OK);
				break;
			}
			if(Item_GetNextDeleteItem((MailBox + SelBox), -1, NULL) != -1){
				if(MessageBox(hWnd, STR_Q_DELSERVERMAIL,
					STR_TITLE_EXEC, MB_ICONEXCLAMATION | MB_YESNO) == IDNO){
					ShowError = FALSE;
					break;
				}
			}
			i = SelBox;
			AutoCheckFlag = FALSE;
			//_CAbvJn
			if(RasCon == 1 && i >= MAILBOX_USER && SendMessage(hWnd, WM_RAS_START, i, 0) == FALSE){
				break;
			}
			AllCheck = FALSE;
			ExecFlag = TRUE;
			NewMailCnt = -1;
			if(CheckAfterUpdate == 1){
				NewMailCnt = 0;
				Init_NewMailFlag();
			}
			//}[Ns
			ExecItem(hWnd, i);
			break;

		//s
		case ID_MENUITEM_ALLEXEC:
			if(g_soc != -1){
				break;
			}
			KeyShowHeader = (GetKeyState(VK_SHIFT) < 0) ? TRUE : FALSE;

			if(MailMarkCheck(hWnd, TRUE, TRUE) == FALSE){
				break;
			}

			AutoCheckFlag = FALSE;
			AllCheck = TRUE;
			ExecFlag = TRUE;
			CheckBox = MAILBOX_USER - 1;
			NewMailCnt = -1;
			if(CheckAfterUpdate == 1){
				NewMailCnt = 0;
				Init_NewMailFlag();
			}

			gSockFlag = TRUE;
			SetTimer(hWnd, ID_EXEC_TIMER, CHECKTIME, NULL);
			SendMessage(hWnd, WM_TIMER, ID_EXEC_TIMER, 0);
			break;

		//~
		case ID_MENUITEM_STOP:
			KillTimer(hWnd, ID_SMTP_TIMER);
			KillTimer(hWnd, ID_SMTP_ONE_TIMER);
			KillTimer(hWnd, ID_CHECK_TIMER);
			KillTimer(hWnd, ID_EXEC_TIMER);
			KillTimer(hWnd, ID_TIMEOUT_TIMER);
			KillTimer(hWnd, ID_RASWAIT_TIMER);
			gSockFlag = FALSE;
			AllCheck = FALSE;
			AutoCheckFlag = FALSE;
			ExecFlag = FALSE;
			KeyShowHeader = FALSE;
			NewMailCnt = -1;
			if(RasLoop == TRUE || (g_soc == -1 && RasCheckEndDisCon == 1)){
				RasDisconnect();
			}
			if(g_soc == -1 || GetHostFlag == TRUE){
				g_soc = -1;
				RecvBox = -1;
				EndSocketFunc(hWnd);
				break;
			}
			if(MailFlag == POP_QUIT || MailFlag == POP_START){
				SocketClose(hWnd, g_soc);
				g_soc = -1;
				RecvBox = -1;
				SetItemCntStatusText(hWnd, NULL);
				EndSocketFunc(hWnd);
				break;
			}
			MailFlag = POP_QUIT;
			SetStatusText(hWnd, RSET);
			SendBuf(g_soc, RSET);
			SetStatusText(hWnd, QUIT);
			SendBuf(g_soc, QUIT);
			break;

		//====== [ =========
		case ID_KEY_BACK:
			{	// (nPOP-Q)
				HWND hWndFocus = GetFocus();
				if(hWndFocus == g_hEditView){
					EditView_PrevMail (hWnd);
					break;
				}
			}
			break;
		//J
		case ID_KEY_ENTER:
			{	// (nPOP-Q)
				HWND hWndFocus = GetFocus();
				if(hWndFocus == GetDlgItem(hWnd, IDC_COMBO)){
					SendDlgItemMessage(hWnd, IDC_COMBO, CB_SHOWDROPDOWN,
						!SendDlgItemMessage(hWnd, IDC_COMBO, CB_GETDROPPEDSTATE, 0, 0), 0);
					break;
				}
				if(hWndFocus == g_hEditView){
					EditView_NextMail (hWnd);
					break;
				}
			}
		case ID_MAILITEM_OPEN:
			OpenItem(hWnd, FALSE, FALSE);
			break;

		case ID_MENUITEM_OPEN:
			OpenItem(hWnd, TRUE, FALSE);
			break;

		//ԐM
		case ID_MENUITEM_REMESSEGE:
			ReMessageItem(hWnd);
			break;

		//Mp}[N̐؂ւ
		case ID_KEY_CTRLENTER:
			if(SelBox == MAILBOX_SAVE){
				break;
			}
			SetDownloadMark(hWnd, TRUE);
			break;

		//MpɃ}[N
		case ID_MENUITEM_DOWNMARK:
			if(SelBox == MAILBOX_SAVE){
				break;
			}
			SetDownloadMark(hWnd, FALSE);
			break;

		//폜pɃ}[N
		case ID_MENUITEM_DELMARK:
			if(SelBox == MAILBOX_SAVE || SelBox == MAILBOX_SEND){
				break;
			}
			SetDeleteMark(hWnd);
			break;

		//}[N
		case ID_MENUITEM_UNMARK:
			UnMark(hWnd);
			break;

		//Jς݂ɂ
		case ID_MENUITEM_READMAIL:
			if(SelBox == MAILBOX_SEND){
				break;
			}
			SetMailStats(hWnd, ICON_READ);
			break;

		//Jɂ
		case ID_MENUITEM_NOREADMAIL:
			if(SelBox == MAILBOX_SEND){
				break;
			}
			SetMailStats(hWnd, ICON_MAIL);
			break;

		//ۑփRs[
		case ID_MENUITE_SAVECOPY:
			// vr[CTRL+CȂNbv (nPOP-Q)
			{
				HWND hFocusWnd = GetFocus ();
				if (hFocusWnd == g_hEditView) {
					PostMessage (g_hEditView, WM_COPY, 0, 0);
				}
				if (hFocusWnd != g_hListView) {
					break;
				}
			}
			ItemToSaveBox(hWnd);
			if(AutoSave == 1){
				//ۑ̕ۑ
				SaveMail(SAVEBOX_FILE, MailBox + MAILBOX_SAVE, 2);
			}
			break;

		//ꗗ폜
		case ID_MENUITEM_DELETE:
			ListDeleteItem(hWnd);
			break;

		//ׂđI
		case ID_MENUITEM_ALLSELECT:
			// vr[CTRL+A (nPOP-Q)
			{
				HWND hFocusWnd = GetFocus ();
				if (hFocusWnd == g_hEditView) {
					SendMessage (g_hEditView, EM_SETSEL, 0, (LPARAM)-1);
				}
				if (hFocusWnd != g_hListView) {
					break;
				}
			}
			SetFocus(GetDlgItem(hWnd, IDC_LISTVIEW));
			ListView_SetItemState(GetDlgItem(hWnd, IDC_LISTVIEW), -1, LVIS_SELECTED, LVIS_SELECTED);
			break;

		//AJEg̐؂ւ
		case ID_MENUITEM_CHANGEMAILBOX:
			SetFocus(GetDlgItem(hWnd, IDC_COMBO));
			SendDlgItemMessage(hWnd, IDC_COMBO, CB_SHOWDROPDOWN, TRUE, 0);
			break;

#ifdef _WIN32_WCE_PPC
		//I[h
		case ID_MENUITEM_SELMODE:
			SelMode = !SelMode;
			CheckMenuItem(SHGetSubMenu(hMainToolBar, ID_MENUITEM_MAIL), ID_MENUITEM_SELMODE, (SelMode == TRUE) ? MF_CHECKED : MF_UNCHECKED);
			break;
#elif defined(_WIN32_WCE_LAGENDA)
		//I[h
		case ID_MENUITEM_SELMODE:
			SelMode = !SelMode;
			CheckMenuItem(GetSubMenu(hMainMenu, 1), ID_MENUITEM_SELMODE, (SelMode == TRUE) ? MF_CHECKED : MF_UNCHECKED);
			break;
#endif

		//ꗗʂ̕\
		case ID_MENUITEM_RESTORE:
#ifdef _WIN32_WCE
			CloseViewWindow(1);
			FocusWnd = hWnd;
			ShowWindow(hWnd, SW_SHOW);
#else
			if(ShowPass == 1 &&
				(IsWindowVisible(hWnd) == 0 || IsIconic(hWnd) != 0) &&
				Password != NULL && *Password != TEXT('\0') &&
				ConfirmPass(hWnd, Password) == FALSE){
				break;
			}
			ShowWindow(hWnd, SW_SHOW);
			if(IsIconic(hWnd) != 0){
				ShowWindow(hWnd, SW_RESTORE);
			}
#endif
			_SetForegroundWindow(hWnd);
			break;

		//EBhE̕\
		case ID_MENUITEM_SHOWLASTWINDOW:
			SendMessage(hWnd, WM_SHOWLASTWINDOW, 0, 0);
			break;

		// (nPOP-Q)
		case ID_MENUITEM_FINDITEM:
			FindItem_Dialog (hWnd);
			break;
		
		//
		case ID_MENUITEM_FIND:
			if(hViewWnd == NULL){
				FindItem_Dialog (hWnd);
				break;
			}
			if(SelBox == MAILBOX_SEND){
				break;
			}
			OpenItem(hWnd, TRUE, TRUE);
			if(hViewWnd != NULL){
				View_FindMail(hViewWnd, TRUE);
			}
			break;

		//
		case ID_MENUITEM_NEXTFIND:
			if(SelBox == MAILBOX_SEND){
				break;
			}
			OpenItem(hWnd, TRUE, TRUE);
			if(hViewWnd != NULL){
				View_FindMail(hViewWnd, FALSE);
			}
			break;
		}
		break;

	//_CAbv̊Jn
	case WM_RAS_START:
		return RasMailBoxStart(hWnd, wParam);

#ifndef _WIN32_WCE
	case WM_SYSCOMMAND:
		if(ShowPass == 1 &&
			(wParam == SC_RESTORE || wParam == SC_MAXIMIZE) &&
			(IsWindowVisible(hWnd) == 0 || IsIconic(hWnd) != 0) &&
			Password != NULL && *Password != TEXT('\0') &&
			ConfirmPass(hWnd, Password) == FALSE){
			return 0;
		}
		return DefWindowProc(hWnd, msg, wParam, lParam);
#endif

	//^XNgCbZ[W
	case WM_TRAY_NOTIFY:
#ifdef _WIN32_WCE_LAGENDA
		EnableMenuItem(GetSubMenu(hPOPUP, 0), ID_MENUITEM_ALLCHECK, !(g_soc == -1));
		EnableMenuItem(GetSubMenu(hPOPUP, 0), ID_MENUITEM_STOP, (g_soc == -1));
		SendMessage(hWnd, WM_NULL, 0, 0);
		ShowMenu(hWnd, hPOPUP, 0, 2, FALSE);
#else
		switch (lParam)
		{
#ifdef _WIN32_WCE
		case WM_LBUTTONUP:
			EnableMenuItem(GetSubMenu(hPOPUP, 0), ID_MENUITEM_ALLCHECK, !(g_soc == -1));
			EnableMenuItem(GetSubMenu(hPOPUP, 0), ID_MENUITEM_STOP, (g_soc == -1));
			SendMessage(hWnd, WM_NULL, 0, 0);
			ShowMenu(hWnd, hPOPUP, 0, 2, FALSE);
			break;
#else
		case WM_LBUTTONDOWN:
			if(TrayIconToggle == 1 && IsIconic(hWnd) == 0 && IsWindowVisible(hWnd) != 0){
				ShowWindow(hWnd, SW_MINIMIZE);
			}else{
				SendMessage(hWnd, WM_COMMAND, ID_MENUITEM_RESTORE, 0);
			}
			break;

		case WM_RBUTTONUP:
			SetMenuDefaultItem(GetSubMenu(hPOPUP, 0), ID_MENUITEM_RESTORE, 0);
			EnableMenuItem(GetSubMenu(hPOPUP, 0), ID_MENUITEM_ALLCHECK, !(g_soc == -1));
			EnableMenuItem(GetSubMenu(hPOPUP, 0), ID_MENUITEM_STOP, (g_soc == -1));
			SendMessage(hWnd, WM_NULL, 0, 0);
			ShowMenu(hWnd, hPOPUP, 0, 0, FALSE);
			break;
#endif
		}
#endif
		break;

#ifdef WSAASYNC
	case WM_SOCK_SELECT:
		if(g_soc != -1 && WSAGETSELECTERROR(lParam) != 0){
			ErrorSocketEnd(hWnd, RecvBox);
			switch(WSAGETSELECTEVENT(lParam))
			{
			case FD_CONNECT:
				SocketErrorMessage(hWnd, STR_ERR_SOCK_CONNECT, RecvBox);
				break;

			case FD_READ:
			case FD_WRITE:
				SocketErrorMessage(hWnd, STR_ERR_SOCK_SENDRECV, RecvBox);
				break;

			default:
				SocketErrorMessage(hWnd, STR_ERR_SOCK_DISCONNECT, RecvBox);
				break;
			}
			break;
		}
		/* ׂ\Pbg */
		if(g_soc != (int)wParam){
			break;
		}
		/* \PbgCxg̏s */
		switch(WSAGETSELECTEVENT(lParam))
		{
		case FD_CONNECT:					/* T[oւ̐ڑCxg */
			break;

		case FD_READ:						/* Mobt@Ƀf[^鎖Cxg */
			/* f[^MĒ~ς */
			if(RecvBufProc(hWnd, g_soc) == SELECT_MEM_ERROR){
				//G[
				ErrorSocketEnd(hWnd, RecvBox);
				SocketErrorMessage(hWnd, STR_ERR_MEMALLOC, RecvBox);
				break;
			}
			SetTimer(hWnd, ID_TIMEOUT_TIMER, TIMEOUTTIME * TimeoutInterval, NULL);
			break;

		case FD_WRITE:						/* M\ȎCxg */
			{
				TCHAR ErrStr[BUF_SIZE];

				*ErrStr = TEXT('\0');
				if(SendProc(hWnd, g_soc, ErrStr, (MailBox + RecvBox)) == FALSE){
					ErrorSocketEnd(hWnd, RecvBox);
					SocketErrorMessage(hWnd, ErrStr, RecvBox);
					break;
				}
				SetTimer(hWnd, ID_TIMEOUT_TIMER, TIMEOUTTIME * TimeoutInterval, NULL);
			}
			break;

		case FD_CLOSE:						/* T[oւ̐ڑICxg */
			/* ڑI */
			if(MailFlag != POP_QUIT){
				ErrorSocketEnd(hWnd, RecvBox);
				SocketErrorMessage(hWnd, STR_ERR_SOCK_DISCONNECT, RecvBox);
			}else{
				SocketClose(hWnd, g_soc);
				KillTimer(hWnd, ID_TIMEOUT_TIMER);
				g_soc = -1;
				SetItemCntStatusText(hWnd, NULL);
				if(AllCheck == FALSE){
					if(CheckEndExec == 1 &&
						CheckEndAutoExec(hWnd, RecvBox, NewMailCnt, FALSE) == TRUE){
						//`FbNs
						break;
					}
					if(ExecFlag == TRUE && CheckAfterUpdate == 1 && RecvBox != MAILBOX_SEND){
						//s`FbN
						ExecFlag = FALSE;
						RecvMailList(hWnd, RecvBox, FALSE);
						break;
					}
					if (g_hTreeView) TreeView_SetIconType (g_hTreeView, RecvBox);
					RecvBox = -1;
					EndSocketFunc(hWnd);
					NewMail_Massage(hWnd, NewMailCnt);
				}else{
					if (g_hTreeView) TreeView_SetIconType (g_hTreeView, RecvBox);
					RecvBox = -1;
					SetMailMenu(hWnd);
				}
			}
			break;
		}
		break;
#endif

	//\Pbg̎MbZ[W
	case WM_SOCK_RECV:
		{
			TCHAR ErrStr[BUF_SIZE];

			*ErrStr = TEXT('\0');
			if(RecvProc(hWnd, g_soc, (char *)lParam, wParam, ErrStr,
				(MailBox + RecvBox), RecvBox == SelBox) == FALSE){
				ErrorSocketEnd(hWnd, RecvBox);
				if(*ErrStr != TEXT('\0')){
					SocketErrorMessage(hWnd, ErrStr, RecvBox);
				}else{
					RecvBox = -1;
					SetMailMenu(hWnd);
				}
				return FALSE;
			}
		}
		return TRUE;

	//[M
	case WM_SMTP_SENDMAIL:
		if(g_soc != -1 || lParam == 0){
			break;
		}
		wkSendMailItem = (struct TPMAILITEM *)lParam;
		NewMailCnt = -1;
		SmtpWait = 0;
		CheckBox = GetNameToMailBox(wkSendMailItem->MailBox);
		if(CheckBox != -1 && (MailBox + CheckBox)->PopBeforeSmtp != 0){
			//POP before SMTP
			AutoCheckFlag = FALSE;
			if(RasCon == 1 && SendMessage(hWnd, WM_RAS_START, CheckBox, 0) == FALSE){
				ErrorSocketEnd(hWnd, CheckBox);
				SetMailMenu(hWnd);
				break;
			}
			AllCheck = TRUE;
			gSockFlag = TRUE;
			if(PopBeforeSmtpIsLoginOnly == 0) NewMailCnt = 0;
			RecvMailList(hWnd, CheckBox, (PopBeforeSmtpIsLoginOnly == 1) ? TRUE : FALSE);
			SmtpWait = PopBeforeSmtpWait / SMTPTIME;
		}
		SetTimer(hWnd, ID_SMTP_ONE_TIMER, SMTPTIME, NULL);
		break;

	//Xgr[̃Cxg
	case WM_LV_EVENT:
		switch(wParam)
		{
		case LVN_ITEMCHANGED:
			SetMailMenu(hWnd);
			// Tv\  (nPOP-Q)
			SetTimer(hWnd, TIMER_VIEW, 100, NULL);
			break;

#ifdef _WIN32_WCE_LAGENDA
		case LVN_BEGINLABELEDIT:
			if(SelMode == TRUE){
				break;
			}
			SendMessage(hWnd, WM_COMMAND, ID_MAILITEM_OPEN, 0);
			return TRUE;
#endif	//_WIN32_WCE_LAGENDA

#ifdef _WIN32_WCE_PPC
		case LVN_BEGINDRAG:
			SetCapture(GetDlgItem(hWnd, IDC_LISTVIEW));
			break;

		case LVN_ITEMACTIVATE:
			SendMessage(hWnd, WM_COMMAND, ID_MAILITEM_OPEN, 0);
			break;

		// (nPOP-Q)
		case NM_DBLCLK:
			SendMessage(hWnd, WM_COMMAND, ID_MAILITEM_OPEN, 0);
			break;

#else	//_WIN32_WCE_PPC
		case NM_CLICK:
#ifdef _WIN32_WCE
			if(GetKeyState(VK_MENU) < 0){
				SendMessage(hWnd, WM_COMMAND, ID_MENU, 0);
				break;
			}
#endif	//_WIN32_WCE
			break;

		case NM_DBLCLK:
#ifdef _WIN32_WCE_LAGENDA
			if(SelMode == TRUE){
				break;
			}
#endif	//_WIN32_WCE_LAGENDA
			SendMessage(hWnd, WM_COMMAND, ID_MAILITEM_OPEN, 0);
			break;

		case NM_RCLICK:
			SendMessage(hWnd, WM_COMMAND, ID_MENU, 0);
			break;
#endif	//_WIN32_WCE_PPC
		}
		break;

	//Xe[^Xo[ɕ\
	case WM_STATUSTEXT:
		SetStatusTextT(hWnd, (TCHAR *)lParam, 1);
		break;

	//EBhE̕\
	case WM_SHOWLASTWINDOW:
#ifdef _WIN32_WCE
		if(IsWindow(FocusWnd) == 0){
			FocusWnd = hWnd;
		}
		ShowWindow(FocusWnd, SW_SHOW);
		_SetForegroundWindow(FocusWnd);
#else
		SendMessage(hWnd, WM_COMMAND, ID_MENUITEM_RESTORE, 0);
#endif
		if(StartCheck == 1){
			SendMessage(hWnd, WM_COMMAND, ID_MENUITEM_ALLCHECK, 0);
		}
		break;

	default:
		if(msg == WM_RASEVENT){
			return RasStatusProc(hWnd, msg, wParam, lParam);
		}
		return DefWindowProc(hWnd, msg, wParam, lParam);
	}
	return 0;
}


/******************************************************************************

	InitApplication

	EBhENX̓o^

******************************************************************************/

static BOOL InitApplication(HINSTANCE hInstance)
{
	WNDCLASS wc;

#ifdef _WIN32_WCE
	wc.style = CS_HREDRAW | CS_VREDRAW;
	wc.hCursor = NULL;
	wc.lpszMenuName = NULL;
#else
	wc.style = 0;
	wc.hCursor = LoadCursor(hInstance, MAKEINTRESOURCE(IDC_CURSOR_CNT));
//	wc.hCursor = LoadCursor(NULL, IDC_ARROW);
	wc.lpszMenuName = MAKEINTRESOURCE(IDR_MENU_WINDOW);
#endif
	wc.lpfnWndProc = (WNDPROC)WndProc;
	wc.cbClsExtra = 0;
	wc.cbWndExtra = 0;
	wc.hInstance = hInstance;
	wc.hIcon = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_ICON_MAIN));
	wc.hbrBackground = (HBRUSH)COLOR_BTNSHADOW;
	wc.lpszClassName = MAIN_WND_CLASS;

	return RegisterClass(&wc);
}


/******************************************************************************

	InitInstance

	EBhE̍쐬

******************************************************************************/

static HWND InitInstance(HINSTANCE hInstance, int CmdShow)
{
	HWND hwndMain =  NULL;
#ifdef _WIN32_WCE_PPC
	SIPINFO si;
	int x = CW_USEDEFAULT, y = CW_USEDEFAULT, cx, cy;
#endif

	hInst = hInstance;

#ifdef _WIN32_WCE
#ifdef _WIN32_WCE_PPC
	memset(&si, 0, sizeof(si));
	si.cbSize = sizeof(si);
	SHSipInfo(SPI_GETSIPINFO, 0, &si, 0);
	cx = si.rcVisibleDesktop.right - si.rcVisibleDesktop.left;
	cy = si.rcVisibleDesktop.bottom - si.rcVisibleDesktop.top - ((si.fdwFlags & SIPF_ON) ? 0 : MENU_HEIGHT);

	hwndMain = CreateWindow(MAIN_WND_CLASS,
		WINDOW_TITLE,
		WS_VISIBLE,
		x, y, cx, cy,
		NULL, NULL, hInstance, NULL);
#else
	{
	DWORD dwStyle = WS_VISIBLE;
#ifdef _CENET
	dwStyle = WS_SYSMENU | WS_BORDER | WS_CAPTION | WS_MAXIMIZEBOX | WS_MINIMIZEBOX;
#endif
	hwndMain = CreateWindow(MAIN_WND_CLASS,
		WINDOW_TITLE,
		dwStyle,
		0, 0,
		CW_USEDEFAULT,
		CW_USEDEFAULT,
		NULL, NULL, hInstance, NULL);
	}
#endif
#else
	hwndMain = CreateWindow(MAIN_WND_CLASS,
		WINDOW_TITLE,
		WS_OVERLAPPEDWINDOW,
		0, 0,
		240,
		320,
		NULL, NULL, hInstance, NULL);
#endif

	if(!hwndMain){
		return NULL;
	}

	if(ShowTrayIcon == 1 && StartHide == 1){
		return hwndMain;
	}
#ifndef _WIN32_WCE
	if((CmdShow == SW_MINIMIZE || CmdShow == SW_SHOWMINIMIZED) && ShowTrayIcon == 1 && MinsizeHide == 1){
		return hwndMain;
	}
#endif

	ShowWindow(hwndMain, CmdShow);
	UpdateWindow(hwndMain);
	return hwndMain;
}


/******************************************************************************

	MessageFunc

	bZ[W

******************************************************************************/

BOOL MessageFunc(HWND hWnd, MSG *msg)
{
	HWND fWnd;

	fWnd = GetForegroundWindow();
	if(fWnd == NULL){

	//CEBhẼANZ[^
	}else if(fWnd == hWnd &&
		TranslateAccelerator(fWnd, hAccel, msg) == TRUE){
		return TRUE;

	//[\EBhẼANZ[^
	}else if(fWnd == hViewWnd &&
		TranslateAccelerator(fWnd, hViewAccel, msg) == TRUE){
		return TRUE;

	//[ʒmEBhE
	}else if(fWnd == MsgWnd &&
		IsDialogMessage(fWnd, msg) != 0){
		return TRUE;

	//EBhẼANZ[^ (nPOP-Q)
	}else if(fWnd == hFindItem &&
		TranslateAccelerator(fWnd, hFindAccel, msg) == TRUE){
		return TRUE;

	//[ҏWEBhẼANZ[^
	}else if(TranslateAccelerator(fWnd, hEditAccel, msg) == TRUE){
		return TRUE;
	}

	TranslateMessage(msg);
	DispatchMessage(msg);
	return TRUE;
}


/******************************************************************************

	WinMain

	C

******************************************************************************/

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
				   LPTSTR lpCmdLine, int CmdShow)
{
	MSG msg;
	HWND hWnd;
	WSADATA WsaData;
	HANDLE hMutex = NULL;
	INITCOMMONCONTROLSEX icex;	// (nPOP-Q)

	hInst = hInstance;

	//ʂ̂Qd̋N(nPOP-Q)
	if(lpCmdLine != NULL && *lpCmdLine != TEXT('\0')){
		if (tstricmp(lpCmdLine, TEXT("-W")) == 0 || tstricmp(lpCmdLine, TEXT("/W")) == 0) {
#ifdef _WIN32_WCE
			int no = _wtoi (&lpCmdLine[2]);
#else
			int no = atoi (&lpCmdLine[2]); 
#endif
			*lpCmdLine = 0;
			wsprintf (MAIN_WND_CLASS, TEXT("nPopQDoubleWnd%d"), no);
		}
	}

#ifndef _DEBUG
#ifdef _WCE_OLD
	//QdNNh~
	if((hWnd = FindWindow(MAIN_WND_CLASS, NULL)) != NULL){
		if(lpCmdLine != NULL && *lpCmdLine != TEXT('\0')){
			COPYDATASTRUCT cpdata;

			cpdata.lpData = lpCmdLine;
			cpdata.cbData = sizeof(TCHAR) * (lstrlen(lpCmdLine) + 1);
			SendMessage(hWnd, WM_COPYDATA, (WPARAM)NULL, (LPARAM)&cpdata);
		}else{
			SendMessage(hWnd, WM_SHOWLASTWINDOW, 0, 0);
		}
		return 0;
	}
#else	//_WCE_OLD
	//QdNNh~
	hMutex = CreateMutex(NULL, TRUE, STR_MUTEX);
	if(GetLastError() == ERROR_ALREADY_EXISTS){
		hWnd = FindWindow(MAIN_WND_CLASS, NULL);
		if(hWnd != NULL){
			if(lpCmdLine != NULL && *lpCmdLine != TEXT('\0')){
				COPYDATASTRUCT cpdata;

				cpdata.lpData = lpCmdLine;
				cpdata.cbData = sizeof(TCHAR) * (lstrlen(lpCmdLine) + 1);
				SendMessage(hWnd, WM_COPYDATA, (WPARAM)NULL, (LPARAM)&cpdata);
			}else{
				SendMessage(hWnd, WM_SHOWLASTWINDOW, 0, 0);
			}
		}
		if(hMutex != NULL){
			CloseHandle(hMutex);
		}
		// (nPOP-Q)
		if(hWnd != NULL) return 0;
	}
#endif	//_WCE_OLD
#endif	//_DEBUG

	//AvP[V̍ƃpX̎擾
	if(GetAppPath(hInstance) == FALSE){
		if(hMutex != NULL){
			CloseHandle(hMutex);
		}
		ErrorMessage(NULL, STR_ERR_MEMALLOC);
		return 0;
	}

#ifndef _WIN32_WCE
	{
		int TmpCmdShow;
		//NpX[h̃`FbN
		TmpCmdShow = CmdShow;
		if(CheckStartPass() == FALSE){
			NULLCHECK_FREE(AppDir);
			NULLCHECK_FREE(g_Pass);
			if(hMutex != NULL){
				CloseHandle(hMutex);
			}
			return 0;
		}
		NULLCHECK_FREE(g_Pass);
		g_Pass = NULL;
		CmdShow = TmpCmdShow;
	}
#endif

	//
	if(WSAStartup(0x101, &WsaData) != 0){
		NULLCHECK_FREE(AppDir);
		if(hMutex != NULL){
			CloseHandle(hMutex);
		}
		ErrorMessage(NULL, STR_ERR_INIT);
		return 0;
	}
	memset (&icex, 0, sizeof(icex));
	icex.dwSize = sizeof (INITCOMMONCONTROLSEX);
	icex.dwICC = ICC_COOL_CLASSES;
	// CommonControl̏s
	InitCommonControlsEx (&icex);
	//InitCommonControls();
	initRas();

#ifdef _WIN32_WCE_LAGENDA
	SipShowIM(SIPF_OFF);
#endif

	//EBhENXo^
	if(!InitApplication(hInstance) || !View_InitApplication(hInstance)
		|| !Edit_InitApplication(hInstance)){
		NULLCHECK_FREE(AppDir);
		WSACleanup();
		FreeRas();
		if(hMutex != NULL){
			CloseHandle(hMutex);
		}
		ErrorMessage(NULL, STR_ERR_INIT);
		return 0;
	}

	if(lpCmdLine != NULL && *lpCmdLine != TEXT('\0')){
		CmdLine = AllocCopy(lpCmdLine);
	}

#ifndef _WCE_OLD
	CreateDialogParam(hInst, MAKEINTRESOURCE(IDD_DIALOG_MSG), NULL, NewMailMessageProc, 0);
#endif

	//CEBhE̍쐬
	if((hWnd = InitInstance(hInstance, CmdShow)) == NULL){
		FreeAllMailBox();
		NULLCHECK_FREE(CmdLine);
		NULLCHECK_FREE(AppDir);
		WSACleanup();
		FreeRas();
		if(hMutex != NULL){
			CloseHandle(hMutex);
		}
		ErrorMessage(NULL, STR_ERR_INIT);
		return 0;
	}

	//\[X|bvAbvj[[h
	hPOPUP = LoadMenu(hInstance, MAKEINTRESOURCE(IDR_MENU_POPUP));

	//\[XANZ[^[h
	hAccel = LoadAccelerators(hInstance, MAKEINTRESOURCE(IDR_ACCELERATOR));
	hViewAccel = LoadAccelerators(hInstance, MAKEINTRESOURCE(IDR_ACCELERATOR_VIEW));
	hEditAccel = LoadAccelerators(hInstance, MAKEINTRESOURCE(IDR_ACCELERATOR_EDIT));
	hFindAccel = LoadAccelerators(hInstance, MAKEINTRESOURCE(IDR_ACCELERATOR_FIND));

	//bZ[W[v
	while(GetMessage(&msg, NULL, 0, 0) == TRUE){
		MessageFunc(hWnd, &msg);
	}

	NULLCHECK_FREE(AppDir);
	DestroyMenu(hPOPUP);
	UnregisterClass(MAIN_WND_CLASS, hInstance);
	UnregisterClass(VIEW_WND_CLASS, hInstance);
	UnregisterClass(EDIT_WND_CLASS, hInstance);
	WSACleanup();
	FreeRas();
	if(hMutex != NULL){
		CloseHandle(hMutex);
	}
	return 0;
}

#ifndef _WIN32_WCE
#ifndef UNICODE
#ifndef _DEBUG
void __cdecl WinMainCRTStartup(void)
{
    STARTUPINFO stinfo;
	char *cmdline;
	int ret;

	//R}hC̍쐬
	cmdline = GetCommandLine();
    if(*cmdline == '"'){
		for(cmdline++; *cmdline != '\0' && *cmdline != '"'; cmdline++);
		if(*cmdline != '\0') cmdline++;
	}else{
		for(; *cmdline != '\0' && *cmdline != ' '; cmdline++);
	}
	for(; *cmdline == ' '; cmdline++);

	//N̏̎擾
	stinfo.cb = sizeof(STARTUPINFO);
	stinfo.dwFlags = STARTF_USESHOWWINDOW;
	GetStartupInfo(&stinfo);

	//WinMaiňĂяo
	ret = WinMain(GetModuleHandle(NULL), NULL, cmdline, stinfo.wShowWindow);
	//vZX̏I
	ExitProcess(ret);
}
#endif
#endif
#endif
/* End of source */
